// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'package:chopper/chopper.dart' as chopper;
import 'shopping_list_remote_data_source.enums.swagger.dart' as enums;
export 'shopping_list_remote_data_source.enums.swagger.dart';

part 'shopping_list_remote_data_source.swagger.chopper.dart';
part 'shopping_list_remote_data_source.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class ShoppingListRemoteDataSource extends ChopperService {
  static ShoppingListRemoteDataSource create(
      {ChopperClient? client,
      Authenticator? authenticator,
      String? baseUrl,
      Iterable<dynamic>? interceptors}) {
    if (client != null) {
      return _$ShoppingListRemoteDataSource(client);
    }

    final newClient = ChopperClient(
        services: [_$ShoppingListRemoteDataSource()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$ShoppingListRemoteDataSource(newClient);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  Future<chopper.Response<ShoppingListResponse>> shoppinglistV2ShoppinglistGet(
      {String? orderBy, String? orderByParam, String? cacheControl}) {
    generatedMapping.putIfAbsent(
        ShoppingListResponse, () => ShoppingListResponse.fromJsonFactory);

    return _shoppinglistV2ShoppinglistGet(
        orderBy: orderBy,
        orderByParam: orderByParam,
        cacheControl: cacheControl);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  @Get(path: '/shoppinglist/v2/shoppinglist')
  Future<chopper.Response<ShoppingListResponse>> _shoppinglistV2ShoppinglistGet(
      {@Query('orderBy') String? orderBy,
      @Query('orderByParam') String? orderByParam,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param orderBy
  ///@param orderByParam
  Future<chopper.Response<ShoppingListResponse>> shoppinglistV2ShoppinglistPost(
      {String? orderBy,
      String? orderByParam,
      String? cacheControl,
      required ShoppingListUpdateCommand? body}) {
    generatedMapping.putIfAbsent(
        ShoppingListResponse, () => ShoppingListResponse.fromJsonFactory);

    return _shoppinglistV2ShoppinglistPost(
        orderBy: orderBy,
        orderByParam: orderByParam,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  @Post(path: '/shoppinglist/v2/shoppinglist')
  Future<chopper.Response<ShoppingListResponse>>
      _shoppinglistV2ShoppinglistPost(
          {@Query('orderBy') String? orderBy,
          @Query('orderByParam') String? orderByParam,
          @Header('Cache-Control') String? cacheControl,
          @Body() required ShoppingListUpdateCommand? body});

  ///
  ///@param orderBy
  ///@param orderByParam
  Future<chopper.Response<ShoppingListResponse>> shoppinglistV3ShoppinglistGet(
      {String? orderBy, String? orderByParam, String? cacheControl}) {
    generatedMapping.putIfAbsent(
        ShoppingListResponse, () => ShoppingListResponse.fromJsonFactory);

    return _shoppinglistV3ShoppinglistGet(
        orderBy: orderBy,
        orderByParam: orderByParam,
        cacheControl: cacheControl);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  @Get(path: '/shoppinglist/v3/shoppinglist')
  Future<chopper.Response<ShoppingListResponse>> _shoppinglistV3ShoppinglistGet(
      {@Query('orderBy') String? orderBy,
      @Query('orderByParam') String? orderByParam,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param orderBy
  ///@param orderByParam
  Future<chopper.Response<ShoppingListResponse>> shoppinglistV3ShoppinglistPost(
      {String? orderBy,
      String? orderByParam,
      String? cacheControl,
      required ShoppingListUpdateCommand? body}) {
    generatedMapping.putIfAbsent(
        ShoppingListResponse, () => ShoppingListResponse.fromJsonFactory);

    return _shoppinglistV3ShoppinglistPost(
        orderBy: orderBy,
        orderByParam: orderByParam,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  @Post(path: '/shoppinglist/v3/shoppinglist')
  Future<chopper.Response<ShoppingListResponse>>
      _shoppinglistV3ShoppinglistPost(
          {@Query('orderBy') String? orderBy,
          @Query('orderByParam') String? orderByParam,
          @Header('Cache-Control') String? cacheControl,
          @Body() required ShoppingListUpdateCommand? body});

  ///
  ///@param orderBy
  ///@param orderByParam
  Future<chopper.Response<ShoppingListResponse>> shoppinglistV1ShoppinglistGet(
      {String? orderBy, String? orderByParam, String? cacheControl}) {
    generatedMapping.putIfAbsent(
        ShoppingListResponse, () => ShoppingListResponse.fromJsonFactory);

    return _shoppinglistV1ShoppinglistGet(
        orderBy: orderBy,
        orderByParam: orderByParam,
        cacheControl: cacheControl);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  @Get(path: '/shoppinglist/v1/shoppinglist')
  Future<chopper.Response<ShoppingListResponse>> _shoppinglistV1ShoppinglistGet(
      {@Query('orderBy') String? orderBy,
      @Query('orderByParam') String? orderByParam,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param orderBy
  ///@param orderByParam
  Future<chopper.Response<ShoppingListResponse>> shoppinglistV1ShoppinglistPost(
      {String? orderBy,
      String? orderByParam,
      String? cacheControl,
      required ShoppingListUpdateCommand? body}) {
    generatedMapping.putIfAbsent(
        ShoppingListResponse, () => ShoppingListResponse.fromJsonFactory);

    return _shoppinglistV1ShoppinglistPost(
        orderBy: orderBy,
        orderByParam: orderByParam,
        cacheControl: cacheControl,
        body: body);
  }

  ///
  ///@param orderBy
  ///@param orderByParam
  @Post(path: '/shoppinglist/v1/shoppinglist')
  Future<chopper.Response<ShoppingListResponse>>
      _shoppinglistV1ShoppinglistPost(
          {@Query('orderBy') String? orderBy,
          @Query('orderByParam') String? orderByParam,
          @Header('Cache-Control') String? cacheControl,
          @Body() required ShoppingListUpdateCommand? body});
}

@JsonSerializable(explicitToJson: true)
class ListItemSorting {
  ListItemSorting({
    this.position,
    this.categoryId,
    this.categoryLabel,
  });

  factory ListItemSorting.fromJson(Map<String, dynamic> json) =>
      _$ListItemSortingFromJson(json);

  @JsonKey(name: 'position', includeIfNull: false)
  final int? position;
  @JsonKey(name: 'categoryId', includeIfNull: false, defaultValue: '')
  final String? categoryId;
  @JsonKey(name: 'categoryLabel', includeIfNull: false, defaultValue: '')
  final String? categoryLabel;
  static const fromJsonFactory = _$ListItemSortingFromJson;
  static const toJsonFactory = _$ListItemSortingToJson;
  Map<String, dynamic> toJson() => _$ListItemSortingToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ListItemSorting &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.categoryId, categoryId) ||
                const DeepCollectionEquality()
                    .equals(other.categoryId, categoryId)) &&
            (identical(other.categoryLabel, categoryLabel) ||
                const DeepCollectionEquality()
                    .equals(other.categoryLabel, categoryLabel)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(categoryId) ^
      const DeepCollectionEquality().hash(categoryLabel) ^
      runtimeType.hashCode;
}

extension $ListItemSortingExtension on ListItemSorting {
  ListItemSorting copyWith(
      {int? position, String? categoryId, String? categoryLabel}) {
    return ListItemSorting(
        position: position ?? this.position,
        categoryId: categoryId ?? this.categoryId,
        categoryLabel: categoryLabel ?? this.categoryLabel);
  }
}

@JsonSerializable(explicitToJson: true)
class ShoppingListItem {
  ShoppingListItem({
    required this.position,
    required this.sourceCode,
    required this.strikedthrough,
    this.groupId,
    this.sourceId,
    required this.quantity,
    required this.listItemId,
    this.sorting,
    this.availableQuantity,
    this.linePrice,
    this.catalog,
    this.assortmentGroupId,
    this.storeSortingSequence,
    this.storeSortingSequenceBucket,
    required this.type,
  });

  factory ShoppingListItem.fromJson(Map<String, dynamic> json) =>
      _$ShoppingListItemFromJson(json);

  @JsonKey(name: 'position', includeIfNull: false)
  final int position;
  @JsonKey(name: 'sourceCode', includeIfNull: false, defaultValue: '')
  final String sourceCode;
  @JsonKey(name: 'strikedthrough', includeIfNull: false)
  final bool strikedthrough;
  @JsonKey(name: 'groupId', includeIfNull: false, defaultValue: '')
  final String? groupId;
  @JsonKey(name: 'sourceId', includeIfNull: false)
  final num? sourceId;
  @JsonKey(name: 'quantity', includeIfNull: false)
  final int quantity;
  @JsonKey(name: 'listItemId', includeIfNull: false)
  final num listItemId;
  @JsonKey(name: 'sorting', includeIfNull: false)
  final ListItemSorting? sorting;
  @JsonKey(name: 'availableQuantity', includeIfNull: false)
  final int? availableQuantity;
  @JsonKey(name: 'linePrice', includeIfNull: false)
  final double? linePrice;
  @JsonKey(name: 'catalog', includeIfNull: false, defaultValue: '')
  final String? catalog;
  @JsonKey(name: 'assortmentGroupId', includeIfNull: false)
  final num? assortmentGroupId;
  @JsonKey(name: 'storeSortingSequence', includeIfNull: false)
  final int? storeSortingSequence;
  @JsonKey(
      name: 'storeSortingSequenceBucket',
      includeIfNull: false,
      defaultValue: '')
  final String? storeSortingSequenceBucket;
  @JsonKey(
      name: 'type',
      includeIfNull: false,
      toJson: shoppingListItemTypeToJson,
      fromJson: shoppingListItemTypeFromJson)
  final enums.ShoppingListItemType type;
  static const fromJsonFactory = _$ShoppingListItemFromJson;
  static const toJsonFactory = _$ShoppingListItemToJson;
  Map<String, dynamic> toJson() => _$ShoppingListItemToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShoppingListItem &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.sourceCode, sourceCode) ||
                const DeepCollectionEquality()
                    .equals(other.sourceCode, sourceCode)) &&
            (identical(other.strikedthrough, strikedthrough) ||
                const DeepCollectionEquality()
                    .equals(other.strikedthrough, strikedthrough)) &&
            (identical(other.groupId, groupId) ||
                const DeepCollectionEquality()
                    .equals(other.groupId, groupId)) &&
            (identical(other.sourceId, sourceId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceId, sourceId)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.listItemId, listItemId) ||
                const DeepCollectionEquality()
                    .equals(other.listItemId, listItemId)) &&
            (identical(other.sorting, sorting) ||
                const DeepCollectionEquality()
                    .equals(other.sorting, sorting)) &&
            (identical(other.availableQuantity, availableQuantity) ||
                const DeepCollectionEquality()
                    .equals(other.availableQuantity, availableQuantity)) &&
            (identical(other.linePrice, linePrice) ||
                const DeepCollectionEquality()
                    .equals(other.linePrice, linePrice)) &&
            (identical(other.catalog, catalog) ||
                const DeepCollectionEquality()
                    .equals(other.catalog, catalog)) &&
            (identical(other.assortmentGroupId, assortmentGroupId) ||
                const DeepCollectionEquality()
                    .equals(other.assortmentGroupId, assortmentGroupId)) &&
            (identical(other.storeSortingSequence, storeSortingSequence) ||
                const DeepCollectionEquality().equals(
                    other.storeSortingSequence, storeSortingSequence)) &&
            (identical(other.storeSortingSequenceBucket,
                    storeSortingSequenceBucket) ||
                const DeepCollectionEquality().equals(
                    other.storeSortingSequenceBucket,
                    storeSortingSequenceBucket)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(sourceCode) ^
      const DeepCollectionEquality().hash(strikedthrough) ^
      const DeepCollectionEquality().hash(groupId) ^
      const DeepCollectionEquality().hash(sourceId) ^
      const DeepCollectionEquality().hash(quantity) ^
      const DeepCollectionEquality().hash(listItemId) ^
      const DeepCollectionEquality().hash(sorting) ^
      const DeepCollectionEquality().hash(availableQuantity) ^
      const DeepCollectionEquality().hash(linePrice) ^
      const DeepCollectionEquality().hash(catalog) ^
      const DeepCollectionEquality().hash(assortmentGroupId) ^
      const DeepCollectionEquality().hash(storeSortingSequence) ^
      const DeepCollectionEquality().hash(storeSortingSequenceBucket) ^
      const DeepCollectionEquality().hash(type) ^
      runtimeType.hashCode;
}

extension $ShoppingListItemExtension on ShoppingListItem {
  ShoppingListItem copyWith(
      {int? position,
      String? sourceCode,
      bool? strikedthrough,
      String? groupId,
      num? sourceId,
      int? quantity,
      num? listItemId,
      ListItemSorting? sorting,
      int? availableQuantity,
      double? linePrice,
      String? catalog,
      num? assortmentGroupId,
      int? storeSortingSequence,
      String? storeSortingSequenceBucket,
      enums.ShoppingListItemType? type}) {
    return ShoppingListItem(
        position: position ?? this.position,
        sourceCode: sourceCode ?? this.sourceCode,
        strikedthrough: strikedthrough ?? this.strikedthrough,
        groupId: groupId ?? this.groupId,
        sourceId: sourceId ?? this.sourceId,
        quantity: quantity ?? this.quantity,
        listItemId: listItemId ?? this.listItemId,
        sorting: sorting ?? this.sorting,
        availableQuantity: availableQuantity ?? this.availableQuantity,
        linePrice: linePrice ?? this.linePrice,
        catalog: catalog ?? this.catalog,
        assortmentGroupId: assortmentGroupId ?? this.assortmentGroupId,
        storeSortingSequence: storeSortingSequence ?? this.storeSortingSequence,
        storeSortingSequenceBucket:
            storeSortingSequenceBucket ?? this.storeSortingSequenceBucket,
        type: type ?? this.type);
  }
}

@JsonSerializable(explicitToJson: true)
class ShoppingListResponse {
  ShoppingListResponse({
    required this.items,
    required this.dateLastSynced,
    required this.dateLastSyncedMillis,
    required this.activeSorting,
    required this.storeNumber,
  });

  factory ShoppingListResponse.fromJson(Map<String, dynamic> json) =>
      _$ShoppingListResponseFromJson(json);

  @JsonKey(
      name: 'items', includeIfNull: false, defaultValue: <ShoppingListItem>[])
  final List<ShoppingListItem> items;
  @JsonKey(name: 'dateLastSynced', includeIfNull: false)
  final DateTime dateLastSynced;
  @JsonKey(name: 'dateLastSyncedMillis', includeIfNull: false)
  final num dateLastSyncedMillis;
  @JsonKey(name: 'activeSorting', includeIfNull: false, defaultValue: '')
  final String activeSorting;
  @JsonKey(name: 'storeNumber', includeIfNull: false)
  final int storeNumber;
  static const fromJsonFactory = _$ShoppingListResponseFromJson;
  static const toJsonFactory = _$ShoppingListResponseToJson;
  Map<String, dynamic> toJson() => _$ShoppingListResponseToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShoppingListResponse &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)) &&
            (identical(other.dateLastSynced, dateLastSynced) ||
                const DeepCollectionEquality()
                    .equals(other.dateLastSynced, dateLastSynced)) &&
            (identical(other.dateLastSyncedMillis, dateLastSyncedMillis) ||
                const DeepCollectionEquality().equals(
                    other.dateLastSyncedMillis, dateLastSyncedMillis)) &&
            (identical(other.activeSorting, activeSorting) ||
                const DeepCollectionEquality()
                    .equals(other.activeSorting, activeSorting)) &&
            (identical(other.storeNumber, storeNumber) ||
                const DeepCollectionEquality()
                    .equals(other.storeNumber, storeNumber)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(items) ^
      const DeepCollectionEquality().hash(dateLastSynced) ^
      const DeepCollectionEquality().hash(dateLastSyncedMillis) ^
      const DeepCollectionEquality().hash(activeSorting) ^
      const DeepCollectionEquality().hash(storeNumber) ^
      runtimeType.hashCode;
}

extension $ShoppingListResponseExtension on ShoppingListResponse {
  ShoppingListResponse copyWith(
      {List<ShoppingListItem>? items,
      DateTime? dateLastSynced,
      num? dateLastSyncedMillis,
      String? activeSorting,
      int? storeNumber}) {
    return ShoppingListResponse(
        items: items ?? this.items,
        dateLastSynced: dateLastSynced ?? this.dateLastSynced,
        dateLastSyncedMillis: dateLastSyncedMillis ?? this.dateLastSyncedMillis,
        activeSorting: activeSorting ?? this.activeSorting,
        storeNumber: storeNumber ?? this.storeNumber);
  }
}

@JsonSerializable(explicitToJson: true)
class ShoppingListUpdateCommand {
  ShoppingListUpdateCommand({
    required this.dateLastSyncedMillis,
    required this.items,
  });

  factory ShoppingListUpdateCommand.fromJson(Map<String, dynamic> json) =>
      _$ShoppingListUpdateCommandFromJson(json);

  @JsonKey(name: 'dateLastSyncedMillis', includeIfNull: false)
  final num dateLastSyncedMillis;
  @JsonKey(
      name: 'items',
      includeIfNull: false,
      defaultValue: <ShoppingListUpdateItem>[])
  final List<ShoppingListUpdateItem> items;
  static const fromJsonFactory = _$ShoppingListUpdateCommandFromJson;
  static const toJsonFactory = _$ShoppingListUpdateCommandToJson;
  Map<String, dynamic> toJson() => _$ShoppingListUpdateCommandToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShoppingListUpdateCommand &&
            (identical(other.dateLastSyncedMillis, dateLastSyncedMillis) ||
                const DeepCollectionEquality().equals(
                    other.dateLastSyncedMillis, dateLastSyncedMillis)) &&
            (identical(other.items, items) ||
                const DeepCollectionEquality().equals(other.items, items)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(dateLastSyncedMillis) ^
      const DeepCollectionEquality().hash(items) ^
      runtimeType.hashCode;
}

extension $ShoppingListUpdateCommandExtension on ShoppingListUpdateCommand {
  ShoppingListUpdateCommand copyWith(
      {num? dateLastSyncedMillis, List<ShoppingListUpdateItem>? items}) {
    return ShoppingListUpdateCommand(
        dateLastSyncedMillis: dateLastSyncedMillis ?? this.dateLastSyncedMillis,
        items: items ?? this.items);
  }
}

@JsonSerializable(explicitToJson: true)
class ShoppingListUpdateItem {
  ShoppingListUpdateItem({
    required this.description,
    this.itemId,
    this.listItemId,
    required this.position,
    required this.quantity,
    this.searchTerm,
    required this.sourceCode,
    required this.strikedthrough,
    required this.type,
    this.sourceId,
  });

  factory ShoppingListUpdateItem.fromJson(Map<String, dynamic> json) =>
      _$ShoppingListUpdateItemFromJson(json);

  @JsonKey(name: 'description', includeIfNull: false, defaultValue: '')
  final String description;
  @JsonKey(name: 'itemId', includeIfNull: false, defaultValue: '')
  final String? itemId;
  @JsonKey(name: 'listItemId', includeIfNull: false)
  final num? listItemId;
  @JsonKey(name: 'position', includeIfNull: false)
  final int position;
  @JsonKey(name: 'quantity', includeIfNull: false)
  final int quantity;
  @JsonKey(name: 'searchTerm', includeIfNull: false, defaultValue: '')
  final String? searchTerm;
  @JsonKey(name: 'sourceCode', includeIfNull: false, defaultValue: '')
  final String sourceCode;
  @JsonKey(name: 'strikedthrough', includeIfNull: false)
  final bool strikedthrough;
  @JsonKey(name: 'type', includeIfNull: false, defaultValue: '')
  final String type;
  @JsonKey(name: 'sourceId', includeIfNull: false)
  final num? sourceId;
  static const fromJsonFactory = _$ShoppingListUpdateItemFromJson;
  static const toJsonFactory = _$ShoppingListUpdateItemToJson;
  Map<String, dynamic> toJson() => _$ShoppingListUpdateItemToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ShoppingListUpdateItem &&
            (identical(other.description, description) ||
                const DeepCollectionEquality()
                    .equals(other.description, description)) &&
            (identical(other.itemId, itemId) ||
                const DeepCollectionEquality().equals(other.itemId, itemId)) &&
            (identical(other.listItemId, listItemId) ||
                const DeepCollectionEquality()
                    .equals(other.listItemId, listItemId)) &&
            (identical(other.position, position) ||
                const DeepCollectionEquality()
                    .equals(other.position, position)) &&
            (identical(other.quantity, quantity) ||
                const DeepCollectionEquality()
                    .equals(other.quantity, quantity)) &&
            (identical(other.searchTerm, searchTerm) ||
                const DeepCollectionEquality()
                    .equals(other.searchTerm, searchTerm)) &&
            (identical(other.sourceCode, sourceCode) ||
                const DeepCollectionEquality()
                    .equals(other.sourceCode, sourceCode)) &&
            (identical(other.strikedthrough, strikedthrough) ||
                const DeepCollectionEquality()
                    .equals(other.strikedthrough, strikedthrough)) &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)) &&
            (identical(other.sourceId, sourceId) ||
                const DeepCollectionEquality()
                    .equals(other.sourceId, sourceId)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(description) ^
      const DeepCollectionEquality().hash(itemId) ^
      const DeepCollectionEquality().hash(listItemId) ^
      const DeepCollectionEquality().hash(position) ^
      const DeepCollectionEquality().hash(quantity) ^
      const DeepCollectionEquality().hash(searchTerm) ^
      const DeepCollectionEquality().hash(sourceCode) ^
      const DeepCollectionEquality().hash(strikedthrough) ^
      const DeepCollectionEquality().hash(type) ^
      const DeepCollectionEquality().hash(sourceId) ^
      runtimeType.hashCode;
}

extension $ShoppingListUpdateItemExtension on ShoppingListUpdateItem {
  ShoppingListUpdateItem copyWith(
      {String? description,
      String? itemId,
      num? listItemId,
      int? position,
      int? quantity,
      String? searchTerm,
      String? sourceCode,
      bool? strikedthrough,
      String? type,
      num? sourceId}) {
    return ShoppingListUpdateItem(
        description: description ?? this.description,
        itemId: itemId ?? this.itemId,
        listItemId: listItemId ?? this.listItemId,
        position: position ?? this.position,
        quantity: quantity ?? this.quantity,
        searchTerm: searchTerm ?? this.searchTerm,
        sourceCode: sourceCode ?? this.sourceCode,
        strikedthrough: strikedthrough ?? this.strikedthrough,
        type: type ?? this.type,
        sourceId: sourceId ?? this.sourceId);
  }
}

String? shoppingListItemTypeToJson(
    enums.ShoppingListItemType? shoppingListItemType) {
  return enums.$ShoppingListItemTypeMap[shoppingListItemType];
}

enums.ShoppingListItemType shoppingListItemTypeFromJson(
  Object? shoppingListItemType, [
  enums.ShoppingListItemType? defaultValue,
]) {
  if (shoppingListItemType is String) {
    return enums.$ShoppingListItemTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                shoppingListItemType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ShoppingListItemType.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ShoppingListItemTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ShoppingListItemType.swaggerGeneratedUnknown;
}

List<String> shoppingListItemTypeListToJson(
    List<enums.ShoppingListItemType>? shoppingListItemType) {
  if (shoppingListItemType == null) {
    return [];
  }

  return shoppingListItemType
      .map((e) => enums.$ShoppingListItemTypeMap[e]!)
      .toList();
}

List<enums.ShoppingListItemType> shoppingListItemTypeListFromJson(
  List? shoppingListItemType, [
  List<enums.ShoppingListItemType>? defaultValue,
]) {
  if (shoppingListItemType == null) {
    return defaultValue ?? [];
  }

  return shoppingListItemType
      .map((e) => shoppingListItemTypeFromJson(e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  chopper.Response<ResultType> convertResponse<ResultType, Item>(
      chopper.Response response) {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}
