// ignore_for_file: type=lint

import 'package:json_annotation/json_annotation.dart';
import 'package:collection/collection.dart';
import 'dart:convert';

import 'package:chopper/chopper.dart';

import 'client_mapping.dart';
import 'package:chopper/chopper.dart' as chopper;
import 'issue_305.enums.swagger.dart' as enums;
export 'issue_305.enums.swagger.dart';

part 'issue_305.swagger.chopper.dart';
part 'issue_305.swagger.g.dart';

// **************************************************************************
// SwaggerChopperGenerator
// **************************************************************************

@ChopperApi()
abstract class Issue305 extends ChopperService {
  static Issue305 create(
      {ChopperClient? client,
      Authenticator? authenticator,
      String? baseUrl,
      Iterable<dynamic>? interceptors}) {
    if (client != null) {
      return _$Issue305(client);
    }

    final newClient = ChopperClient(
        services: [_$Issue305()],
        converter: $JsonSerializableConverter(),
        interceptors: interceptors ?? [],
        authenticator: authenticator,
        baseUrl: baseUrl ?? 'http://');
    return _$Issue305(newClient);
  }

  ///
  Future<chopper.Response> v1AdminProfilesGet({String? cacheControl}) {
    return _v1AdminProfilesGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/v1/admin/profiles')
  Future<chopper.Response> _v1AdminProfilesGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response<bool>> v1AdminProfilesReplayGet(
      {String? cacheControl}) {
    return _v1AdminProfilesReplayGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/v1/admin/profiles/replay')
  Future<chopper.Response<bool>> _v1AdminProfilesReplayGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response> v1AdminPortfolioGet({String? cacheControl}) {
    return _v1AdminPortfolioGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/v1/admin/portfolio')
  Future<chopper.Response> _v1AdminPortfolioGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response> v1AdminPortfolioUpdatereadmodelGet(
      {String? cacheControl}) {
    return _v1AdminPortfolioUpdatereadmodelGet(cacheControl: cacheControl);
  }

  ///
  @Get(path: '/v1/admin/portfolio/updatereadmodel')
  Future<chopper.Response> _v1AdminPortfolioUpdatereadmodelGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response> v1AdminPortfolioUpdateprofileinformationsGet(
      {String? cacheControl}) {
    return _v1AdminPortfolioUpdateprofileinformationsGet(
        cacheControl: cacheControl);
  }

  ///
  @Get(path: '/v1/admin/portfolio/updateprofileinformations')
  Future<chopper.Response> _v1AdminPortfolioUpdateprofileinformationsGet(
      {@Header('Cache-Control') String? cacheControl});

  ///
  ///@param profileId
  Future<chopper.Response> v1ProfilesProfileIdEstimationPost(
      {required String? profileId, String? cacheControl}) {
    return _v1ProfilesProfileIdEstimationPost(
        profileId: profileId, cacheControl: cacheControl);
  }

  ///
  ///@param profileId
  @Post(path: '/v1/profiles/{profileId}/estimation', optionalBody: true)
  Future<chopper.Response> _v1ProfilesProfileIdEstimationPost(
      {@Path('profileId') required String? profileId,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param profileId
  Future<chopper.Response> v1ProfilesProfileIdEstimationGet(
      {required String? profileId, String? cacheControl}) {
    return _v1ProfilesProfileIdEstimationGet(
        profileId: profileId, cacheControl: cacheControl);
  }

  ///
  ///@param profileId
  @Get(path: '/v1/profiles/{profileId}/estimation')
  Future<chopper.Response> _v1ProfilesProfileIdEstimationGet(
      {@Path('profileId') required String? profileId,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesForSaleIdArchivePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesForSaleIdArchivePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/for-sale/{_}/{id}/archive',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesForSaleIdArchivePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesForSaleIdReactivatePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesForSaleIdReactivatePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/for-sale/{_}/{id}/reactivate',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesForSaleIdReactivatePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleApartmentsPost(
      {required String? contactId,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleApartmentsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/for-sale/apartments')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleApartmentsPost(
      {@Path('contactId')
          required String? contactId,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleApartmentsIdPut(
      {required String? contactId,
      required String? id,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleApartmentsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/for-sale/apartments/{id}')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleApartmentsIdPut(
      {@Path('contactId')
          required String? contactId,
      @Path('id')
          required String? id,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleHousesPost(
      {required String? contactId,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleHousesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/for-sale/houses')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleHousesPost(
      {@Path('contactId')
          required String? contactId,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleHousesIdPut(
      {required String? contactId,
      required String? id,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleHousesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/for-sale/houses/{id}')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleHousesIdPut(
      {@Path('contactId')
          required String? contactId,
      @Path('id')
          required String? id,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleParkingPost(
      {required String? contactId,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleParkingPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/for-sale/parking')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleParkingPost(
      {@Path('contactId')
          required String? contactId,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleParkingIdPut(
      {required String? contactId,
      required String? id,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleParkingIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/for-sale/parking/{id}')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleParkingIdPut(
      {@Path('contactId')
          required String? contactId,
      @Path('id')
          required String? id,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleBuildingPost(
      {required String? contactId,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleBuildingPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/for-sale/building')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleBuildingPost(
      {@Path('contactId')
          required String? contactId,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleBuildingIdPut(
      {required String? contactId,
      required String? id,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto?
          body}) {
    return _v1ContactsContactIdProfilesForSaleBuildingIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/for-sale/building/{id}')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleBuildingIdPut(
      {@Path('contactId')
          required String? contactId,
      @Path('id')
          required String? id,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleLandPost(
      {required String? contactId,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto? body}) {
    return _v1ContactsContactIdProfilesForSaleLandPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/for-sale/land')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleLandPost(
      {@Path('contactId')
          required String? contactId,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto?
              body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response> v1ContactsContactIdProfilesForSaleLandIdPut(
      {required String? contactId,
      required String? id,
      String? cacheControl,
      required CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto? body}) {
    return _v1ContactsContactIdProfilesForSaleLandIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/for-sale/land/{id}')
  Future<chopper.Response> _v1ContactsContactIdProfilesForSaleLandIdPut(
      {@Path('contactId')
          required String? contactId,
      @Path('id')
          required String? id,
      @Header('Cache-Control')
          String? cacheControl,
      @Body()
          required CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto?
              body});

  ///
  ///@param apiKey
  Future<chopper.Response> v1HuntersPost(
      {required String? apiKey,
      String? cacheControl,
      required CRMAPIHuntersControllersDtoHunterContactDto? body}) {
    return _v1HuntersPost(
        apiKey: apiKey, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param apiKey
  @Post(path: '/v1/hunters')
  Future<chopper.Response> _v1HuntersPost(
      {@Query('apiKey') required String? apiKey,
      @Header('Cache-Control') String? cacheControl,
      @Body() required CRMAPIHuntersControllersDtoHunterContactDto? body});

  ///
  Future<chopper.Response<int>> v1ProfilesMatchingCountPost(
      {String? cacheControl,
      required CRMAPIProfilesDtoMatchingProfilesRequestDto? body}) {
    return _v1ProfilesMatchingCountPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/v1/profiles/matching/count')
  Future<chopper.Response<int>> _v1ProfilesMatchingCountPost(
      {@Header('Cache-Control') String? cacheControl,
      @Body() required CRMAPIProfilesDtoMatchingProfilesRequestDto? body});

  ///
  ///@param page
  ///@param size
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto>>
      v1ProfilesMatchingMinePost(
          {required int? page,
          required int? size,
          String? cacheControl,
          required CRMAPIProfilesDtoMatchingProfilesRequestDto? body}) {
    generatedMapping.putIfAbsent(
        CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto,
        () =>
            CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto
                .fromJsonFactory);

    return _v1ProfilesMatchingMinePost(
        page: page, size: size, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param page
  ///@param size
  @Post(path: '/v1/profiles/matching/mine')
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto>>
      _v1ProfilesMatchingMinePost(
          {@Query('page') required int? page,
          @Query('size') required int? size,
          @Header('Cache-Control') String? cacheControl,
          @Body() required CRMAPIProfilesDtoMatchingProfilesRequestDto? body});

  ///
  ///@param page
  ///@param size
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto>>
      v1ProfilesMatchingTheirsPost(
          {required int? page,
          required int? size,
          String? cacheControl,
          required CRMAPIProfilesDtoMatchingProfilesRequestDto? body}) {
    generatedMapping.putIfAbsent(
        CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto,
        () =>
            CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto
                .fromJsonFactory);

    return _v1ProfilesMatchingTheirsPost(
        page: page, size: size, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param page
  ///@param size
  @Post(path: '/v1/profiles/matching/theirs')
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto>>
      _v1ProfilesMatchingTheirsPost(
          {@Query('page') required int? page,
          @Query('size') required int? size,
          @Header('Cache-Control') String? cacheControl,
          @Body() required CRMAPIProfilesDtoMatchingProfilesRequestDto? body});

  ///
  ///@param SortAsc
  ///@param SortColumn
  ///@param From
  ///@param To
  ///@param WithArchivedContacts
  ///@param SearchTerm
  ///@param ProfileKinds
  ///@param Sources
  ///@param ConsentStatuses
  ///@param Villes
  ///@param Regions
  ///@param Departements
  ///@param Size
  ///@param Page
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel>>
      v1PortfolioGet(
          {bool? sortAsc,
          enums.CRMInfrastructureElasticSearchContactSortColumn? sortColumn,
          String? from,
          String? to,
          bool? withArchivedContacts,
          String? searchTerm,
          enums.ProfileKindEnum? profileKinds,
          enums.SourceEnum? sources,
          enums.CRMAPIPortfolioControllersDtoConsentStatusEnum? consentStatuses,
          List<String>? villes,
          List<String>? regions,
          List<String>? departements,
          int? size,
          int? page,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(
        CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel,
        () =>
            CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel
                .fromJsonFactory);

    return _v1PortfolioGet(
        sortAsc: sortAsc,
        sortColumn: enums
            .$CRMInfrastructureElasticSearchContactSortColumnMap[sortColumn]
            ?.toString(),
        from: from,
        to: to,
        withArchivedContacts: withArchivedContacts,
        searchTerm: searchTerm,
        profileKinds: enums.$ProfileKindEnumMap[profileKinds]?.toString(),
        sources: enums.$SourceEnumMap[sources]?.toString(),
        consentStatuses: enums
            .$CRMAPIPortfolioControllersDtoConsentStatusEnumMap[consentStatuses]
            ?.toString(),
        villes: villes,
        regions: regions,
        departements: departements,
        size: size,
        page: page,
        cacheControl: cacheControl);
  }

  ///
  ///@param SortAsc
  ///@param SortColumn
  ///@param From
  ///@param To
  ///@param WithArchivedContacts
  ///@param SearchTerm
  ///@param ProfileKinds
  ///@param Sources
  ///@param ConsentStatuses
  ///@param Villes
  ///@param Regions
  ///@param Departements
  ///@param Size
  ///@param Page
  @Get(path: '/v1/portfolio')
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel>>
      _v1PortfolioGet(
          {@Query('SortAsc') bool? sortAsc,
          @Query('SortColumn') String? sortColumn,
          @Query('From') String? from,
          @Query('To') String? to,
          @Query('WithArchivedContacts') bool? withArchivedContacts,
          @Query('SearchTerm') String? searchTerm,
          @Query('ProfileKinds') String? profileKinds,
          @Query('Sources') String? sources,
          @Query('ConsentStatuses') String? consentStatuses,
          @Query('Villes') List<String>? villes,
          @Query('Regions') List<String>? regions,
          @Query('Departements') List<String>? departements,
          @Query('Size') int? size,
          @Query('Page') int? page,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param page
  ///@param size
  ///@param fullText
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel>>
      v1PortfolioContactsGlobalsearchGet(
          {required int? page,
          required int? size,
          required String? fullText,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(
        CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel,
        () =>
            CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel
                .fromJsonFactory);

    return _v1PortfolioContactsGlobalsearchGet(
        page: page, size: size, fullText: fullText, cacheControl: cacheControl);
  }

  ///
  ///@param page
  ///@param size
  ///@param fullText
  @Get(path: '/v1/portfolio/contacts/globalsearch')
  Future<
          chopper.Response<
              CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel>>
      _v1PortfolioContactsGlobalsearchGet(
          {@Query('page') required int? page,
          @Query('size') required int? size,
          @Query('fullText') required String? fullText,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param id
  Future<chopper.Response> v1PortfolioContactsIdGet(
      {required String? id, String? cacheControl}) {
    return _v1PortfolioContactsIdGet(id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Get(path: '/v1/portfolio/contacts/{id}')
  Future<chopper.Response> _v1PortfolioContactsIdGet(
      {@Path('id') required String? id,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param id
  Future<chopper.Response> v1PortfolioContactsIdPut(
      {required String? id,
      String? cacheControl,
      required CRMAPIPortfolioControllersDtoWriteContactDto? body}) {
    return _v1PortfolioContactsIdPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/v1/portfolio/contacts/{id}')
  Future<chopper.Response> _v1PortfolioContactsIdPut(
      {@Path('id') required String? id,
      @Header('Cache-Control') String? cacheControl,
      @Body() required CRMAPIPortfolioControllersDtoWriteContactDto? body});

  ///
  ///@param phoneNumber
  ///@param contactId
  Future<chopper.Response> v1PortfolioContactsByphonenumberGet(
      {String? phoneNumber, String? contactId, String? cacheControl}) {
    return _v1PortfolioContactsByphonenumberGet(
        phoneNumber: phoneNumber,
        contactId: contactId,
        cacheControl: cacheControl);
  }

  ///
  ///@param phoneNumber
  ///@param contactId
  @Get(path: '/v1/portfolio/contacts/byphonenumber')
  Future<chopper.Response> _v1PortfolioContactsByphonenumberGet(
      {@Query('phoneNumber') String? phoneNumber,
      @Query('contactId') String? contactId,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param emailAddress
  ///@param contactId
  Future<chopper.Response> v1PortfolioContactsByemailaddressGet(
      {String? emailAddress, String? contactId, String? cacheControl}) {
    return _v1PortfolioContactsByemailaddressGet(
        emailAddress: emailAddress,
        contactId: contactId,
        cacheControl: cacheControl);
  }

  ///
  ///@param emailAddress
  ///@param contactId
  @Get(path: '/v1/portfolio/contacts/byemailaddress')
  Future<chopper.Response> _v1PortfolioContactsByemailaddressGet(
      {@Query('emailAddress') String? emailAddress,
      @Query('contactId') String? contactId,
      @Header('Cache-Control') String? cacheControl});

  ///
  Future<chopper.Response> v1PortfolioContactsPost(
      {String? cacheControl,
      required CRMAPIPortfolioControllersDtoWriteContactDto? body}) {
    return _v1PortfolioContactsPost(cacheControl: cacheControl, body: body);
  }

  ///
  @Post(path: '/v1/portfolio/contacts')
  Future<chopper.Response> _v1PortfolioContactsPost(
      {@Header('Cache-Control') String? cacheControl,
      @Body() required CRMAPIPortfolioControllersDtoWriteContactDto? body});

  ///
  ///@param id
  Future<chopper.Response> v1PortfolioContactsIdConsentstatusPut(
      {required String? id,
      String? cacheControl,
      required CRMAPIPortfolioControllersDtoConsentStatusDto? body}) {
    return _v1PortfolioContactsIdConsentstatusPut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/v1/portfolio/contacts/{id}/consentstatus')
  Future<chopper.Response> _v1PortfolioContactsIdConsentstatusPut(
      {@Path('id') required String? id,
      @Header('Cache-Control') String? cacheControl,
      @Body() required CRMAPIPortfolioControllersDtoConsentStatusDto? body});

  ///
  ///@param id
  Future<chopper.Response> v1PortfolioContactsIdArchivePut(
      {required String? id,
      String? cacheControl,
      required CRMAPIPortfolioControllersDtoConsentStatusDto? body}) {
    return _v1PortfolioContactsIdArchivePut(
        id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param id
  @Put(path: '/v1/portfolio/contacts/{id}/archive')
  Future<chopper.Response> _v1PortfolioContactsIdArchivePut(
      {@Path('id') required String? id,
      @Header('Cache-Control') String? cacheControl,
      @Body() required CRMAPIPortfolioControllersDtoConsentStatusDto? body});

  ///
  ///@param id
  Future<chopper.Response> v1PortfolioContactsIdActivatePut(
      {required String? id, String? cacheControl}) {
    return _v1PortfolioContactsIdActivatePut(
        id: id, cacheControl: cacheControl);
  }

  ///
  ///@param id
  @Put(path: '/v1/portfolio/contacts/{id}/activate', optionalBody: true)
  Future<chopper.Response> _v1PortfolioContactsIdActivatePut(
      {@Path('id') required String? id,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesGet(
          {required String? contactId, String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesGet(
        contactId: contactId, cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  @Get(path: '/v1/contacts/{contactId}/profiles')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesGet(
          {@Path('contactId') required String? contactId,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param id
  ///@param contactId
  Future<chopper.Response<CRMInfrastructureProfilesModelProfileModel>>
      v1ProfilesIdContactContactIdGet(
          {required String? id,
          required String? contactId,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMInfrastructureProfilesModelProfileModel,
        () => CRMInfrastructureProfilesModelProfileModel.fromJsonFactory);

    return _v1ProfilesIdContactContactIdGet(
        id: id, contactId: contactId, cacheControl: cacheControl);
  }

  ///
  ///@param id
  ///@param contactId
  @Get(path: '/v1/profiles/{id}/contact/{contactId}')
  Future<chopper.Response<CRMInfrastructureProfilesModelProfileModel>>
      _v1ProfilesIdContactContactIdGet(
          {@Path('id') required String? id,
          @Path('contactId') required String? contactId,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param id
  ///@param contactId
  ///@param notes
  Future<chopper.Response> v1ProfilesIdContactContactIdNotesNotesPut(
      {required String? id,
      required String? contactId,
      required String? notes,
      String? cacheControl}) {
    return _v1ProfilesIdContactContactIdNotesNotesPut(
        id: id, contactId: contactId, notes: notes, cacheControl: cacheControl);
  }

  ///
  ///@param id
  ///@param contactId
  ///@param notes
  @Put(
      path: '/v1/profiles/{id}/contact/{contactId}/notes/{notes}',
      optionalBody: true)
  Future<chopper.Response> _v1ProfilesIdContactContactIdNotesNotesPut(
      {@Path('id') required String? id,
      @Path('contactId') required String? contactId,
      @Path('notes') required String? notes,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param Size
  ///@param PageNumber
  ///@param ProfileKinds
  ///@param FamilyKinds
  ///@param Sources
  ///@param BudgetMax
  ///@param ContactName
  ///@param SortColumn
  ///@param SortAsc
  ///@param Reference
  Future<
          chopper.Response<
              CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel>>
      v1ProfilesGet(
          {int? size,
          int? pageNumber,
          List<String>? profileKinds,
          List<String>? familyKinds,
          List<String>? sources,
          num? budgetMax,
          String? contactName,
          enums.CRMAPIProfilesDtoSortableColumn? sortColumn,
          bool? sortAsc,
          String? reference,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(
        CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel,
        () =>
            CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel
                .fromJsonFactory);

    return _v1ProfilesGet(
        size: size,
        pageNumber: pageNumber,
        profileKinds: profileKinds,
        familyKinds: familyKinds,
        sources: sources,
        budgetMax: budgetMax,
        contactName: contactName,
        sortColumn:
            enums.$CRMAPIProfilesDtoSortableColumnMap[sortColumn]?.toString(),
        sortAsc: sortAsc,
        reference: reference,
        cacheControl: cacheControl);
  }

  ///
  ///@param Size
  ///@param PageNumber
  ///@param ProfileKinds
  ///@param FamilyKinds
  ///@param Sources
  ///@param BudgetMax
  ///@param ContactName
  ///@param SortColumn
  ///@param SortAsc
  ///@param Reference
  @Get(path: '/v1/profiles')
  Future<
          chopper.Response<
              CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel>>
      _v1ProfilesGet(
          {@Query('Size') int? size,
          @Query('PageNumber') int? pageNumber,
          @Query('ProfileKinds') List<String>? profileKinds,
          @Query('FamilyKinds') List<String>? familyKinds,
          @Query('Sources') List<String>? sources,
          @Query('BudgetMax') num? budgetMax,
          @Query('ContactName') String? contactName,
          @Query('SortColumn') String? sortColumn,
          @Query('SortAsc') bool? sortAsc,
          @Query('Reference') String? reference,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param profileId
  Future<chopper.Response> v1ContactsContactIdProfilesProfileIdGet(
      {required String? contactId,
      required String? profileId,
      String? cacheControl}) {
    return _v1ContactsContactIdProfilesProfileIdGet(
        contactId: contactId, profileId: profileId, cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param profileId
  @Get(path: '/v1/contacts/{contactId}/profiles/{profileId}')
  Future<chopper.Response> _v1ContactsContactIdProfilesProfileIdGet(
      {@Path('contactId') required String? contactId,
      @Path('profileId') required String? profileId,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param profileId
  Future<chopper.Response> v1ContactsContactIdProfilesProfileIdPost(
      {required String? contactId,
      required String? profileId,
      String? cacheControl}) {
    return _v1ContactsContactIdProfilesProfileIdPost(
        contactId: contactId, profileId: profileId, cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param profileId
  @Post(
      path: '/v1/contacts/{contactId}/profiles/{profileId}', optionalBody: true)
  Future<chopper.Response> _v1ContactsContactIdProfilesProfileIdPost(
      {@Path('contactId') required String? contactId,
      @Path('profileId') required String? profileId,
      @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityIdArchivePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityIdArchivePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/life-annuity/{_}/{id}/archive',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityIdArchivePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityIdReactivatePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityIdReactivatePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path:
          '/v1/contacts/{contactId}/profiles/life-annuity/{_}/{id}/reactivate',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityIdReactivatePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityApartmentsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityApartmentsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/life-annuity/apartments')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityApartmentsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityApartmentsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityApartmentsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/life-annuity/apartments/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityApartmentsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityBuildingsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityBuildingsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/life-annuity/buildings')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityBuildingsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityBuildingsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityBuildingsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/life-annuity/buildings/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityBuildingsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityHousesPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityHousesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/life-annuity/houses')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityHousesPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityHousesIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityHousesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/life-annuity/houses/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityHousesIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityLandsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityLandsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/life-annuity/lands')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityLandsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityLandsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityLandsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/life-annuity/lands/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityLandsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityPremisesPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityPremisesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/life-annuity/premises')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityPremisesPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesLifeAnnuityPremisesIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesLifeAnnuityPremisesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/life-annuity/premises/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesLifeAnnuityPremisesIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseApartmentsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseApartmentsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/apartments')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseApartmentsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseIdArchivePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseIdArchivePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/purchase/{_}/{id}/archive',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseIdArchivePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseIdReactivatePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseIdReactivatePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/purchase/{_}/{id}/reactivate',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseIdReactivatePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseApartmentsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseApartmentsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/apartments/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseApartmentsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseBuildingsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseBuildingsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/buildings')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseBuildingsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseBuildingsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseBuildingsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/buildings/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseBuildingsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseHousesPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseHousesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/houses')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseHousesPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseHousesIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseHousesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/houses/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseHousesIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseLandsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseLandsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/lands')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseLandsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseLandsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseLandsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/lands/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseLandsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchasePremisesPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchasePremisesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/premises')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchasePremisesPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchasePremisesIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchasePremisesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/premises/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchasePremisesIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseParkingsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseParkingsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/parkings')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseParkingsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseParkingsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseParkingsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/parkings/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseParkingsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseGoodwillsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseGoodwillsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/purchase/goodwills')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseGoodwillsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesPurchaseGoodwillsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesPurchaseGoodwillsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/purchase/goodwills/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesPurchaseGoodwillsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalIdArchivePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalIdArchivePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/rental/{_}/{id}/archive',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalIdArchivePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  ///@param id
  ///@param _
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalIdReactivatePut(
          {required String? contactId,
          required String? id,
          required String? undefinedParameter,
          String? cacheControl}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalIdReactivatePut(
        contactId: contactId,
        id: id,
        undefinedParameter: undefinedParameter,
        cacheControl: cacheControl);
  }

  ///
  ///@param contactId
  ///@param id
  ///@param _
  @Put(
      path: '/v1/contacts/{contactId}/profiles/rental/{_}/{id}/reactivate',
      optionalBody: true)
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalIdReactivatePut(
          {@Path('contactId') required String? contactId,
          @Path('id') required String? id,
          @Path('_') required String? undefinedParameter,
          @Header('Cache-Control') String? cacheControl});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalApartmentsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalApartmentsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/rental/apartments')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalApartmentsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalApartmentsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalApartmentsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/rental/apartments/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalApartmentsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalHousesPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalHousesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/rental/houses')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalHousesPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalHousesIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalHousesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/rental/houses/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalHousesIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalLandsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalLandsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/rental/lands')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalLandsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalLandsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalLandsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/rental/lands/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalLandsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalParkingsPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalParkingsPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/rental/parkings')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalParkingsPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalParkingsIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalParkingsIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/rental/parkings/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalParkingsIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto?
                  body});

  ///
  ///@param contactId
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalPremisesPost(
          {required String? contactId,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalPremisesPost(
        contactId: contactId, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  @Post(path: '/v1/contacts/{contactId}/profiles/rental/premises')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalPremisesPost(
          {@Path('contactId')
              required String? contactId,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto?
                  body});

  ///
  ///@param contactId
  ///@param id
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      v1ContactsContactIdProfilesRentalPremisesIdPut(
          {required String? contactId,
          required String? id,
          String? cacheControl,
          required CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto?
              body}) {
    generatedMapping.putIfAbsent(CRMAPIProfilesDtoProfilesReadDto,
        () => CRMAPIProfilesDtoProfilesReadDto.fromJsonFactory);

    return _v1ContactsContactIdProfilesRentalPremisesIdPut(
        contactId: contactId, id: id, cacheControl: cacheControl, body: body);
  }

  ///
  ///@param contactId
  ///@param id
  @Put(path: '/v1/contacts/{contactId}/profiles/rental/premises/{id}')
  Future<chopper.Response<CRMAPIProfilesDtoProfilesReadDto>>
      _v1ContactsContactIdProfilesRentalPremisesIdPut(
          {@Path('contactId')
              required String? contactId,
          @Path('id')
              required String? id,
          @Header('Cache-Control')
              String? cacheControl,
          @Body()
              required CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto?
                  body});
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoIProfileReadDto {
  CRMAPIProfilesDtoIProfileReadDto({
    this.archivingDate,
    this.lastModificationDate,
    this.creationDate,
    this.reference,
    this.kind,
  });

  factory CRMAPIProfilesDtoIProfileReadDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoIProfileReadDtoFromJson(json);

  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'lastModificationDate', includeIfNull: false)
  final DateTime? lastModificationDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'kind', includeIfNull: false, defaultValue: '')
  final String? kind;
  static const fromJsonFactory = _$CRMAPIProfilesDtoIProfileReadDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoIProfileReadDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoIProfileReadDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoIProfileReadDto &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.lastModificationDate, lastModificationDate) ||
                const DeepCollectionEquality().equals(
                    other.lastModificationDate, lastModificationDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.kind, kind) ||
                const DeepCollectionEquality().equals(other.kind, kind)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(lastModificationDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(kind) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoIProfileReadDtoExtension
    on CRMAPIProfilesDtoIProfileReadDto {
  CRMAPIProfilesDtoIProfileReadDto copyWith(
      {DateTime? archivingDate,
      DateTime? lastModificationDate,
      DateTime? creationDate,
      String? reference,
      String? kind}) {
    return CRMAPIProfilesDtoIProfileReadDto(
        archivingDate: archivingDate ?? this.archivingDate,
        lastModificationDate: lastModificationDate ?? this.lastModificationDate,
        creationDate: creationDate ?? this.creationDate,
        reference: reference ?? this.reference,
        kind: kind ?? this.kind);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoProfilesReadDto {
  CRMAPIProfilesDtoProfilesReadDto({
    this.value,
  });

  factory CRMAPIProfilesDtoProfilesReadDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoProfilesReadDtoFromJson(json);

  @JsonKey(
      name: 'value',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoIProfileReadDto>[])
  final List<CRMAPIProfilesDtoIProfileReadDto>? value;
  static const fromJsonFactory = _$CRMAPIProfilesDtoProfilesReadDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoProfilesReadDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoProfilesReadDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoProfilesReadDto &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoProfilesReadDtoExtension
    on CRMAPIProfilesDtoProfilesReadDto {
  CRMAPIProfilesDtoProfilesReadDto copyWith(
      {List<CRMAPIProfilesDtoIProfileReadDto>? value}) {
    return CRMAPIProfilesDtoProfilesReadDto(value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoPlaceDto {
  CRMAPIProfilesDtoPlaceDto({
    this.id,
    this.name,
    this.postalCodes,
    this.wkt,
    this.inseeCode,
  });

  factory CRMAPIProfilesDtoPlaceDto.fromJson(Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoPlaceDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'postalCodes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? postalCodes;
  @JsonKey(name: 'wkt', includeIfNull: false, defaultValue: '')
  final String? wkt;
  @JsonKey(name: 'inseeCode', includeIfNull: false, defaultValue: '')
  final String? inseeCode;
  static const fromJsonFactory = _$CRMAPIProfilesDtoPlaceDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoPlaceDtoToJson;
  Map<String, dynamic> toJson() => _$CRMAPIProfilesDtoPlaceDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoPlaceDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.postalCodes, postalCodes) ||
                const DeepCollectionEquality()
                    .equals(other.postalCodes, postalCodes)) &&
            (identical(other.wkt, wkt) ||
                const DeepCollectionEquality().equals(other.wkt, wkt)) &&
            (identical(other.inseeCode, inseeCode) ||
                const DeepCollectionEquality()
                    .equals(other.inseeCode, inseeCode)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(postalCodes) ^
      const DeepCollectionEquality().hash(wkt) ^
      const DeepCollectionEquality().hash(inseeCode) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoPlaceDtoExtension on CRMAPIProfilesDtoPlaceDto {
  CRMAPIProfilesDtoPlaceDto copyWith(
      {String? id,
      String? name,
      List<String>? postalCodes,
      String? wkt,
      String? inseeCode}) {
    return CRMAPIProfilesDtoPlaceDto(
        id: id ?? this.id,
        name: name ?? this.name,
        postalCodes: postalCodes ?? this.postalCodes,
        wkt: wkt ?? this.wkt,
        inseeCode: inseeCode ?? this.inseeCode);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonProfileAddressDto {
  CRMAPIProfilesDtoForSaleCommonProfileAddressDto({
    this.city,
    this.name,
    this.street,
  });

  factory CRMAPIProfilesDtoForSaleCommonProfileAddressDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonProfileAddressDtoFromJson(json);

  @JsonKey(name: 'city', includeIfNull: false)
  final CRMAPIProfilesDtoPlaceDto? city;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'street', includeIfNull: false, defaultValue: '')
  final String? street;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonProfileAddressDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonProfileAddressDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonProfileAddressDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonProfileAddressDto &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.street, street) ||
                const DeepCollectionEquality().equals(other.street, street)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(street) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonProfileAddressDtoExtension
    on CRMAPIProfilesDtoForSaleCommonProfileAddressDto {
  CRMAPIProfilesDtoForSaleCommonProfileAddressDto copyWith(
      {CRMAPIProfilesDtoPlaceDto? city, String? name, String? street}) {
    return CRMAPIProfilesDtoForSaleCommonProfileAddressDto(
        city: city ?? this.city,
        name: name ?? this.name,
        street: street ?? this.street);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto {
  CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto({
    this.price,
    this.agentFees,
    this.taxProperty,
    this.condominiumFees,
  });

  factory CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDtoFromJson(
          json);

  @JsonKey(name: 'price', includeIfNull: false)
  final double? price;
  @JsonKey(name: 'agentFees', includeIfNull: false)
  final double? agentFees;
  @JsonKey(name: 'taxProperty', includeIfNull: false)
  final double? taxProperty;
  @JsonKey(name: 'condominiumFees', includeIfNull: false)
  final double? condominiumFees;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.agentFees, agentFees) ||
                const DeepCollectionEquality()
                    .equals(other.agentFees, agentFees)) &&
            (identical(other.taxProperty, taxProperty) ||
                const DeepCollectionEquality()
                    .equals(other.taxProperty, taxProperty)) &&
            (identical(other.condominiumFees, condominiumFees) ||
                const DeepCollectionEquality()
                    .equals(other.condominiumFees, condominiumFees)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(agentFees) ^
      const DeepCollectionEquality().hash(taxProperty) ^
      const DeepCollectionEquality().hash(condominiumFees) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDtoExtension
    on CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto {
  CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto copyWith(
      {double? price,
      double? agentFees,
      double? taxProperty,
      double? condominiumFees}) {
    return CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto(
        price: price ?? this.price,
        agentFees: agentFees ?? this.agentFees,
        taxProperty: taxProperty ?? this.taxProperty,
        condominiumFees: condominiumFees ?? this.condominiumFees);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonBuildingInfoDto {
  CRMAPIProfilesDtoForSaleCommonBuildingInfoDto({
    this.yearBuilt,
    this.floorsCount,
    this.propertyFloor,
  });

  factory CRMAPIProfilesDtoForSaleCommonBuildingInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonBuildingInfoDtoFromJson(json);

  @JsonKey(name: 'yearBuilt', includeIfNull: false)
  final int? yearBuilt;
  @JsonKey(name: 'floorsCount', includeIfNull: false)
  final int? floorsCount;
  @JsonKey(name: 'propertyFloor', includeIfNull: false)
  final int? propertyFloor;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonBuildingInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonBuildingInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonBuildingInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonBuildingInfoDto &&
            (identical(other.yearBuilt, yearBuilt) ||
                const DeepCollectionEquality()
                    .equals(other.yearBuilt, yearBuilt)) &&
            (identical(other.floorsCount, floorsCount) ||
                const DeepCollectionEquality()
                    .equals(other.floorsCount, floorsCount)) &&
            (identical(other.propertyFloor, propertyFloor) ||
                const DeepCollectionEquality()
                    .equals(other.propertyFloor, propertyFloor)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(yearBuilt) ^
      const DeepCollectionEquality().hash(floorsCount) ^
      const DeepCollectionEquality().hash(propertyFloor) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonBuildingInfoDtoExtension
    on CRMAPIProfilesDtoForSaleCommonBuildingInfoDto {
  CRMAPIProfilesDtoForSaleCommonBuildingInfoDto copyWith(
      {int? yearBuilt, int? floorsCount, int? propertyFloor}) {
    return CRMAPIProfilesDtoForSaleCommonBuildingInfoDto(
        yearBuilt: yearBuilt ?? this.yearBuilt,
        floorsCount: floorsCount ?? this.floorsCount,
        propertyFloor: propertyFloor ?? this.propertyFloor);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonPropertyInfoDto {
  CRMAPIProfilesDtoForSaleCommonPropertyInfoDto({
    this.buildingInfo,
    this.generalState,
    this.built,
    this.exposure,
    this.joinOwnership,
    this.squareMeter,
  });

  factory CRMAPIProfilesDtoForSaleCommonPropertyInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonPropertyInfoDtoFromJson(json);

  @JsonKey(name: 'buildingInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonBuildingInfoDto? buildingInfo;
  @JsonKey(
      name: 'generalState',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType?
      generalState;
  @JsonKey(
      name: 'built',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeToJson,
      fromJson: cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType? built;
  @JsonKey(
      name: 'exposure',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeToJson,
      fromJson: cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType? exposure;
  @JsonKey(
      name: 'joinOwnership',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType?
      joinOwnership;
  @JsonKey(name: 'squareMeter', includeIfNull: false)
  final double? squareMeter;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonPropertyInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonPropertyInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonPropertyInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonPropertyInfoDto &&
            (identical(other.buildingInfo, buildingInfo) ||
                const DeepCollectionEquality()
                    .equals(other.buildingInfo, buildingInfo)) &&
            (identical(other.generalState, generalState) ||
                const DeepCollectionEquality()
                    .equals(other.generalState, generalState)) &&
            (identical(other.built, built) ||
                const DeepCollectionEquality().equals(other.built, built)) &&
            (identical(other.exposure, exposure) ||
                const DeepCollectionEquality()
                    .equals(other.exposure, exposure)) &&
            (identical(other.joinOwnership, joinOwnership) ||
                const DeepCollectionEquality()
                    .equals(other.joinOwnership, joinOwnership)) &&
            (identical(other.squareMeter, squareMeter) ||
                const DeepCollectionEquality()
                    .equals(other.squareMeter, squareMeter)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(buildingInfo) ^
      const DeepCollectionEquality().hash(generalState) ^
      const DeepCollectionEquality().hash(built) ^
      const DeepCollectionEquality().hash(exposure) ^
      const DeepCollectionEquality().hash(joinOwnership) ^
      const DeepCollectionEquality().hash(squareMeter) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonPropertyInfoDtoExtension
    on CRMAPIProfilesDtoForSaleCommonPropertyInfoDto {
  CRMAPIProfilesDtoForSaleCommonPropertyInfoDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonBuildingInfoDto? buildingInfo,
      enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType?
          generalState,
      enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType? built,
      enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType? exposure,
      enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType?
          joinOwnership,
      double? squareMeter}) {
    return CRMAPIProfilesDtoForSaleCommonPropertyInfoDto(
        buildingInfo: buildingInfo ?? this.buildingInfo,
        generalState: generalState ?? this.generalState,
        built: built ?? this.built,
        exposure: exposure ?? this.exposure,
        joinOwnership: joinOwnership ?? this.joinOwnership,
        squareMeter: squareMeter ?? this.squareMeter);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonIAnnexDto {
  CRMAPIProfilesDtoForSaleCommonIAnnexDto({
    this.kind,
    this.squareMeter,
  });

  factory CRMAPIProfilesDtoForSaleCommonIAnnexDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonIAnnexDtoFromJson(json);

  @JsonKey(
      name: 'kind',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonAnnexKindToJson,
      fromJson: cRMAPIProfilesDtoForSaleCommonAnnexKindFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonAnnexKind? kind;
  @JsonKey(name: 'squareMeter', includeIfNull: false)
  final double? squareMeter;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonIAnnexDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoForSaleCommonIAnnexDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonIAnnexDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonIAnnexDto &&
            (identical(other.kind, kind) ||
                const DeepCollectionEquality().equals(other.kind, kind)) &&
            (identical(other.squareMeter, squareMeter) ||
                const DeepCollectionEquality()
                    .equals(other.squareMeter, squareMeter)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(kind) ^
      const DeepCollectionEquality().hash(squareMeter) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonIAnnexDtoExtension
    on CRMAPIProfilesDtoForSaleCommonIAnnexDto {
  CRMAPIProfilesDtoForSaleCommonIAnnexDto copyWith(
      {enums.CRMAPIProfilesDtoForSaleCommonAnnexKind? kind,
      double? squareMeter}) {
    return CRMAPIProfilesDtoForSaleCommonIAnnexDto(
        kind: kind ?? this.kind, squareMeter: squareMeter ?? this.squareMeter);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonBedRoomsDto {
  CRMAPIProfilesDtoForSaleCommonBedRoomsDto({
    this.count,
  });

  factory CRMAPIProfilesDtoForSaleCommonBedRoomsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonBedRoomsDtoFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonBedRoomsDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonBedRoomsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonBedRoomsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonBedRoomsDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonBedRoomsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonBedRoomsDto {
  CRMAPIProfilesDtoForSaleCommonBedRoomsDto copyWith({int? count}) {
    return CRMAPIProfilesDtoForSaleCommonBedRoomsDto(
        count: count ?? this.count);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonRoomsDto {
  CRMAPIProfilesDtoForSaleCommonRoomsDto({
    this.count,
  });

  factory CRMAPIProfilesDtoForSaleCommonRoomsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonRoomsDtoFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonRoomsDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoForSaleCommonRoomsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonRoomsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonRoomsDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonRoomsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonRoomsDto {
  CRMAPIProfilesDtoForSaleCommonRoomsDto copyWith({int? count}) {
    return CRMAPIProfilesDtoForSaleCommonRoomsDto(count: count ?? this.count);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonBathRoomsDto {
  CRMAPIProfilesDtoForSaleCommonBathRoomsDto({
    this.count,
  });

  factory CRMAPIProfilesDtoForSaleCommonBathRoomsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonBathRoomsDtoFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonBathRoomsDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonBathRoomsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonBathRoomsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonBathRoomsDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonBathRoomsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonBathRoomsDto {
  CRMAPIProfilesDtoForSaleCommonBathRoomsDto copyWith({int? count}) {
    return CRMAPIProfilesDtoForSaleCommonBathRoomsDto(
        count: count ?? this.count);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonToiletsDto {
  CRMAPIProfilesDtoForSaleCommonToiletsDto({
    this.count,
  });

  factory CRMAPIProfilesDtoForSaleCommonToiletsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonToiletsDtoFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonToiletsDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoForSaleCommonToiletsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonToiletsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonToiletsDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonToiletsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonToiletsDto {
  CRMAPIProfilesDtoForSaleCommonToiletsDto copyWith({int? count}) {
    return CRMAPIProfilesDtoForSaleCommonToiletsDto(count: count ?? this.count);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonParkingsDto {
  CRMAPIProfilesDtoForSaleCommonParkingsDto({
    this.hasBox,
    this.hasInteriorParking,
    this.hasExteriorParking,
    this.count,
  });

  factory CRMAPIProfilesDtoForSaleCommonParkingsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonParkingsDtoFromJson(json);

  @JsonKey(name: 'hasBox', includeIfNull: false)
  final bool? hasBox;
  @JsonKey(name: 'hasInteriorParking', includeIfNull: false)
  final bool? hasInteriorParking;
  @JsonKey(name: 'hasExteriorParking', includeIfNull: false)
  final bool? hasExteriorParking;
  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonParkingsDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonParkingsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonParkingsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonParkingsDto &&
            (identical(other.hasBox, hasBox) ||
                const DeepCollectionEquality().equals(other.hasBox, hasBox)) &&
            (identical(other.hasInteriorParking, hasInteriorParking) ||
                const DeepCollectionEquality()
                    .equals(other.hasInteriorParking, hasInteriorParking)) &&
            (identical(other.hasExteriorParking, hasExteriorParking) ||
                const DeepCollectionEquality()
                    .equals(other.hasExteriorParking, hasExteriorParking)) &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(hasBox) ^
      const DeepCollectionEquality().hash(hasInteriorParking) ^
      const DeepCollectionEquality().hash(hasExteriorParking) ^
      const DeepCollectionEquality().hash(count) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonParkingsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonParkingsDto {
  CRMAPIProfilesDtoForSaleCommonParkingsDto copyWith(
      {bool? hasBox,
      bool? hasInteriorParking,
      bool? hasExteriorParking,
      int? count}) {
    return CRMAPIProfilesDtoForSaleCommonParkingsDto(
        hasBox: hasBox ?? this.hasBox,
        hasInteriorParking: hasInteriorParking ?? this.hasInteriorParking,
        hasExteriorParking: hasExteriorParking ?? this.hasExteriorParking,
        count: count ?? this.count);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonKitchenDto {
  CRMAPIProfilesDtoForSaleCommonKitchenDto({
    this.type,
  });

  factory CRMAPIProfilesDtoForSaleCommonKitchenDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonKitchenDtoFromJson(json);

  @JsonKey(
      name: 'type',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType? type;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonKitchenDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoForSaleCommonKitchenDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonKitchenDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonKitchenDto &&
            (identical(other.type, type) ||
                const DeepCollectionEquality().equals(other.type, type)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(type) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonKitchenDtoExtension
    on CRMAPIProfilesDtoForSaleCommonKitchenDto {
  CRMAPIProfilesDtoForSaleCommonKitchenDto copyWith(
      {enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType?
          type}) {
    return CRMAPIProfilesDtoForSaleCommonKitchenDto(type: type ?? this.type);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonLivingRoomDto {
  CRMAPIProfilesDtoForSaleCommonLivingRoomDto({
    this.squareMeter,
  });

  factory CRMAPIProfilesDtoForSaleCommonLivingRoomDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonLivingRoomDtoFromJson(json);

  @JsonKey(name: 'squareMeter', includeIfNull: false)
  final double? squareMeter;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonLivingRoomDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonLivingRoomDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonLivingRoomDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonLivingRoomDto &&
            (identical(other.squareMeter, squareMeter) ||
                const DeepCollectionEquality()
                    .equals(other.squareMeter, squareMeter)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(squareMeter) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonLivingRoomDtoExtension
    on CRMAPIProfilesDtoForSaleCommonLivingRoomDto {
  CRMAPIProfilesDtoForSaleCommonLivingRoomDto copyWith({double? squareMeter}) {
    return CRMAPIProfilesDtoForSaleCommonLivingRoomDto(
        squareMeter: squareMeter ?? this.squareMeter);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonLevelsDto {
  CRMAPIProfilesDtoForSaleCommonLevelsDto({
    this.count,
  });

  factory CRMAPIProfilesDtoForSaleCommonLevelsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonLevelsDtoFromJson(json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonLevelsDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoForSaleCommonLevelsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonLevelsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonLevelsDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^ runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonLevelsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonLevelsDto {
  CRMAPIProfilesDtoForSaleCommonLevelsDto copyWith({int? count}) {
    return CRMAPIProfilesDtoForSaleCommonLevelsDto(count: count ?? this.count);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonSummariesDto {
  CRMAPIProfilesDtoForSaleCommonSummariesDto({
    this.bedRooms,
    this.rooms,
    this.bathRooms,
    this.toilets,
    this.parkings,
    this.kitchen,
    this.livingRoom,
    this.levels,
  });

  factory CRMAPIProfilesDtoForSaleCommonSummariesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonSummariesDtoFromJson(json);

  @JsonKey(name: 'bedRooms', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonBedRoomsDto? bedRooms;
  @JsonKey(name: 'rooms', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonRoomsDto? rooms;
  @JsonKey(name: 'bathRooms', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonBathRoomsDto? bathRooms;
  @JsonKey(name: 'toilets', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonToiletsDto? toilets;
  @JsonKey(name: 'parkings', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonParkingsDto? parkings;
  @JsonKey(name: 'kitchen', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonKitchenDto? kitchen;
  @JsonKey(name: 'livingRoom', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonLivingRoomDto? livingRoom;
  @JsonKey(name: 'levels', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonLevelsDto? levels;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonSummariesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonSummariesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonSummariesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonSummariesDto &&
            (identical(other.bedRooms, bedRooms) ||
                const DeepCollectionEquality()
                    .equals(other.bedRooms, bedRooms)) &&
            (identical(other.rooms, rooms) ||
                const DeepCollectionEquality().equals(other.rooms, rooms)) &&
            (identical(other.bathRooms, bathRooms) ||
                const DeepCollectionEquality()
                    .equals(other.bathRooms, bathRooms)) &&
            (identical(other.toilets, toilets) ||
                const DeepCollectionEquality()
                    .equals(other.toilets, toilets)) &&
            (identical(other.parkings, parkings) ||
                const DeepCollectionEquality()
                    .equals(other.parkings, parkings)) &&
            (identical(other.kitchen, kitchen) ||
                const DeepCollectionEquality()
                    .equals(other.kitchen, kitchen)) &&
            (identical(other.livingRoom, livingRoom) ||
                const DeepCollectionEquality()
                    .equals(other.livingRoom, livingRoom)) &&
            (identical(other.levels, levels) ||
                const DeepCollectionEquality().equals(other.levels, levels)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(bedRooms) ^
      const DeepCollectionEquality().hash(rooms) ^
      const DeepCollectionEquality().hash(bathRooms) ^
      const DeepCollectionEquality().hash(toilets) ^
      const DeepCollectionEquality().hash(parkings) ^
      const DeepCollectionEquality().hash(kitchen) ^
      const DeepCollectionEquality().hash(livingRoom) ^
      const DeepCollectionEquality().hash(levels) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonSummariesDtoExtension
    on CRMAPIProfilesDtoForSaleCommonSummariesDto {
  CRMAPIProfilesDtoForSaleCommonSummariesDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonBedRoomsDto? bedRooms,
      CRMAPIProfilesDtoForSaleCommonRoomsDto? rooms,
      CRMAPIProfilesDtoForSaleCommonBathRoomsDto? bathRooms,
      CRMAPIProfilesDtoForSaleCommonToiletsDto? toilets,
      CRMAPIProfilesDtoForSaleCommonParkingsDto? parkings,
      CRMAPIProfilesDtoForSaleCommonKitchenDto? kitchen,
      CRMAPIProfilesDtoForSaleCommonLivingRoomDto? livingRoom,
      CRMAPIProfilesDtoForSaleCommonLevelsDto? levels}) {
    return CRMAPIProfilesDtoForSaleCommonSummariesDto(
        bedRooms: bedRooms ?? this.bedRooms,
        rooms: rooms ?? this.rooms,
        bathRooms: bathRooms ?? this.bathRooms,
        toilets: toilets ?? this.toilets,
        parkings: parkings ?? this.parkings,
        kitchen: kitchen ?? this.kitchen,
        livingRoom: livingRoom ?? this.livingRoom,
        levels: levels ?? this.levels);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleCommonPartsDto {
  CRMAPIProfilesDtoForSaleCommonPartsDto({
    this.annexes,
    this.summaries,
  });

  factory CRMAPIProfilesDtoForSaleCommonPartsDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleCommonPartsDtoFromJson(json);

  @JsonKey(
      name: 'annexes',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoForSaleCommonIAnnexDto>[])
  final List<CRMAPIProfilesDtoForSaleCommonIAnnexDto>? annexes;
  @JsonKey(name: 'summaries', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonSummariesDto? summaries;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleCommonPartsDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoForSaleCommonPartsDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleCommonPartsDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleCommonPartsDto &&
            (identical(other.annexes, annexes) ||
                const DeepCollectionEquality()
                    .equals(other.annexes, annexes)) &&
            (identical(other.summaries, summaries) ||
                const DeepCollectionEquality()
                    .equals(other.summaries, summaries)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(annexes) ^
      const DeepCollectionEquality().hash(summaries) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleCommonPartsDtoExtension
    on CRMAPIProfilesDtoForSaleCommonPartsDto {
  CRMAPIProfilesDtoForSaleCommonPartsDto copyWith(
      {List<CRMAPIProfilesDtoForSaleCommonIAnnexDto>? annexes,
      CRMAPIProfilesDtoForSaleCommonSummariesDto? summaries}) {
    return CRMAPIProfilesDtoForSaleCommonPartsDto(
        annexes: annexes ?? this.annexes,
        summaries: summaries ?? this.summaries);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto {
  CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto({
    this.address,
    this.financialInfo,
    this.propertyInfo,
    this.amenities,
    this.parts,
  });

  factory CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDtoFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address;
  @JsonKey(name: 'financialInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto?
      financialInfo;
  @JsonKey(name: 'propertyInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonPropertyInfoDto? propertyInfo;
  @JsonKey(
      name: 'amenities',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListToJson,
      fromJson: cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
      amenities;
  @JsonKey(name: 'parts', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonPartsDto? parts;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.financialInfo, financialInfo) ||
                const DeepCollectionEquality()
                    .equals(other.financialInfo, financialInfo)) &&
            (identical(other.propertyInfo, propertyInfo) ||
                const DeepCollectionEquality()
                    .equals(other.propertyInfo, propertyInfo)) &&
            (identical(other.amenities, amenities) ||
                const DeepCollectionEquality()
                    .equals(other.amenities, amenities)) &&
            (identical(other.parts, parts) ||
                const DeepCollectionEquality().equals(other.parts, parts)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(financialInfo) ^
      const DeepCollectionEquality().hash(propertyInfo) ^
      const DeepCollectionEquality().hash(amenities) ^
      const DeepCollectionEquality().hash(parts) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDtoExtension
    on CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto {
  CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address,
      CRMAPIProfilesDtoForSaleApartmentApartmentFinancialInfoDto? financialInfo,
      CRMAPIProfilesDtoForSaleCommonPropertyInfoDto? propertyInfo,
      List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
          amenities,
      CRMAPIProfilesDtoForSaleCommonPartsDto? parts}) {
    return CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto(
        address: address ?? this.address,
        financialInfo: financialInfo ?? this.financialInfo,
        propertyInfo: propertyInfo ?? this.propertyInfo,
        amenities: amenities ?? this.amenities,
        parts: parts ?? this.parts);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto({
    this.reference,
    this.account,
    this.maturity,
    this.notes,
    this.apartmentFeatures,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'apartmentFeatures', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto?
      apartmentFeatures;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.apartmentFeatures, apartmentFeatures) ||
                const DeepCollectionEquality()
                    .equals(other.apartmentFeatures, apartmentFeatures)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(apartmentFeatures) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDtoExtension
    on CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto copyWith(
      {String? reference,
      enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      String? notes,
      CRMAPIProfilesDtoForSaleApartmentApartmentFeaturesDto? apartmentFeatures,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoForSaleApartmentApartmentForSaleProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        maturity: maturity ?? this.maturity,
        notes: notes ?? this.notes,
        apartmentFeatures: apartmentFeatures ?? this.apartmentFeatures,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto {
  CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto({
    this.price,
    this.agentFees,
    this.taxProperty,
  });

  factory CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDtoFromJson(json);

  @JsonKey(name: 'price', includeIfNull: false)
  final double? price;
  @JsonKey(name: 'agentFees', includeIfNull: false)
  final double? agentFees;
  @JsonKey(name: 'taxProperty', includeIfNull: false)
  final double? taxProperty;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.agentFees, agentFees) ||
                const DeepCollectionEquality()
                    .equals(other.agentFees, agentFees)) &&
            (identical(other.taxProperty, taxProperty) ||
                const DeepCollectionEquality()
                    .equals(other.taxProperty, taxProperty)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(agentFees) ^
      const DeepCollectionEquality().hash(taxProperty) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDtoExtension
    on CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto {
  CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto copyWith(
      {double? price, double? agentFees, double? taxProperty}) {
    return CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto(
        price: price ?? this.price,
        agentFees: agentFees ?? this.agentFees,
        taxProperty: taxProperty ?? this.taxProperty);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto {
  CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto({
    this.address,
    this.financialInfo,
    this.propertyInfo,
    this.amenities,
    this.parts,
  });

  factory CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleHouseHouseFeaturesDtoFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address;
  @JsonKey(name: 'financialInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto? financialInfo;
  @JsonKey(name: 'propertyInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonPropertyInfoDto? propertyInfo;
  @JsonKey(
      name: 'amenities',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListToJson,
      fromJson: cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
      amenities;
  @JsonKey(name: 'parts', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonPartsDto? parts;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleHouseHouseFeaturesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleHouseHouseFeaturesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleHouseHouseFeaturesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.financialInfo, financialInfo) ||
                const DeepCollectionEquality()
                    .equals(other.financialInfo, financialInfo)) &&
            (identical(other.propertyInfo, propertyInfo) ||
                const DeepCollectionEquality()
                    .equals(other.propertyInfo, propertyInfo)) &&
            (identical(other.amenities, amenities) ||
                const DeepCollectionEquality()
                    .equals(other.amenities, amenities)) &&
            (identical(other.parts, parts) ||
                const DeepCollectionEquality().equals(other.parts, parts)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(financialInfo) ^
      const DeepCollectionEquality().hash(propertyInfo) ^
      const DeepCollectionEquality().hash(amenities) ^
      const DeepCollectionEquality().hash(parts) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleHouseHouseFeaturesDtoExtension
    on CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto {
  CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address,
      CRMAPIProfilesDtoForSaleHouseHouseFinancialInfoDto? financialInfo,
      CRMAPIProfilesDtoForSaleCommonPropertyInfoDto? propertyInfo,
      List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
          amenities,
      CRMAPIProfilesDtoForSaleCommonPartsDto? parts}) {
    return CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto(
        address: address ?? this.address,
        financialInfo: financialInfo ?? this.financialInfo,
        propertyInfo: propertyInfo ?? this.propertyInfo,
        amenities: amenities ?? this.amenities,
        parts: parts ?? this.parts);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto({
    this.reference,
    this.account,
    this.maturity,
    this.creationDate,
    this.notes,
    this.houseFeatures,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDtoFromJson(json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'houseFeatures', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto? houseFeatures;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.houseFeatures, houseFeatures) ||
                const DeepCollectionEquality()
                    .equals(other.houseFeatures, houseFeatures)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(houseFeatures) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDtoExtension
    on CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto copyWith(
      {String? reference,
      enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      DateTime? creationDate,
      String? notes,
      CRMAPIProfilesDtoForSaleHouseHouseFeaturesDto? houseFeatures,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoForSaleHouseHouseForSaleProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        maturity: maturity ?? this.maturity,
        creationDate: creationDate ?? this.creationDate,
        notes: notes ?? this.notes,
        houseFeatures: houseFeatures ?? this.houseFeatures,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto {
  CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto({
    this.price,
    this.agentFees,
    this.taxProperty,
    this.condominiumFees,
  });

  factory CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDtoFromJson(json);

  @JsonKey(name: 'price', includeIfNull: false)
  final double? price;
  @JsonKey(name: 'agentFees', includeIfNull: false)
  final double? agentFees;
  @JsonKey(name: 'taxProperty', includeIfNull: false)
  final double? taxProperty;
  @JsonKey(name: 'condominiumFees', includeIfNull: false)
  final double? condominiumFees;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.agentFees, agentFees) ||
                const DeepCollectionEquality()
                    .equals(other.agentFees, agentFees)) &&
            (identical(other.taxProperty, taxProperty) ||
                const DeepCollectionEquality()
                    .equals(other.taxProperty, taxProperty)) &&
            (identical(other.condominiumFees, condominiumFees) ||
                const DeepCollectionEquality()
                    .equals(other.condominiumFees, condominiumFees)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(agentFees) ^
      const DeepCollectionEquality().hash(taxProperty) ^
      const DeepCollectionEquality().hash(condominiumFees) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDtoExtension
    on CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto {
  CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto copyWith(
      {double? price,
      double? agentFees,
      double? taxProperty,
      double? condominiumFees}) {
    return CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto(
        price: price ?? this.price,
        agentFees: agentFees ?? this.agentFees,
        taxProperty: taxProperty ?? this.taxProperty,
        condominiumFees: condominiumFees ?? this.condominiumFees);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto {
  CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto({
    this.squareMeter,
    this.parkingJoinOwnership,
    this.boxableParking,
    this.spacesNumber,
    this.height,
    this.width,
    this.length,
  });

  factory CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDtoFromJson(json);

  @JsonKey(name: 'squareMeter', includeIfNull: false)
  final double? squareMeter;
  @JsonKey(name: 'parkingJoinOwnership', includeIfNull: false)
  final bool? parkingJoinOwnership;
  @JsonKey(name: 'boxableParking', includeIfNull: false)
  final bool? boxableParking;
  @JsonKey(name: 'spacesNumber', includeIfNull: false)
  final double? spacesNumber;
  @JsonKey(name: 'height', includeIfNull: false)
  final double? height;
  @JsonKey(name: 'width', includeIfNull: false)
  final double? width;
  @JsonKey(name: 'length', includeIfNull: false)
  final double? length;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto &&
            (identical(other.squareMeter, squareMeter) ||
                const DeepCollectionEquality()
                    .equals(other.squareMeter, squareMeter)) &&
            (identical(other.parkingJoinOwnership, parkingJoinOwnership) ||
                const DeepCollectionEquality().equals(
                    other.parkingJoinOwnership, parkingJoinOwnership)) &&
            (identical(other.boxableParking, boxableParking) ||
                const DeepCollectionEquality()
                    .equals(other.boxableParking, boxableParking)) &&
            (identical(other.spacesNumber, spacesNumber) ||
                const DeepCollectionEquality()
                    .equals(other.spacesNumber, spacesNumber)) &&
            (identical(other.height, height) ||
                const DeepCollectionEquality().equals(other.height, height)) &&
            (identical(other.width, width) ||
                const DeepCollectionEquality().equals(other.width, width)) &&
            (identical(other.length, length) ||
                const DeepCollectionEquality().equals(other.length, length)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(squareMeter) ^
      const DeepCollectionEquality().hash(parkingJoinOwnership) ^
      const DeepCollectionEquality().hash(boxableParking) ^
      const DeepCollectionEquality().hash(spacesNumber) ^
      const DeepCollectionEquality().hash(height) ^
      const DeepCollectionEquality().hash(width) ^
      const DeepCollectionEquality().hash(length) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDtoExtension
    on CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto {
  CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto copyWith(
      {double? squareMeter,
      bool? parkingJoinOwnership,
      bool? boxableParking,
      double? spacesNumber,
      double? height,
      double? width,
      double? length}) {
    return CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto(
        squareMeter: squareMeter ?? this.squareMeter,
        parkingJoinOwnership: parkingJoinOwnership ?? this.parkingJoinOwnership,
        boxableParking: boxableParking ?? this.boxableParking,
        spacesNumber: spacesNumber ?? this.spacesNumber,
        height: height ?? this.height,
        width: width ?? this.width,
        length: length ?? this.length);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto {
  CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto({
    this.rent,
    this.rented,
  });

  factory CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDtoFromJson(json);

  @JsonKey(name: 'rent', includeIfNull: false)
  final double? rent;
  @JsonKey(name: 'rented', includeIfNull: false)
  final bool? rented;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto &&
            (identical(other.rent, rent) ||
                const DeepCollectionEquality().equals(other.rent, rent)) &&
            (identical(other.rented, rented) ||
                const DeepCollectionEquality().equals(other.rented, rented)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(rent) ^
      const DeepCollectionEquality().hash(rented) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDtoExtension
    on CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto {
  CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto copyWith(
      {double? rent, bool? rented}) {
    return CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto(
        rent: rent ?? this.rent, rented: rented ?? this.rented);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto {
  CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto({
    this.address,
    this.parkingFinancialInfo,
    this.parkingPropertyInfo,
    this.parkingRentedInfo,
    this.parkingAmenities,
    this.parkingKind,
  });

  factory CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleParkingParkingFeaturesDtoFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address;
  @JsonKey(name: 'parkingFinancialInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto?
      parkingFinancialInfo;
  @JsonKey(name: 'parkingPropertyInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto?
      parkingPropertyInfo;
  @JsonKey(name: 'parkingRentedInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto? parkingRentedInfo;
  @JsonKey(
      name: 'parkingAmenities',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeListFromJson)
  final List<
          enums
              .CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType>?
      parkingAmenities;
  @JsonKey(
      name: 'parkingKind',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType?
      parkingKind;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingFeaturesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingFeaturesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleParkingParkingFeaturesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.parkingFinancialInfo, parkingFinancialInfo) ||
                const DeepCollectionEquality().equals(
                    other.parkingFinancialInfo, parkingFinancialInfo)) &&
            (identical(other.parkingPropertyInfo, parkingPropertyInfo) ||
                const DeepCollectionEquality()
                    .equals(other.parkingPropertyInfo, parkingPropertyInfo)) &&
            (identical(other.parkingRentedInfo, parkingRentedInfo) ||
                const DeepCollectionEquality()
                    .equals(other.parkingRentedInfo, parkingRentedInfo)) &&
            (identical(other.parkingAmenities, parkingAmenities) ||
                const DeepCollectionEquality()
                    .equals(other.parkingAmenities, parkingAmenities)) &&
            (identical(other.parkingKind, parkingKind) ||
                const DeepCollectionEquality()
                    .equals(other.parkingKind, parkingKind)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(parkingFinancialInfo) ^
      const DeepCollectionEquality().hash(parkingPropertyInfo) ^
      const DeepCollectionEquality().hash(parkingRentedInfo) ^
      const DeepCollectionEquality().hash(parkingAmenities) ^
      const DeepCollectionEquality().hash(parkingKind) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleParkingParkingFeaturesDtoExtension
    on CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto {
  CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address,
      CRMAPIProfilesDtoForSaleParkingParkingFinancialInfoDto?
          parkingFinancialInfo,
      CRMAPIProfilesDtoForSaleParkingParkingPropertyInfoDto?
          parkingPropertyInfo,
      CRMAPIProfilesDtoForSaleParkingParkingRentedInfoDto? parkingRentedInfo,
      List<enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType>?
          parkingAmenities,
      enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType?
          parkingKind}) {
    return CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto(
        address: address ?? this.address,
        parkingFinancialInfo: parkingFinancialInfo ?? this.parkingFinancialInfo,
        parkingPropertyInfo: parkingPropertyInfo ?? this.parkingPropertyInfo,
        parkingRentedInfo: parkingRentedInfo ?? this.parkingRentedInfo,
        parkingAmenities: parkingAmenities ?? this.parkingAmenities,
        parkingKind: parkingKind ?? this.parkingKind);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto({
    this.account,
    this.reference,
    this.maturity,
    this.creationDate,
    this.notes,
    this.parkingFeatures,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'parkingFeatures', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto? parkingFeatures;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.parkingFeatures, parkingFeatures) ||
                const DeepCollectionEquality()
                    .equals(other.parkingFeatures, parkingFeatures)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(parkingFeatures) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDtoExtension
    on CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      DateTime? creationDate,
      String? notes,
      CRMAPIProfilesDtoForSaleParkingParkingFeaturesDto? parkingFeatures,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoForSaleParkingParkingForSaleProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        maturity: maturity ?? this.maturity,
        creationDate: creationDate ?? this.creationDate,
        notes: notes ?? this.notes,
        parkingFeatures: parkingFeatures ?? this.parkingFeatures,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto({
    this.price,
    this.agentFees,
    this.taxProperty,
    this.expensesEstimation,
  });

  factory CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDtoFromJson(json);

  @JsonKey(name: 'price', includeIfNull: false)
  final double? price;
  @JsonKey(name: 'agentFees', includeIfNull: false)
  final double? agentFees;
  @JsonKey(name: 'taxProperty', includeIfNull: false)
  final double? taxProperty;
  @JsonKey(name: 'expensesEstimation', includeIfNull: false)
  final double? expensesEstimation;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.agentFees, agentFees) ||
                const DeepCollectionEquality()
                    .equals(other.agentFees, agentFees)) &&
            (identical(other.taxProperty, taxProperty) ||
                const DeepCollectionEquality()
                    .equals(other.taxProperty, taxProperty)) &&
            (identical(other.expensesEstimation, expensesEstimation) ||
                const DeepCollectionEquality()
                    .equals(other.expensesEstimation, expensesEstimation)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(agentFees) ^
      const DeepCollectionEquality().hash(taxProperty) ^
      const DeepCollectionEquality().hash(expensesEstimation) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDtoExtension
    on CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto copyWith(
      {double? price,
      double? agentFees,
      double? taxProperty,
      double? expensesEstimation}) {
    return CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto(
        price: price ?? this.price,
        agentFees: agentFees ?? this.agentFees,
        taxProperty: taxProperty ?? this.taxProperty,
        expensesEstimation: expensesEstimation ?? this.expensesEstimation);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto({
    this.squareMeter,
    this.generalState,
    this.constructionYear,
    this.lotsNumber,
    this.floorsNumber,
    this.lastRenovationDate,
    this.jointOwnership,
    this.ongoingProcedure,
  });

  factory CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDtoFromJson(json);

  @JsonKey(name: 'squareMeter', includeIfNull: false)
  final double? squareMeter;
  @JsonKey(
      name: 'generalState',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType?
      generalState;
  @JsonKey(name: 'constructionYear', includeIfNull: false)
  final int? constructionYear;
  @JsonKey(name: 'lotsNumber', includeIfNull: false)
  final int? lotsNumber;
  @JsonKey(name: 'floorsNumber', includeIfNull: false)
  final int? floorsNumber;
  @JsonKey(name: 'lastRenovationDate', includeIfNull: false)
  final DateTime? lastRenovationDate;
  @JsonKey(name: 'jointOwnership', includeIfNull: false)
  final bool? jointOwnership;
  @JsonKey(name: 'ongoingProcedure', includeIfNull: false)
  final bool? ongoingProcedure;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto &&
            (identical(other.squareMeter, squareMeter) ||
                const DeepCollectionEquality()
                    .equals(other.squareMeter, squareMeter)) &&
            (identical(other.generalState, generalState) ||
                const DeepCollectionEquality()
                    .equals(other.generalState, generalState)) &&
            (identical(other.constructionYear, constructionYear) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYear, constructionYear)) &&
            (identical(other.lotsNumber, lotsNumber) ||
                const DeepCollectionEquality()
                    .equals(other.lotsNumber, lotsNumber)) &&
            (identical(other.floorsNumber, floorsNumber) ||
                const DeepCollectionEquality()
                    .equals(other.floorsNumber, floorsNumber)) &&
            (identical(other.lastRenovationDate, lastRenovationDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastRenovationDate, lastRenovationDate)) &&
            (identical(other.jointOwnership, jointOwnership) ||
                const DeepCollectionEquality()
                    .equals(other.jointOwnership, jointOwnership)) &&
            (identical(other.ongoingProcedure, ongoingProcedure) ||
                const DeepCollectionEquality()
                    .equals(other.ongoingProcedure, ongoingProcedure)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(squareMeter) ^
      const DeepCollectionEquality().hash(generalState) ^
      const DeepCollectionEquality().hash(constructionYear) ^
      const DeepCollectionEquality().hash(lotsNumber) ^
      const DeepCollectionEquality().hash(floorsNumber) ^
      const DeepCollectionEquality().hash(lastRenovationDate) ^
      const DeepCollectionEquality().hash(jointOwnership) ^
      const DeepCollectionEquality().hash(ongoingProcedure) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDtoExtension
    on CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto copyWith(
      {double? squareMeter,
      enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType?
          generalState,
      int? constructionYear,
      int? lotsNumber,
      int? floorsNumber,
      DateTime? lastRenovationDate,
      bool? jointOwnership,
      bool? ongoingProcedure}) {
    return CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto(
        squareMeter: squareMeter ?? this.squareMeter,
        generalState: generalState ?? this.generalState,
        constructionYear: constructionYear ?? this.constructionYear,
        lotsNumber: lotsNumber ?? this.lotsNumber,
        floorsNumber: floorsNumber ?? this.floorsNumber,
        lastRenovationDate: lastRenovationDate ?? this.lastRenovationDate,
        jointOwnership: jointOwnership ?? this.jointOwnership,
        ongoingProcedure: ongoingProcedure ?? this.ongoingProcedure);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto({
    this.rented,
    this.lotsNumber,
    this.totalGrossIncome,
    this.residentialGrossIncome,
    this.commercialGrossIncome,
  });

  factory CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDtoFromJson(json);

  @JsonKey(name: 'rented', includeIfNull: false)
  final bool? rented;
  @JsonKey(name: 'lotsNumber', includeIfNull: false)
  final int? lotsNumber;
  @JsonKey(name: 'totalGrossIncome', includeIfNull: false)
  final double? totalGrossIncome;
  @JsonKey(name: 'residentialGrossIncome', includeIfNull: false)
  final double? residentialGrossIncome;
  @JsonKey(name: 'commercialGrossIncome', includeIfNull: false)
  final double? commercialGrossIncome;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto &&
            (identical(other.rented, rented) ||
                const DeepCollectionEquality().equals(other.rented, rented)) &&
            (identical(other.lotsNumber, lotsNumber) ||
                const DeepCollectionEquality()
                    .equals(other.lotsNumber, lotsNumber)) &&
            (identical(other.totalGrossIncome, totalGrossIncome) ||
                const DeepCollectionEquality()
                    .equals(other.totalGrossIncome, totalGrossIncome)) &&
            (identical(other.residentialGrossIncome, residentialGrossIncome) ||
                const DeepCollectionEquality().equals(
                    other.residentialGrossIncome, residentialGrossIncome)) &&
            (identical(other.commercialGrossIncome, commercialGrossIncome) ||
                const DeepCollectionEquality().equals(
                    other.commercialGrossIncome, commercialGrossIncome)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(rented) ^
      const DeepCollectionEquality().hash(lotsNumber) ^
      const DeepCollectionEquality().hash(totalGrossIncome) ^
      const DeepCollectionEquality().hash(residentialGrossIncome) ^
      const DeepCollectionEquality().hash(commercialGrossIncome) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDtoExtension
    on CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto copyWith(
      {bool? rented,
      int? lotsNumber,
      double? totalGrossIncome,
      double? residentialGrossIncome,
      double? commercialGrossIncome}) {
    return CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto(
        rented: rented ?? this.rented,
        lotsNumber: lotsNumber ?? this.lotsNumber,
        totalGrossIncome: totalGrossIncome ?? this.totalGrossIncome,
        residentialGrossIncome:
            residentialGrossIncome ?? this.residentialGrossIncome,
        commercialGrossIncome:
            commercialGrossIncome ?? this.commercialGrossIncome);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto({
    this.basementsNumber,
    this.serviceRoomsNumber,
  });

  factory CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDtoFromJson(json);

  @JsonKey(name: 'basementsNumber', includeIfNull: false)
  final int? basementsNumber;
  @JsonKey(name: 'serviceRoomsNumber', includeIfNull: false)
  final int? serviceRoomsNumber;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto &&
            (identical(other.basementsNumber, basementsNumber) ||
                const DeepCollectionEquality()
                    .equals(other.basementsNumber, basementsNumber)) &&
            (identical(other.serviceRoomsNumber, serviceRoomsNumber) ||
                const DeepCollectionEquality()
                    .equals(other.serviceRoomsNumber, serviceRoomsNumber)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(basementsNumber) ^
      const DeepCollectionEquality().hash(serviceRoomsNumber) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDtoExtension
    on CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto copyWith(
      {int? basementsNumber, int? serviceRoomsNumber}) {
    return CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto(
        basementsNumber: basementsNumber ?? this.basementsNumber,
        serviceRoomsNumber: serviceRoomsNumber ?? this.serviceRoomsNumber);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto({
    this.address,
    this.buildingFinancialInfo,
    this.buildingPropertyInfo,
    this.buildingRentedInfo,
    this.lots,
    this.amenities,
    this.parkingInfo,
    this.buildingAnnexes,
    this.buildingKind,
  });

  factory CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDtoFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address;
  @JsonKey(name: 'buildingFinancialInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto?
      buildingFinancialInfo;
  @JsonKey(name: 'buildingPropertyInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto?
      buildingPropertyInfo;
  @JsonKey(name: 'buildingRentedInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto?
      buildingRentedInfo;
  @JsonKey(
      name: 'lots',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeListToJson,
      fromJson: cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType>? lots;
  @JsonKey(
      name: 'amenities',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListToJson,
      fromJson: cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
      amenities;
  @JsonKey(name: 'parkingInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonParkingsDto? parkingInfo;
  @JsonKey(name: 'buildingAnnexes', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto? buildingAnnexes;
  @JsonKey(
      name: 'buildingKind',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType?
      buildingKind;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.buildingFinancialInfo, buildingFinancialInfo) ||
                const DeepCollectionEquality().equals(
                    other.buildingFinancialInfo, buildingFinancialInfo)) &&
            (identical(other.buildingPropertyInfo, buildingPropertyInfo) ||
                const DeepCollectionEquality().equals(
                    other.buildingPropertyInfo, buildingPropertyInfo)) &&
            (identical(other.buildingRentedInfo, buildingRentedInfo) ||
                const DeepCollectionEquality()
                    .equals(other.buildingRentedInfo, buildingRentedInfo)) &&
            (identical(other.lots, lots) ||
                const DeepCollectionEquality().equals(other.lots, lots)) &&
            (identical(other.amenities, amenities) ||
                const DeepCollectionEquality()
                    .equals(other.amenities, amenities)) &&
            (identical(other.parkingInfo, parkingInfo) ||
                const DeepCollectionEquality()
                    .equals(other.parkingInfo, parkingInfo)) &&
            (identical(other.buildingAnnexes, buildingAnnexes) ||
                const DeepCollectionEquality()
                    .equals(other.buildingAnnexes, buildingAnnexes)) &&
            (identical(other.buildingKind, buildingKind) ||
                const DeepCollectionEquality()
                    .equals(other.buildingKind, buildingKind)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(buildingFinancialInfo) ^
      const DeepCollectionEquality().hash(buildingPropertyInfo) ^
      const DeepCollectionEquality().hash(buildingRentedInfo) ^
      const DeepCollectionEquality().hash(lots) ^
      const DeepCollectionEquality().hash(amenities) ^
      const DeepCollectionEquality().hash(parkingInfo) ^
      const DeepCollectionEquality().hash(buildingAnnexes) ^
      const DeepCollectionEquality().hash(buildingKind) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDtoExtension
    on CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address,
      CRMAPIProfilesDtoForSaleBuildingBuildingFinancialInfoDto?
          buildingFinancialInfo,
      CRMAPIProfilesDtoForSaleBuildingBuildingPropertyInfoDto?
          buildingPropertyInfo,
      CRMAPIProfilesDtoForSaleBuildingBuildingRentedInfoDto? buildingRentedInfo,
      List<enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType>? lots,
      List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
          amenities,
      CRMAPIProfilesDtoForSaleCommonParkingsDto? parkingInfo,
      CRMAPIProfilesDtoForSaleBuildingBuildingAnnexesDto? buildingAnnexes,
      enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType?
          buildingKind}) {
    return CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto(
        address: address ?? this.address,
        buildingFinancialInfo:
            buildingFinancialInfo ?? this.buildingFinancialInfo,
        buildingPropertyInfo: buildingPropertyInfo ?? this.buildingPropertyInfo,
        buildingRentedInfo: buildingRentedInfo ?? this.buildingRentedInfo,
        lots: lots ?? this.lots,
        amenities: amenities ?? this.amenities,
        parkingInfo: parkingInfo ?? this.parkingInfo,
        buildingAnnexes: buildingAnnexes ?? this.buildingAnnexes,
        buildingKind: buildingKind ?? this.buildingKind);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto({
    this.reference,
    this.account,
    this.maturity,
    this.notes,
    this.buildingFeatures,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'buildingFeatures', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto? buildingFeatures;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.buildingFeatures, buildingFeatures) ||
                const DeepCollectionEquality()
                    .equals(other.buildingFeatures, buildingFeatures)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(buildingFeatures) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDtoExtension
    on CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto copyWith(
      {String? reference,
      enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      String? notes,
      CRMAPIProfilesDtoForSaleBuildingBuildingFeaturesDto? buildingFeatures,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoForSaleBuildingBuildingForSaleProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        maturity: maturity ?? this.maturity,
        notes: notes ?? this.notes,
        buildingFeatures: buildingFeatures ?? this.buildingFeatures,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto {
  CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto({
    this.price,
    this.agentFees,
  });

  factory CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleLandLandFinancialInfoDtoFromJson(json);

  @JsonKey(name: 'price', includeIfNull: false)
  final double? price;
  @JsonKey(name: 'agentFees', includeIfNull: false)
  final double? agentFees;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandFinancialInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandFinancialInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleLandLandFinancialInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto &&
            (identical(other.price, price) ||
                const DeepCollectionEquality().equals(other.price, price)) &&
            (identical(other.agentFees, agentFees) ||
                const DeepCollectionEquality()
                    .equals(other.agentFees, agentFees)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(price) ^
      const DeepCollectionEquality().hash(agentFees) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleLandLandFinancialInfoDtoExtension
    on CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto {
  CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto copyWith(
      {double? price, double? agentFees}) {
    return CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto(
        price: price ?? this.price, agentFees: agentFees ?? this.agentFees);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto {
  CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto({
    this.squareMeter,
    this.frontLength,
  });

  factory CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleLandLandPropertyInfoDtoFromJson(json);

  @JsonKey(name: 'squareMeter', includeIfNull: false)
  final double? squareMeter;
  @JsonKey(name: 'frontLength', includeIfNull: false)
  final double? frontLength;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandPropertyInfoDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandPropertyInfoDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleLandLandPropertyInfoDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto &&
            (identical(other.squareMeter, squareMeter) ||
                const DeepCollectionEquality()
                    .equals(other.squareMeter, squareMeter)) &&
            (identical(other.frontLength, frontLength) ||
                const DeepCollectionEquality()
                    .equals(other.frontLength, frontLength)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(squareMeter) ^
      const DeepCollectionEquality().hash(frontLength) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleLandLandPropertyInfoDtoExtension
    on CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto {
  CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto copyWith(
      {double? squareMeter, double? frontLength}) {
    return CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto(
        squareMeter: squareMeter ?? this.squareMeter,
        frontLength: frontLength ?? this.frontLength);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleLandLandFeaturesDto {
  CRMAPIProfilesDtoForSaleLandLandFeaturesDto({
    this.address,
    this.landFinancialInfo,
    this.landPropertyInfo,
    this.landAmenities,
    this.landKind,
    this.landRelief,
    this.landConnections,
  });

  factory CRMAPIProfilesDtoForSaleLandLandFeaturesDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleLandLandFeaturesDtoFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address;
  @JsonKey(name: 'landFinancialInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto? landFinancialInfo;
  @JsonKey(name: 'landPropertyInfo', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto? landPropertyInfo;
  @JsonKey(
      name: 'landAmenities',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType>?
      landAmenities;
  @JsonKey(
      name: 'landKind',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeToJson,
      fromJson: cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType? landKind;
  @JsonKey(
      name: 'landRelief',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeToJson,
      fromJson: cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeFromJson)
  final enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType?
      landRelief;
  @JsonKey(
      name: 'landConnections',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeListFromJson)
  final List<
          enums
              .CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType>?
      landConnections;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandFeaturesDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandFeaturesDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleLandLandFeaturesDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleLandLandFeaturesDto &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.landFinancialInfo, landFinancialInfo) ||
                const DeepCollectionEquality()
                    .equals(other.landFinancialInfo, landFinancialInfo)) &&
            (identical(other.landPropertyInfo, landPropertyInfo) ||
                const DeepCollectionEquality()
                    .equals(other.landPropertyInfo, landPropertyInfo)) &&
            (identical(other.landAmenities, landAmenities) ||
                const DeepCollectionEquality()
                    .equals(other.landAmenities, landAmenities)) &&
            (identical(other.landKind, landKind) ||
                const DeepCollectionEquality()
                    .equals(other.landKind, landKind)) &&
            (identical(other.landRelief, landRelief) ||
                const DeepCollectionEquality()
                    .equals(other.landRelief, landRelief)) &&
            (identical(other.landConnections, landConnections) ||
                const DeepCollectionEquality()
                    .equals(other.landConnections, landConnections)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(landFinancialInfo) ^
      const DeepCollectionEquality().hash(landPropertyInfo) ^
      const DeepCollectionEquality().hash(landAmenities) ^
      const DeepCollectionEquality().hash(landKind) ^
      const DeepCollectionEquality().hash(landRelief) ^
      const DeepCollectionEquality().hash(landConnections) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleLandLandFeaturesDtoExtension
    on CRMAPIProfilesDtoForSaleLandLandFeaturesDto {
  CRMAPIProfilesDtoForSaleLandLandFeaturesDto copyWith(
      {CRMAPIProfilesDtoForSaleCommonProfileAddressDto? address,
      CRMAPIProfilesDtoForSaleLandLandFinancialInfoDto? landFinancialInfo,
      CRMAPIProfilesDtoForSaleLandLandPropertyInfoDto? landPropertyInfo,
      List<enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType>?
          landAmenities,
      enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType? landKind,
      enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType? landRelief,
      List<enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType>?
          landConnections}) {
    return CRMAPIProfilesDtoForSaleLandLandFeaturesDto(
        address: address ?? this.address,
        landFinancialInfo: landFinancialInfo ?? this.landFinancialInfo,
        landPropertyInfo: landPropertyInfo ?? this.landPropertyInfo,
        landAmenities: landAmenities ?? this.landAmenities,
        landKind: landKind ?? this.landKind,
        landRelief: landRelief ?? this.landRelief,
        landConnections: landConnections ?? this.landConnections);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto({
    this.account,
    this.reference,
    this.maturity,
    this.creationDate,
    this.notes,
    this.landFeatures,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDtoFromJson(json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'landFeatures', includeIfNull: false)
  final CRMAPIProfilesDtoForSaleLandLandFeaturesDto? landFeatures;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.landFeatures, landFeatures) ||
                const DeepCollectionEquality()
                    .equals(other.landFeatures, landFeatures)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(landFeatures) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDtoExtension
    on CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto {
  CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      DateTime? creationDate,
      String? notes,
      CRMAPIProfilesDtoForSaleLandLandFeaturesDto? landFeatures,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoForSaleLandLandForSaleProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        maturity: maturity ?? this.maturity,
        creationDate: creationDate ?? this.creationDate,
        notes: notes ?? this.notes,
        landFeatures: landFeatures ?? this.landFeatures,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterIdentityDto {
  CRMAPIHuntersControllersDtoHunterIdentityDto({
    this.civiliteEnum,
    this.nom,
    this.prenom,
    this.email,
    this.telephone,
    this.souhaiteEtreContacte,
    this.notes,
  });

  factory CRMAPIHuntersControllersDtoHunterIdentityDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterIdentityDtoFromJson(json);

  @JsonKey(name: 'civiliteEnum', includeIfNull: false, defaultValue: '')
  final String? civiliteEnum;
  @JsonKey(name: 'nom', includeIfNull: false, defaultValue: '')
  final String? nom;
  @JsonKey(name: 'prenom', includeIfNull: false, defaultValue: '')
  final String? prenom;
  @JsonKey(name: 'email', includeIfNull: false, defaultValue: '')
  final String? email;
  @JsonKey(name: 'telephone', includeIfNull: false, defaultValue: '')
  final String? telephone;
  @JsonKey(name: 'souhaiteEtreContacte', includeIfNull: false)
  final bool? souhaiteEtreContacte;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterIdentityDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterIdentityDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterIdentityDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterIdentityDto &&
            (identical(other.civiliteEnum, civiliteEnum) ||
                const DeepCollectionEquality()
                    .equals(other.civiliteEnum, civiliteEnum)) &&
            (identical(other.nom, nom) ||
                const DeepCollectionEquality().equals(other.nom, nom)) &&
            (identical(other.prenom, prenom) ||
                const DeepCollectionEquality().equals(other.prenom, prenom)) &&
            (identical(other.email, email) ||
                const DeepCollectionEquality().equals(other.email, email)) &&
            (identical(other.telephone, telephone) ||
                const DeepCollectionEquality()
                    .equals(other.telephone, telephone)) &&
            (identical(other.souhaiteEtreContacte, souhaiteEtreContacte) ||
                const DeepCollectionEquality().equals(
                    other.souhaiteEtreContacte, souhaiteEtreContacte)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(civiliteEnum) ^
      const DeepCollectionEquality().hash(nom) ^
      const DeepCollectionEquality().hash(prenom) ^
      const DeepCollectionEquality().hash(email) ^
      const DeepCollectionEquality().hash(telephone) ^
      const DeepCollectionEquality().hash(souhaiteEtreContacte) ^
      const DeepCollectionEquality().hash(notes) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterIdentityDtoExtension
    on CRMAPIHuntersControllersDtoHunterIdentityDto {
  CRMAPIHuntersControllersDtoHunterIdentityDto copyWith(
      {String? civiliteEnum,
      String? nom,
      String? prenom,
      String? email,
      String? telephone,
      bool? souhaiteEtreContacte,
      String? notes}) {
    return CRMAPIHuntersControllersDtoHunterIdentityDto(
        civiliteEnum: civiliteEnum ?? this.civiliteEnum,
        nom: nom ?? this.nom,
        prenom: prenom ?? this.prenom,
        email: email ?? this.email,
        telephone: telephone ?? this.telephone,
        souhaiteEtreContacte: souhaiteEtreContacte ?? this.souhaiteEtreContacte,
        notes: notes ?? this.notes);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterCityDto {
  CRMAPIHuntersControllersDtoHunterCityDto({
    this.id,
    this.ville,
    this.codeDepartement,
    this.departement,
    this.region,
    this.codesPostaux,
    this.latitude,
    this.longitude,
    this.codeInsee,
  });

  factory CRMAPIHuntersControllersDtoHunterCityDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterCityDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'ville', includeIfNull: false, defaultValue: '')
  final String? ville;
  @JsonKey(name: 'codeDepartement', includeIfNull: false, defaultValue: '')
  final String? codeDepartement;
  @JsonKey(name: 'departement', includeIfNull: false, defaultValue: '')
  final String? departement;
  @JsonKey(name: 'region', includeIfNull: false, defaultValue: '')
  final String? region;
  @JsonKey(name: 'codesPostaux', includeIfNull: false, defaultValue: <String>[])
  final List<String>? codesPostaux;
  @JsonKey(name: 'latitude', includeIfNull: false)
  final double? latitude;
  @JsonKey(name: 'longitude', includeIfNull: false)
  final double? longitude;
  @JsonKey(name: 'codeInsee', includeIfNull: false, defaultValue: '')
  final String? codeInsee;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterCityDtoFromJson;
  static const toJsonFactory = _$CRMAPIHuntersControllersDtoHunterCityDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterCityDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterCityDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.ville, ville) ||
                const DeepCollectionEquality().equals(other.ville, ville)) &&
            (identical(other.codeDepartement, codeDepartement) ||
                const DeepCollectionEquality()
                    .equals(other.codeDepartement, codeDepartement)) &&
            (identical(other.departement, departement) ||
                const DeepCollectionEquality()
                    .equals(other.departement, departement)) &&
            (identical(other.region, region) ||
                const DeepCollectionEquality().equals(other.region, region)) &&
            (identical(other.codesPostaux, codesPostaux) ||
                const DeepCollectionEquality()
                    .equals(other.codesPostaux, codesPostaux)) &&
            (identical(other.latitude, latitude) ||
                const DeepCollectionEquality()
                    .equals(other.latitude, latitude)) &&
            (identical(other.longitude, longitude) ||
                const DeepCollectionEquality()
                    .equals(other.longitude, longitude)) &&
            (identical(other.codeInsee, codeInsee) ||
                const DeepCollectionEquality()
                    .equals(other.codeInsee, codeInsee)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(ville) ^
      const DeepCollectionEquality().hash(codeDepartement) ^
      const DeepCollectionEquality().hash(departement) ^
      const DeepCollectionEquality().hash(region) ^
      const DeepCollectionEquality().hash(codesPostaux) ^
      const DeepCollectionEquality().hash(latitude) ^
      const DeepCollectionEquality().hash(longitude) ^
      const DeepCollectionEquality().hash(codeInsee) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterCityDtoExtension
    on CRMAPIHuntersControllersDtoHunterCityDto {
  CRMAPIHuntersControllersDtoHunterCityDto copyWith(
      {String? id,
      String? ville,
      String? codeDepartement,
      String? departement,
      String? region,
      List<String>? codesPostaux,
      double? latitude,
      double? longitude,
      String? codeInsee}) {
    return CRMAPIHuntersControllersDtoHunterCityDto(
        id: id ?? this.id,
        ville: ville ?? this.ville,
        codeDepartement: codeDepartement ?? this.codeDepartement,
        departement: departement ?? this.departement,
        region: region ?? this.region,
        codesPostaux: codesPostaux ?? this.codesPostaux,
        latitude: latitude ?? this.latitude,
        longitude: longitude ?? this.longitude,
        codeInsee: codeInsee ?? this.codeInsee);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterAddressDto {
  CRMAPIHuntersControllersDtoHunterAddressDto({
    this.adresse,
    this.complementAdresse,
    this.ville,
    this.villeLegacy,
  });

  factory CRMAPIHuntersControllersDtoHunterAddressDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterAddressDtoFromJson(json);

  @JsonKey(name: 'adresse', includeIfNull: false, defaultValue: '')
  final String? adresse;
  @JsonKey(name: 'complementAdresse', includeIfNull: false, defaultValue: '')
  final String? complementAdresse;
  @JsonKey(name: 'ville', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterCityDto? ville;
  @JsonKey(name: 'villeLegacy', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterCityDto? villeLegacy;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterAddressDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterAddressDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterAddressDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterAddressDto &&
            (identical(other.adresse, adresse) ||
                const DeepCollectionEquality()
                    .equals(other.adresse, adresse)) &&
            (identical(other.complementAdresse, complementAdresse) ||
                const DeepCollectionEquality()
                    .equals(other.complementAdresse, complementAdresse)) &&
            (identical(other.ville, ville) ||
                const DeepCollectionEquality().equals(other.ville, ville)) &&
            (identical(other.villeLegacy, villeLegacy) ||
                const DeepCollectionEquality()
                    .equals(other.villeLegacy, villeLegacy)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(adresse) ^
      const DeepCollectionEquality().hash(complementAdresse) ^
      const DeepCollectionEquality().hash(ville) ^
      const DeepCollectionEquality().hash(villeLegacy) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterAddressDtoExtension
    on CRMAPIHuntersControllersDtoHunterAddressDto {
  CRMAPIHuntersControllersDtoHunterAddressDto copyWith(
      {String? adresse,
      String? complementAdresse,
      CRMAPIHuntersControllersDtoHunterCityDto? ville,
      CRMAPIHuntersControllersDtoHunterCityDto? villeLegacy}) {
    return CRMAPIHuntersControllersDtoHunterAddressDto(
        adresse: adresse ?? this.adresse,
        complementAdresse: complementAdresse ?? this.complementAdresse,
        ville: ville ?? this.ville,
        villeLegacy: villeLegacy ?? this.villeLegacy);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterAreaWorkDto {
  CRMAPIHuntersControllersDtoHunterAreaWorkDto({
    this.id,
    this.typeDeZoneDeRechercheEnum,
    this.latitude,
    this.longitude,
    this.nom,
    this.polygone,
    this.codesPostaux,
    this.codeInsee,
  });

  factory CRMAPIHuntersControllersDtoHunterAreaWorkDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterAreaWorkDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(
      name: 'typeDeZoneDeRechercheEnum', includeIfNull: false, defaultValue: '')
  final String? typeDeZoneDeRechercheEnum;
  @JsonKey(name: 'latitude', includeIfNull: false)
  final double? latitude;
  @JsonKey(name: 'longitude', includeIfNull: false)
  final double? longitude;
  @JsonKey(name: 'nom', includeIfNull: false, defaultValue: '')
  final String? nom;
  @JsonKey(name: 'polygone', includeIfNull: false, defaultValue: '')
  final String? polygone;
  @JsonKey(name: 'codesPostaux', includeIfNull: false, defaultValue: <String>[])
  final List<String>? codesPostaux;
  @JsonKey(name: 'codeInsee', includeIfNull: false, defaultValue: '')
  final String? codeInsee;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterAreaWorkDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterAreaWorkDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterAreaWorkDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterAreaWorkDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.typeDeZoneDeRechercheEnum,
                    typeDeZoneDeRechercheEnum) ||
                const DeepCollectionEquality().equals(
                    other.typeDeZoneDeRechercheEnum,
                    typeDeZoneDeRechercheEnum)) &&
            (identical(other.latitude, latitude) ||
                const DeepCollectionEquality()
                    .equals(other.latitude, latitude)) &&
            (identical(other.longitude, longitude) ||
                const DeepCollectionEquality()
                    .equals(other.longitude, longitude)) &&
            (identical(other.nom, nom) ||
                const DeepCollectionEquality().equals(other.nom, nom)) &&
            (identical(other.polygone, polygone) ||
                const DeepCollectionEquality()
                    .equals(other.polygone, polygone)) &&
            (identical(other.codesPostaux, codesPostaux) ||
                const DeepCollectionEquality()
                    .equals(other.codesPostaux, codesPostaux)) &&
            (identical(other.codeInsee, codeInsee) ||
                const DeepCollectionEquality()
                    .equals(other.codeInsee, codeInsee)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(typeDeZoneDeRechercheEnum) ^
      const DeepCollectionEquality().hash(latitude) ^
      const DeepCollectionEquality().hash(longitude) ^
      const DeepCollectionEquality().hash(nom) ^
      const DeepCollectionEquality().hash(polygone) ^
      const DeepCollectionEquality().hash(codesPostaux) ^
      const DeepCollectionEquality().hash(codeInsee) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterAreaWorkDtoExtension
    on CRMAPIHuntersControllersDtoHunterAreaWorkDto {
  CRMAPIHuntersControllersDtoHunterAreaWorkDto copyWith(
      {String? id,
      String? typeDeZoneDeRechercheEnum,
      double? latitude,
      double? longitude,
      String? nom,
      String? polygone,
      List<String>? codesPostaux,
      String? codeInsee}) {
    return CRMAPIHuntersControllersDtoHunterAreaWorkDto(
        id: id ?? this.id,
        typeDeZoneDeRechercheEnum:
            typeDeZoneDeRechercheEnum ?? this.typeDeZoneDeRechercheEnum,
        latitude: latitude ?? this.latitude,
        longitude: longitude ?? this.longitude,
        nom: nom ?? this.nom,
        polygone: polygone ?? this.polygone,
        codesPostaux: codesPostaux ?? this.codesPostaux,
        codeInsee: codeInsee ?? this.codeInsee);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterBudgetDto {
  CRMAPIHuntersControllersDtoHunterBudgetDto({
    this.montant,
    this.montantCible,
    this.rente,
    this.renteCible,
    this.avecLesMurs,
  });

  factory CRMAPIHuntersControllersDtoHunterBudgetDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterBudgetDtoFromJson(json);

  @JsonKey(name: 'montant', includeIfNull: false)
  final double? montant;
  @JsonKey(name: 'montantCible', includeIfNull: false)
  final double? montantCible;
  @JsonKey(name: 'rente', includeIfNull: false)
  final double? rente;
  @JsonKey(name: 'renteCible', includeIfNull: false)
  final double? renteCible;
  @JsonKey(name: 'avecLesMurs', includeIfNull: false)
  final bool? avecLesMurs;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterBudgetDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterBudgetDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterBudgetDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterBudgetDto &&
            (identical(other.montant, montant) ||
                const DeepCollectionEquality()
                    .equals(other.montant, montant)) &&
            (identical(other.montantCible, montantCible) ||
                const DeepCollectionEquality()
                    .equals(other.montantCible, montantCible)) &&
            (identical(other.rente, rente) ||
                const DeepCollectionEquality().equals(other.rente, rente)) &&
            (identical(other.renteCible, renteCible) ||
                const DeepCollectionEquality()
                    .equals(other.renteCible, renteCible)) &&
            (identical(other.avecLesMurs, avecLesMurs) ||
                const DeepCollectionEquality()
                    .equals(other.avecLesMurs, avecLesMurs)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(montant) ^
      const DeepCollectionEquality().hash(montantCible) ^
      const DeepCollectionEquality().hash(rente) ^
      const DeepCollectionEquality().hash(renteCible) ^
      const DeepCollectionEquality().hash(avecLesMurs) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterBudgetDtoExtension
    on CRMAPIHuntersControllersDtoHunterBudgetDto {
  CRMAPIHuntersControllersDtoHunterBudgetDto copyWith(
      {double? montant,
      double? montantCible,
      double? rente,
      double? renteCible,
      bool? avecLesMurs}) {
    return CRMAPIHuntersControllersDtoHunterBudgetDto(
        montant: montant ?? this.montant,
        montantCible: montantCible ?? this.montantCible,
        rente: rente ?? this.rente,
        renteCible: renteCible ?? this.renteCible,
        avecLesMurs: avecLesMurs ?? this.avecLesMurs);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterCriteriaDto {
  CRMAPIHuntersControllersDtoHunterCriteriaDto({
    this.nombrePiecesMin,
    this.nombrePiecesMax,
    this.nombreChambresMin,
    this.nombreChambresMax,
    this.surfaceHabitableMin,
    this.surfaceHabitableMax,
    this.surfaceTerrainMin,
    this.surfaceTerrainMax,
  });

  factory CRMAPIHuntersControllersDtoHunterCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterCriteriaDtoFromJson(json);

  @JsonKey(name: 'nombrePiecesMin', includeIfNull: false)
  final int? nombrePiecesMin;
  @JsonKey(name: 'nombrePiecesMax', includeIfNull: false)
  final int? nombrePiecesMax;
  @JsonKey(name: 'nombreChambresMin', includeIfNull: false)
  final int? nombreChambresMin;
  @JsonKey(name: 'nombreChambresMax', includeIfNull: false)
  final int? nombreChambresMax;
  @JsonKey(name: 'surfaceHabitableMin', includeIfNull: false)
  final int? surfaceHabitableMin;
  @JsonKey(name: 'surfaceHabitableMax', includeIfNull: false)
  final int? surfaceHabitableMax;
  @JsonKey(name: 'surfaceTerrainMin', includeIfNull: false)
  final int? surfaceTerrainMin;
  @JsonKey(name: 'surfaceTerrainMax', includeIfNull: false)
  final int? surfaceTerrainMax;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterCriteriaDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterCriteriaDto &&
            (identical(other.nombrePiecesMin, nombrePiecesMin) ||
                const DeepCollectionEquality()
                    .equals(other.nombrePiecesMin, nombrePiecesMin)) &&
            (identical(other.nombrePiecesMax, nombrePiecesMax) ||
                const DeepCollectionEquality()
                    .equals(other.nombrePiecesMax, nombrePiecesMax)) &&
            (identical(other.nombreChambresMin, nombreChambresMin) ||
                const DeepCollectionEquality()
                    .equals(other.nombreChambresMin, nombreChambresMin)) &&
            (identical(other.nombreChambresMax, nombreChambresMax) ||
                const DeepCollectionEquality()
                    .equals(other.nombreChambresMax, nombreChambresMax)) &&
            (identical(other.surfaceHabitableMin, surfaceHabitableMin) ||
                const DeepCollectionEquality()
                    .equals(other.surfaceHabitableMin, surfaceHabitableMin)) &&
            (identical(other.surfaceHabitableMax, surfaceHabitableMax) ||
                const DeepCollectionEquality()
                    .equals(other.surfaceHabitableMax, surfaceHabitableMax)) &&
            (identical(other.surfaceTerrainMin, surfaceTerrainMin) ||
                const DeepCollectionEquality()
                    .equals(other.surfaceTerrainMin, surfaceTerrainMin)) &&
            (identical(other.surfaceTerrainMax, surfaceTerrainMax) ||
                const DeepCollectionEquality()
                    .equals(other.surfaceTerrainMax, surfaceTerrainMax)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(nombrePiecesMin) ^
      const DeepCollectionEquality().hash(nombrePiecesMax) ^
      const DeepCollectionEquality().hash(nombreChambresMin) ^
      const DeepCollectionEquality().hash(nombreChambresMax) ^
      const DeepCollectionEquality().hash(surfaceHabitableMin) ^
      const DeepCollectionEquality().hash(surfaceHabitableMax) ^
      const DeepCollectionEquality().hash(surfaceTerrainMin) ^
      const DeepCollectionEquality().hash(surfaceTerrainMax) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterCriteriaDtoExtension
    on CRMAPIHuntersControllersDtoHunterCriteriaDto {
  CRMAPIHuntersControllersDtoHunterCriteriaDto copyWith(
      {int? nombrePiecesMin,
      int? nombrePiecesMax,
      int? nombreChambresMin,
      int? nombreChambresMax,
      int? surfaceHabitableMin,
      int? surfaceHabitableMax,
      int? surfaceTerrainMin,
      int? surfaceTerrainMax}) {
    return CRMAPIHuntersControllersDtoHunterCriteriaDto(
        nombrePiecesMin: nombrePiecesMin ?? this.nombrePiecesMin,
        nombrePiecesMax: nombrePiecesMax ?? this.nombrePiecesMax,
        nombreChambresMin: nombreChambresMin ?? this.nombreChambresMin,
        nombreChambresMax: nombreChambresMax ?? this.nombreChambresMax,
        surfaceHabitableMin: surfaceHabitableMin ?? this.surfaceHabitableMin,
        surfaceHabitableMax: surfaceHabitableMax ?? this.surfaceHabitableMax,
        surfaceTerrainMin: surfaceTerrainMin ?? this.surfaceTerrainMin,
        surfaceTerrainMax: surfaceTerrainMax ?? this.surfaceTerrainMax);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterSearchProfileDto {
  CRMAPIHuntersControllersDtoHunterSearchProfileDto({
    this.id,
    this.typeDeProfilDeRechercheEnum,
    this.typeDeProfilCompletEnum,
    this.typeUrgenceProjetEnum,
    this.typeDeProfilEnum,
    this.typeDeFamilleDeBienEnum,
    this.typeDeBienEnum,
    this.zonesDeRecherches,
    this.budget,
    this.criteresDeRecherche,
    this.notes,
    this.activites,
    this.dateDeCreationUtc,
    this.dateDeModificationUtc,
  });

  factory CRMAPIHuntersControllersDtoHunterSearchProfileDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterSearchProfileDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(
      name: 'typeDeProfilDeRechercheEnum',
      includeIfNull: false,
      defaultValue: '')
  final String? typeDeProfilDeRechercheEnum;
  @JsonKey(
      name: 'typeDeProfilCompletEnum', includeIfNull: false, defaultValue: '')
  final String? typeDeProfilCompletEnum;
  @JsonKey(
      name: 'typeUrgenceProjetEnum', includeIfNull: false, defaultValue: '')
  final String? typeUrgenceProjetEnum;
  @JsonKey(name: 'typeDeProfilEnum', includeIfNull: false, defaultValue: '')
  final String? typeDeProfilEnum;
  @JsonKey(
      name: 'typeDeFamilleDeBienEnum', includeIfNull: false, defaultValue: '')
  final String? typeDeFamilleDeBienEnum;
  @JsonKey(name: 'typeDeBienEnum', includeIfNull: false, defaultValue: '')
  final String? typeDeBienEnum;
  @JsonKey(
      name: 'zonesDeRecherches',
      includeIfNull: false,
      defaultValue: <CRMAPIHuntersControllersDtoHunterAreaWorkDto>[])
  final List<CRMAPIHuntersControllersDtoHunterAreaWorkDto>? zonesDeRecherches;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterBudgetDto? budget;
  @JsonKey(name: 'criteresDeRecherche', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterCriteriaDto? criteresDeRecherche;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'activites', includeIfNull: false, defaultValue: <String>[])
  final List<String>? activites;
  @JsonKey(name: 'dateDeCreationUtc', includeIfNull: false)
  final DateTime? dateDeCreationUtc;
  @JsonKey(name: 'dateDeModificationUtc', includeIfNull: false)
  final DateTime? dateDeModificationUtc;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterSearchProfileDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterSearchProfileDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterSearchProfileDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterSearchProfileDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.typeDeProfilDeRechercheEnum, typeDeProfilDeRechercheEnum) ||
                const DeepCollectionEquality().equals(
                    other.typeDeProfilDeRechercheEnum,
                    typeDeProfilDeRechercheEnum)) &&
            (identical(other.typeDeProfilCompletEnum, typeDeProfilCompletEnum) ||
                const DeepCollectionEquality().equals(
                    other.typeDeProfilCompletEnum, typeDeProfilCompletEnum)) &&
            (identical(other.typeUrgenceProjetEnum, typeUrgenceProjetEnum) ||
                const DeepCollectionEquality().equals(
                    other.typeUrgenceProjetEnum, typeUrgenceProjetEnum)) &&
            (identical(other.typeDeProfilEnum, typeDeProfilEnum) ||
                const DeepCollectionEquality()
                    .equals(other.typeDeProfilEnum, typeDeProfilEnum)) &&
            (identical(other.typeDeFamilleDeBienEnum, typeDeFamilleDeBienEnum) ||
                const DeepCollectionEquality().equals(
                    other.typeDeFamilleDeBienEnum, typeDeFamilleDeBienEnum)) &&
            (identical(other.typeDeBienEnum, typeDeBienEnum) ||
                const DeepCollectionEquality()
                    .equals(other.typeDeBienEnum, typeDeBienEnum)) &&
            (identical(other.zonesDeRecherches, zonesDeRecherches) ||
                const DeepCollectionEquality()
                    .equals(other.zonesDeRecherches, zonesDeRecherches)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.criteresDeRecherche, criteresDeRecherche) ||
                const DeepCollectionEquality()
                    .equals(other.criteresDeRecherche, criteresDeRecherche)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.activites, activites) ||
                const DeepCollectionEquality()
                    .equals(other.activites, activites)) &&
            (identical(other.dateDeCreationUtc, dateDeCreationUtc) ||
                const DeepCollectionEquality()
                    .equals(other.dateDeCreationUtc, dateDeCreationUtc)) &&
            (identical(other.dateDeModificationUtc, dateDeModificationUtc) || const DeepCollectionEquality().equals(other.dateDeModificationUtc, dateDeModificationUtc)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(typeDeProfilDeRechercheEnum) ^
      const DeepCollectionEquality().hash(typeDeProfilCompletEnum) ^
      const DeepCollectionEquality().hash(typeUrgenceProjetEnum) ^
      const DeepCollectionEquality().hash(typeDeProfilEnum) ^
      const DeepCollectionEquality().hash(typeDeFamilleDeBienEnum) ^
      const DeepCollectionEquality().hash(typeDeBienEnum) ^
      const DeepCollectionEquality().hash(zonesDeRecherches) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(criteresDeRecherche) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(activites) ^
      const DeepCollectionEquality().hash(dateDeCreationUtc) ^
      const DeepCollectionEquality().hash(dateDeModificationUtc) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterSearchProfileDtoExtension
    on CRMAPIHuntersControllersDtoHunterSearchProfileDto {
  CRMAPIHuntersControllersDtoHunterSearchProfileDto copyWith(
      {String? id,
      String? typeDeProfilDeRechercheEnum,
      String? typeDeProfilCompletEnum,
      String? typeUrgenceProjetEnum,
      String? typeDeProfilEnum,
      String? typeDeFamilleDeBienEnum,
      String? typeDeBienEnum,
      List<CRMAPIHuntersControllersDtoHunterAreaWorkDto>? zonesDeRecherches,
      CRMAPIHuntersControllersDtoHunterBudgetDto? budget,
      CRMAPIHuntersControllersDtoHunterCriteriaDto? criteresDeRecherche,
      String? notes,
      List<String>? activites,
      DateTime? dateDeCreationUtc,
      DateTime? dateDeModificationUtc}) {
    return CRMAPIHuntersControllersDtoHunterSearchProfileDto(
        id: id ?? this.id,
        typeDeProfilDeRechercheEnum:
            typeDeProfilDeRechercheEnum ?? this.typeDeProfilDeRechercheEnum,
        typeDeProfilCompletEnum:
            typeDeProfilCompletEnum ?? this.typeDeProfilCompletEnum,
        typeUrgenceProjetEnum:
            typeUrgenceProjetEnum ?? this.typeUrgenceProjetEnum,
        typeDeProfilEnum: typeDeProfilEnum ?? this.typeDeProfilEnum,
        typeDeFamilleDeBienEnum:
            typeDeFamilleDeBienEnum ?? this.typeDeFamilleDeBienEnum,
        typeDeBienEnum: typeDeBienEnum ?? this.typeDeBienEnum,
        zonesDeRecherches: zonesDeRecherches ?? this.zonesDeRecherches,
        budget: budget ?? this.budget,
        criteresDeRecherche: criteresDeRecherche ?? this.criteresDeRecherche,
        notes: notes ?? this.notes,
        activites: activites ?? this.activites,
        dateDeCreationUtc: dateDeCreationUtc ?? this.dateDeCreationUtc,
        dateDeModificationUtc:
            dateDeModificationUtc ?? this.dateDeModificationUtc);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIHuntersControllersDtoHunterContactDto {
  CRMAPIHuntersControllersDtoHunterContactDto({
    this.conseillerUniqueId,
    this.businessUnit,
    this.identite,
    this.adresse,
    this.profilDeRecherche,
  });

  factory CRMAPIHuntersControllersDtoHunterContactDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIHuntersControllersDtoHunterContactDtoFromJson(json);

  @JsonKey(name: 'conseillerUniqueId', includeIfNull: false, defaultValue: '')
  final String? conseillerUniqueId;
  @JsonKey(
      name: 'businessUnit',
      includeIfNull: false,
      toJson: cRMAPIHuntersControllersDtoBusinessUnitToJson,
      fromJson: cRMAPIHuntersControllersDtoBusinessUnitFromJson)
  final enums.CRMAPIHuntersControllersDtoBusinessUnit? businessUnit;
  @JsonKey(name: 'identite', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterIdentityDto? identite;
  @JsonKey(name: 'adresse', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterAddressDto? adresse;
  @JsonKey(name: 'profilDeRecherche', includeIfNull: false)
  final CRMAPIHuntersControllersDtoHunterSearchProfileDto? profilDeRecherche;
  static const fromJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterContactDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIHuntersControllersDtoHunterContactDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIHuntersControllersDtoHunterContactDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIHuntersControllersDtoHunterContactDto &&
            (identical(other.conseillerUniqueId, conseillerUniqueId) ||
                const DeepCollectionEquality()
                    .equals(other.conseillerUniqueId, conseillerUniqueId)) &&
            (identical(other.businessUnit, businessUnit) ||
                const DeepCollectionEquality()
                    .equals(other.businessUnit, businessUnit)) &&
            (identical(other.identite, identite) ||
                const DeepCollectionEquality()
                    .equals(other.identite, identite)) &&
            (identical(other.adresse, adresse) ||
                const DeepCollectionEquality()
                    .equals(other.adresse, adresse)) &&
            (identical(other.profilDeRecherche, profilDeRecherche) ||
                const DeepCollectionEquality()
                    .equals(other.profilDeRecherche, profilDeRecherche)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(conseillerUniqueId) ^
      const DeepCollectionEquality().hash(businessUnit) ^
      const DeepCollectionEquality().hash(identite) ^
      const DeepCollectionEquality().hash(adresse) ^
      const DeepCollectionEquality().hash(profilDeRecherche) ^
      runtimeType.hashCode;
}

extension $CRMAPIHuntersControllersDtoHunterContactDtoExtension
    on CRMAPIHuntersControllersDtoHunterContactDto {
  CRMAPIHuntersControllersDtoHunterContactDto copyWith(
      {String? conseillerUniqueId,
      enums.CRMAPIHuntersControllersDtoBusinessUnit? businessUnit,
      CRMAPIHuntersControllersDtoHunterIdentityDto? identite,
      CRMAPIHuntersControllersDtoHunterAddressDto? adresse,
      CRMAPIHuntersControllersDtoHunterSearchProfileDto? profilDeRecherche}) {
    return CRMAPIHuntersControllersDtoHunterContactDto(
        conseillerUniqueId: conseillerUniqueId ?? this.conseillerUniqueId,
        businessUnit: businessUnit ?? this.businessUnit,
        identite: identite ?? this.identite,
        adresse: adresse ?? this.adresse,
        profilDeRecherche: profilDeRecherche ?? this.profilDeRecherche);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoMatchingProfilesRequestDto {
  CRMAPIProfilesDtoMatchingProfilesRequestDto({
    this.profileKind,
    this.propertyKind,
    this.cityId,
    this.budget,
    this.surface,
    this.nbRooms,
    this.constructionYear,
    this.withParking,
    this.withElevator,
  });

  factory CRMAPIProfilesDtoMatchingProfilesRequestDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoMatchingProfilesRequestDtoFromJson(json);

  @JsonKey(name: 'profileKind', includeIfNull: false, defaultValue: '')
  final String? profileKind;
  @JsonKey(name: 'propertyKind', includeIfNull: false, defaultValue: '')
  final String? propertyKind;
  @JsonKey(name: 'cityId', includeIfNull: false, defaultValue: '')
  final String? cityId;
  @JsonKey(name: 'budget', includeIfNull: false)
  final double? budget;
  @JsonKey(name: 'surface', includeIfNull: false)
  final double? surface;
  @JsonKey(name: 'nbRooms', includeIfNull: false)
  final int? nbRooms;
  @JsonKey(name: 'constructionYear', includeIfNull: false)
  final int? constructionYear;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoMatchingProfilesRequestDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoMatchingProfilesRequestDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoMatchingProfilesRequestDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoMatchingProfilesRequestDto &&
            (identical(other.profileKind, profileKind) ||
                const DeepCollectionEquality()
                    .equals(other.profileKind, profileKind)) &&
            (identical(other.propertyKind, propertyKind) ||
                const DeepCollectionEquality()
                    .equals(other.propertyKind, propertyKind)) &&
            (identical(other.cityId, cityId) ||
                const DeepCollectionEquality().equals(other.cityId, cityId)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.surface, surface) ||
                const DeepCollectionEquality()
                    .equals(other.surface, surface)) &&
            (identical(other.nbRooms, nbRooms) ||
                const DeepCollectionEquality()
                    .equals(other.nbRooms, nbRooms)) &&
            (identical(other.constructionYear, constructionYear) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYear, constructionYear)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(profileKind) ^
      const DeepCollectionEquality().hash(propertyKind) ^
      const DeepCollectionEquality().hash(cityId) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(surface) ^
      const DeepCollectionEquality().hash(nbRooms) ^
      const DeepCollectionEquality().hash(constructionYear) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoMatchingProfilesRequestDtoExtension
    on CRMAPIProfilesDtoMatchingProfilesRequestDto {
  CRMAPIProfilesDtoMatchingProfilesRequestDto copyWith(
      {String? profileKind,
      String? propertyKind,
      String? cityId,
      double? budget,
      double? surface,
      int? nbRooms,
      int? constructionYear,
      bool? withParking,
      bool? withElevator}) {
    return CRMAPIProfilesDtoMatchingProfilesRequestDto(
        profileKind: profileKind ?? this.profileKind,
        propertyKind: propertyKind ?? this.propertyKind,
        cityId: cityId ?? this.cityId,
        budget: budget ?? this.budget,
        surface: surface ?? this.surface,
        nbRooms: nbRooms ?? this.nbRooms,
        constructionYear: constructionYear ?? this.constructionYear,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoMatchingProfileContactDetailDto {
  CRMAPIProfilesDtoMatchingProfileContactDetailDto({
    this.profileReference,
    this.contactId,
    this.contactFirstName,
    this.contactLastName,
    this.contactGender,
    this.contactTelephone,
    this.contactEmail,
    this.lastModificationDate,
  });

  factory CRMAPIProfilesDtoMatchingProfileContactDetailDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoMatchingProfileContactDetailDtoFromJson(json);

  @JsonKey(name: 'profileReference', includeIfNull: false, defaultValue: '')
  final String? profileReference;
  @JsonKey(name: 'contactId', includeIfNull: false, defaultValue: '')
  final String? contactId;
  @JsonKey(name: 'contactFirstName', includeIfNull: false, defaultValue: '')
  final String? contactFirstName;
  @JsonKey(name: 'contactLastName', includeIfNull: false, defaultValue: '')
  final String? contactLastName;
  @JsonKey(name: 'contactGender', includeIfNull: false, defaultValue: '')
  final String? contactGender;
  @JsonKey(name: 'contactTelephone', includeIfNull: false, defaultValue: '')
  final String? contactTelephone;
  @JsonKey(name: 'contactEmail', includeIfNull: false, defaultValue: '')
  final String? contactEmail;
  @JsonKey(name: 'lastModificationDate', includeIfNull: false)
  final DateTime? lastModificationDate;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoMatchingProfileContactDetailDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoMatchingProfileContactDetailDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoMatchingProfileContactDetailDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoMatchingProfileContactDetailDto &&
            (identical(other.profileReference, profileReference) ||
                const DeepCollectionEquality()
                    .equals(other.profileReference, profileReference)) &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.contactFirstName, contactFirstName) ||
                const DeepCollectionEquality()
                    .equals(other.contactFirstName, contactFirstName)) &&
            (identical(other.contactLastName, contactLastName) ||
                const DeepCollectionEquality()
                    .equals(other.contactLastName, contactLastName)) &&
            (identical(other.contactGender, contactGender) ||
                const DeepCollectionEquality()
                    .equals(other.contactGender, contactGender)) &&
            (identical(other.contactTelephone, contactTelephone) ||
                const DeepCollectionEquality()
                    .equals(other.contactTelephone, contactTelephone)) &&
            (identical(other.contactEmail, contactEmail) ||
                const DeepCollectionEquality()
                    .equals(other.contactEmail, contactEmail)) &&
            (identical(other.lastModificationDate, lastModificationDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastModificationDate, lastModificationDate)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(profileReference) ^
      const DeepCollectionEquality().hash(contactId) ^
      const DeepCollectionEquality().hash(contactFirstName) ^
      const DeepCollectionEquality().hash(contactLastName) ^
      const DeepCollectionEquality().hash(contactGender) ^
      const DeepCollectionEquality().hash(contactTelephone) ^
      const DeepCollectionEquality().hash(contactEmail) ^
      const DeepCollectionEquality().hash(lastModificationDate) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoMatchingProfileContactDetailDtoExtension
    on CRMAPIProfilesDtoMatchingProfileContactDetailDto {
  CRMAPIProfilesDtoMatchingProfileContactDetailDto copyWith(
      {String? profileReference,
      String? contactId,
      String? contactFirstName,
      String? contactLastName,
      String? contactGender,
      String? contactTelephone,
      String? contactEmail,
      DateTime? lastModificationDate}) {
    return CRMAPIProfilesDtoMatchingProfileContactDetailDto(
        profileReference: profileReference ?? this.profileReference,
        contactId: contactId ?? this.contactId,
        contactFirstName: contactFirstName ?? this.contactFirstName,
        contactLastName: contactLastName ?? this.contactLastName,
        contactGender: contactGender ?? this.contactGender,
        contactTelephone: contactTelephone ?? this.contactTelephone,
        contactEmail: contactEmail ?? this.contactEmail,
        lastModificationDate:
            lastModificationDate ?? this.lastModificationDate);
  }
}

@JsonSerializable(explicitToJson: true)
class SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64 {
  SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64({
    this.key,
    this.value,
  });

  factory SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64.fromJson(
          Map<String, dynamic> json) =>
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64FromJson(
          json);

  @JsonKey(name: 'key', includeIfNull: false, defaultValue: '')
  final String? key;
  @JsonKey(name: 'value', includeIfNull: false)
  final num? value;
  static const fromJsonFactory =
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64FromJson;
  static const toJsonFactory =
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64ToJson;
  Map<String, dynamic> toJson() =>
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64ToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64 &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(key) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64Extension
    on SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64 {
  SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64 copyWith(
      {String? key, num? value}) {
    return SystemCollectionsGenericKeyValuePair2SystemStringSystemInt64(
        key: key ?? this.key, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto {
  CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto({
    this.count,
    this.total,
    this.totalPage,
    this.pageSize,
    this.pageNumber,
    this.hasMore,
    this.documents,
    this.aggregations,
  });

  factory CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDtoFromJson(
          json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  @JsonKey(name: 'total', includeIfNull: false)
  final num? total;
  @JsonKey(name: 'totalPage', includeIfNull: false)
  final num? totalPage;
  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'pageNumber', includeIfNull: false)
  final int? pageNumber;
  @JsonKey(name: 'hasMore', includeIfNull: false)
  final bool? hasMore;
  @JsonKey(
      name: 'documents',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoMatchingProfileContactDetailDto>[])
  final List<CRMAPIProfilesDtoMatchingProfileContactDetailDto>? documents;
  @JsonKey(name: 'aggregations', includeIfNull: false)
  final Map<String, dynamic>? aggregations;
  static const fromJsonFactory =
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDtoFromJson;
  static const toJsonFactory =
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.totalPage, totalPage) ||
                const DeepCollectionEquality()
                    .equals(other.totalPage, totalPage)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.pageNumber, pageNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pageNumber, pageNumber)) &&
            (identical(other.hasMore, hasMore) ||
                const DeepCollectionEquality()
                    .equals(other.hasMore, hasMore)) &&
            (identical(other.documents, documents) ||
                const DeepCollectionEquality()
                    .equals(other.documents, documents)) &&
            (identical(other.aggregations, aggregations) ||
                const DeepCollectionEquality()
                    .equals(other.aggregations, aggregations)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(total) ^
      const DeepCollectionEquality().hash(totalPage) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(pageNumber) ^
      const DeepCollectionEquality().hash(hasMore) ^
      const DeepCollectionEquality().hash(documents) ^
      const DeepCollectionEquality().hash(aggregations) ^
      runtimeType.hashCode;
}

extension $CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDtoExtension
    on CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto {
  CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto
      copyWith(
          {int? count,
          num? total,
          num? totalPage,
          int? pageSize,
          int? pageNumber,
          bool? hasMore,
          List<CRMAPIProfilesDtoMatchingProfileContactDetailDto>? documents,
          Map<String, dynamic>? aggregations}) {
    return CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileContactDetailDto(
        count: count ?? this.count,
        total: total ?? this.total,
        totalPage: totalPage ?? this.totalPage,
        pageSize: pageSize ?? this.pageSize,
        pageNumber: pageNumber ?? this.pageNumber,
        hasMore: hasMore ?? this.hasMore,
        documents: documents ?? this.documents,
        aggregations: aggregations ?? this.aggregations);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoMatchingProfileAgentDetailDto {
  CRMAPIProfilesDtoMatchingProfileAgentDetailDto({
    this.profileReference,
    this.bu,
    this.agentId,
    this.agentFirstName,
    this.agentLastName,
    this.agentGender,
    this.agentTelephone,
    this.agentEmail,
    this.agentPhoto,
    this.isActive,
    this.lastModificationDate,
  });

  factory CRMAPIProfilesDtoMatchingProfileAgentDetailDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoMatchingProfileAgentDetailDtoFromJson(json);

  @JsonKey(name: 'profileReference', includeIfNull: false, defaultValue: '')
  final String? profileReference;
  @JsonKey(name: 'bu', includeIfNull: false, defaultValue: '')
  final String? bu;
  @JsonKey(name: 'agentId', includeIfNull: false, defaultValue: '')
  final String? agentId;
  @JsonKey(name: 'agentFirstName', includeIfNull: false, defaultValue: '')
  final String? agentFirstName;
  @JsonKey(name: 'agentLastName', includeIfNull: false, defaultValue: '')
  final String? agentLastName;
  @JsonKey(name: 'agentGender', includeIfNull: false, defaultValue: '')
  final String? agentGender;
  @JsonKey(name: 'agentTelephone', includeIfNull: false, defaultValue: '')
  final String? agentTelephone;
  @JsonKey(name: 'agentEmail', includeIfNull: false, defaultValue: '')
  final String? agentEmail;
  @JsonKey(name: 'agentPhoto', includeIfNull: false, defaultValue: '')
  final String? agentPhoto;
  @JsonKey(name: 'isActive', includeIfNull: false)
  final bool? isActive;
  @JsonKey(name: 'lastModificationDate', includeIfNull: false)
  final DateTime? lastModificationDate;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoMatchingProfileAgentDetailDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoMatchingProfileAgentDetailDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoMatchingProfileAgentDetailDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoMatchingProfileAgentDetailDto &&
            (identical(other.profileReference, profileReference) ||
                const DeepCollectionEquality()
                    .equals(other.profileReference, profileReference)) &&
            (identical(other.bu, bu) ||
                const DeepCollectionEquality().equals(other.bu, bu)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.agentFirstName, agentFirstName) ||
                const DeepCollectionEquality()
                    .equals(other.agentFirstName, agentFirstName)) &&
            (identical(other.agentLastName, agentLastName) ||
                const DeepCollectionEquality()
                    .equals(other.agentLastName, agentLastName)) &&
            (identical(other.agentGender, agentGender) ||
                const DeepCollectionEquality()
                    .equals(other.agentGender, agentGender)) &&
            (identical(other.agentTelephone, agentTelephone) ||
                const DeepCollectionEquality()
                    .equals(other.agentTelephone, agentTelephone)) &&
            (identical(other.agentEmail, agentEmail) ||
                const DeepCollectionEquality()
                    .equals(other.agentEmail, agentEmail)) &&
            (identical(other.agentPhoto, agentPhoto) ||
                const DeepCollectionEquality()
                    .equals(other.agentPhoto, agentPhoto)) &&
            (identical(other.isActive, isActive) ||
                const DeepCollectionEquality()
                    .equals(other.isActive, isActive)) &&
            (identical(other.lastModificationDate, lastModificationDate) ||
                const DeepCollectionEquality()
                    .equals(other.lastModificationDate, lastModificationDate)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(profileReference) ^
      const DeepCollectionEquality().hash(bu) ^
      const DeepCollectionEquality().hash(agentId) ^
      const DeepCollectionEquality().hash(agentFirstName) ^
      const DeepCollectionEquality().hash(agentLastName) ^
      const DeepCollectionEquality().hash(agentGender) ^
      const DeepCollectionEquality().hash(agentTelephone) ^
      const DeepCollectionEquality().hash(agentEmail) ^
      const DeepCollectionEquality().hash(agentPhoto) ^
      const DeepCollectionEquality().hash(isActive) ^
      const DeepCollectionEquality().hash(lastModificationDate) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoMatchingProfileAgentDetailDtoExtension
    on CRMAPIProfilesDtoMatchingProfileAgentDetailDto {
  CRMAPIProfilesDtoMatchingProfileAgentDetailDto copyWith(
      {String? profileReference,
      String? bu,
      String? agentId,
      String? agentFirstName,
      String? agentLastName,
      String? agentGender,
      String? agentTelephone,
      String? agentEmail,
      String? agentPhoto,
      bool? isActive,
      DateTime? lastModificationDate}) {
    return CRMAPIProfilesDtoMatchingProfileAgentDetailDto(
        profileReference: profileReference ?? this.profileReference,
        bu: bu ?? this.bu,
        agentId: agentId ?? this.agentId,
        agentFirstName: agentFirstName ?? this.agentFirstName,
        agentLastName: agentLastName ?? this.agentLastName,
        agentGender: agentGender ?? this.agentGender,
        agentTelephone: agentTelephone ?? this.agentTelephone,
        agentEmail: agentEmail ?? this.agentEmail,
        agentPhoto: agentPhoto ?? this.agentPhoto,
        isActive: isActive ?? this.isActive,
        lastModificationDate:
            lastModificationDate ?? this.lastModificationDate);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto {
  CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto({
    this.count,
    this.total,
    this.totalPage,
    this.pageSize,
    this.pageNumber,
    this.hasMore,
    this.documents,
    this.aggregations,
  });

  factory CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDtoFromJson(
          json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  @JsonKey(name: 'total', includeIfNull: false)
  final num? total;
  @JsonKey(name: 'totalPage', includeIfNull: false)
  final num? totalPage;
  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'pageNumber', includeIfNull: false)
  final int? pageNumber;
  @JsonKey(name: 'hasMore', includeIfNull: false)
  final bool? hasMore;
  @JsonKey(
      name: 'documents',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoMatchingProfileAgentDetailDto>[])
  final List<CRMAPIProfilesDtoMatchingProfileAgentDetailDto>? documents;
  @JsonKey(name: 'aggregations', includeIfNull: false)
  final Map<String, dynamic>? aggregations;
  static const fromJsonFactory =
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDtoFromJson;
  static const toJsonFactory =
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.totalPage, totalPage) ||
                const DeepCollectionEquality()
                    .equals(other.totalPage, totalPage)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.pageNumber, pageNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pageNumber, pageNumber)) &&
            (identical(other.hasMore, hasMore) ||
                const DeepCollectionEquality()
                    .equals(other.hasMore, hasMore)) &&
            (identical(other.documents, documents) ||
                const DeepCollectionEquality()
                    .equals(other.documents, documents)) &&
            (identical(other.aggregations, aggregations) ||
                const DeepCollectionEquality()
                    .equals(other.aggregations, aggregations)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(total) ^
      const DeepCollectionEquality().hash(totalPage) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(pageNumber) ^
      const DeepCollectionEquality().hash(hasMore) ^
      const DeepCollectionEquality().hash(documents) ^
      const DeepCollectionEquality().hash(aggregations) ^
      runtimeType.hashCode;
}

extension $CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDtoExtension
    on CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto {
  CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto
      copyWith(
          {int? count,
          num? total,
          num? totalPage,
          int? pageSize,
          int? pageNumber,
          bool? hasMore,
          List<CRMAPIProfilesDtoMatchingProfileAgentDetailDto>? documents,
          Map<String, dynamic>? aggregations}) {
    return CRMDomainReadModelsProfilesPagedDataResult1CRMAPIProfilesDtoMatchingProfileAgentDetailDto(
        count: count ?? this.count,
        total: total ?? this.total,
        totalPage: totalPage ?? this.totalPage,
        pageSize: pageSize ?? this.pageSize,
        pageNumber: pageNumber ?? this.pageNumber,
        hasMore: hasMore ?? this.hasMore,
        documents: documents ?? this.documents,
        aggregations: aggregations ?? this.aggregations);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsCityModel {
  CRMInfrastructureElasticSearchReadModelsCityModel({
    this.id,
    this.name,
    this.postalCodes,
    this.inseeCode,
  });

  factory CRMInfrastructureElasticSearchReadModelsCityModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsCityModelFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'postalCodes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? postalCodes;
  @JsonKey(name: 'inseeCode', includeIfNull: false, defaultValue: '')
  final String? inseeCode;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsCityModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsCityModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsCityModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsCityModel &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.postalCodes, postalCodes) ||
                const DeepCollectionEquality()
                    .equals(other.postalCodes, postalCodes)) &&
            (identical(other.inseeCode, inseeCode) ||
                const DeepCollectionEquality()
                    .equals(other.inseeCode, inseeCode)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(postalCodes) ^
      const DeepCollectionEquality().hash(inseeCode) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsCityModelExtension
    on CRMInfrastructureElasticSearchReadModelsCityModel {
  CRMInfrastructureElasticSearchReadModelsCityModel copyWith(
      {String? id,
      String? name,
      List<String>? postalCodes,
      String? inseeCode}) {
    return CRMInfrastructureElasticSearchReadModelsCityModel(
        id: id ?? this.id,
        name: name ?? this.name,
        postalCodes: postalCodes ?? this.postalCodes,
        inseeCode: inseeCode ?? this.inseeCode);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsPhoneModel {
  CRMInfrastructureElasticSearchReadModelsPhoneModel({
    this.kind,
    this.$number,
  });

  factory CRMInfrastructureElasticSearchReadModelsPhoneModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsPhoneModelFromJson(json);

  @JsonKey(name: 'kind', includeIfNull: false, defaultValue: '')
  final String? kind;
  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String? $number;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsPhoneModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsPhoneModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsPhoneModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsPhoneModel &&
            (identical(other.kind, kind) ||
                const DeepCollectionEquality().equals(other.kind, kind)) &&
            (identical(other.$number, $number) ||
                const DeepCollectionEquality().equals(other.$number, $number)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(kind) ^
      const DeepCollectionEquality().hash($number) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsPhoneModelExtension
    on CRMInfrastructureElasticSearchReadModelsPhoneModel {
  CRMInfrastructureElasticSearchReadModelsPhoneModel copyWith(
      {String? kind, String? $number}) {
    return CRMInfrastructureElasticSearchReadModelsPhoneModel(
        kind: kind ?? this.kind, $number: $number ?? this.$number);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsEmailModel {
  CRMInfrastructureElasticSearchReadModelsEmailModel({
    this.address,
    this.kind,
  });

  factory CRMInfrastructureElasticSearchReadModelsEmailModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsEmailModelFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false, defaultValue: '')
  final String? address;
  @JsonKey(name: 'kind', includeIfNull: false, defaultValue: '')
  final String? kind;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsEmailModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsEmailModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsEmailModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsEmailModel &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.kind, kind) ||
                const DeepCollectionEquality().equals(other.kind, kind)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(kind) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsEmailModelExtension
    on CRMInfrastructureElasticSearchReadModelsEmailModel {
  CRMInfrastructureElasticSearchReadModelsEmailModel copyWith(
      {String? address, String? kind}) {
    return CRMInfrastructureElasticSearchReadModelsEmailModel(
        address: address ?? this.address, kind: kind ?? this.kind);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel {
  CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel({
    this.professionCategory,
    this.profession,
    this.company,
    this.companyRole,
  });

  factory CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsProfessionalInfosModelFromJson(
          json);

  @JsonKey(name: 'professionCategory', includeIfNull: false, defaultValue: '')
  final String? professionCategory;
  @JsonKey(name: 'profession', includeIfNull: false, defaultValue: '')
  final String? profession;
  @JsonKey(name: 'company', includeIfNull: false, defaultValue: '')
  final String? company;
  @JsonKey(name: 'companyRole', includeIfNull: false, defaultValue: '')
  final String? companyRole;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsProfessionalInfosModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsProfessionalInfosModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsProfessionalInfosModelToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel &&
            (identical(other.professionCategory, professionCategory) ||
                const DeepCollectionEquality()
                    .equals(other.professionCategory, professionCategory)) &&
            (identical(other.profession, profession) ||
                const DeepCollectionEquality()
                    .equals(other.profession, profession)) &&
            (identical(other.company, company) ||
                const DeepCollectionEquality()
                    .equals(other.company, company)) &&
            (identical(other.companyRole, companyRole) ||
                const DeepCollectionEquality()
                    .equals(other.companyRole, companyRole)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(professionCategory) ^
      const DeepCollectionEquality().hash(profession) ^
      const DeepCollectionEquality().hash(company) ^
      const DeepCollectionEquality().hash(companyRole) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsProfessionalInfosModelExtension
    on CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel {
  CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel copyWith(
      {String? professionCategory,
      String? profession,
      String? company,
      String? companyRole}) {
    return CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel(
        professionCategory: professionCategory ?? this.professionCategory,
        profession: profession ?? this.profession,
        company: company ?? this.company,
        companyRole: companyRole ?? this.companyRole);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsIdentityModel {
  CRMInfrastructureElasticSearchReadModelsIdentityModel({
    this.birthDate,
    this.birthPlace,
    this.firstName,
    this.lastName,
    this.gender,
    this.phones,
    this.emails,
    this.professionalInfos,
  });

  factory CRMInfrastructureElasticSearchReadModelsIdentityModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsIdentityModelFromJson(json);

  @JsonKey(name: 'birthDate', includeIfNull: false)
  final DateTime? birthDate;
  @JsonKey(name: 'birthPlace', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsCityModel? birthPlace;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'gender', includeIfNull: false, defaultValue: '')
  final String? gender;
  @JsonKey(
      name: 'phones',
      includeIfNull: false,
      defaultValue: <CRMInfrastructureElasticSearchReadModelsPhoneModel>[])
  final List<CRMInfrastructureElasticSearchReadModelsPhoneModel>? phones;
  @JsonKey(
      name: 'emails',
      includeIfNull: false,
      defaultValue: <CRMInfrastructureElasticSearchReadModelsEmailModel>[])
  final List<CRMInfrastructureElasticSearchReadModelsEmailModel>? emails;
  @JsonKey(name: 'professionalInfos', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel?
      professionalInfos;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsIdentityModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsIdentityModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsIdentityModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsIdentityModel &&
            (identical(other.birthDate, birthDate) ||
                const DeepCollectionEquality()
                    .equals(other.birthDate, birthDate)) &&
            (identical(other.birthPlace, birthPlace) ||
                const DeepCollectionEquality()
                    .equals(other.birthPlace, birthPlace)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.gender, gender) ||
                const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.phones, phones) ||
                const DeepCollectionEquality().equals(other.phones, phones)) &&
            (identical(other.emails, emails) ||
                const DeepCollectionEquality().equals(other.emails, emails)) &&
            (identical(other.professionalInfos, professionalInfos) ||
                const DeepCollectionEquality()
                    .equals(other.professionalInfos, professionalInfos)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(birthDate) ^
      const DeepCollectionEquality().hash(birthPlace) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(gender) ^
      const DeepCollectionEquality().hash(phones) ^
      const DeepCollectionEquality().hash(emails) ^
      const DeepCollectionEquality().hash(professionalInfos) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsIdentityModelExtension
    on CRMInfrastructureElasticSearchReadModelsIdentityModel {
  CRMInfrastructureElasticSearchReadModelsIdentityModel copyWith(
      {DateTime? birthDate,
      CRMInfrastructureElasticSearchReadModelsCityModel? birthPlace,
      String? firstName,
      String? lastName,
      String? gender,
      List<CRMInfrastructureElasticSearchReadModelsPhoneModel>? phones,
      List<CRMInfrastructureElasticSearchReadModelsEmailModel>? emails,
      CRMInfrastructureElasticSearchReadModelsProfessionalInfosModel?
          professionalInfos}) {
    return CRMInfrastructureElasticSearchReadModelsIdentityModel(
        birthDate: birthDate ?? this.birthDate,
        birthPlace: birthPlace ?? this.birthPlace,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        gender: gender ?? this.gender,
        phones: phones ?? this.phones,
        emails: emails ?? this.emails,
        professionalInfos: professionalInfos ?? this.professionalInfos);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsDepartementModel {
  CRMInfrastructureElasticSearchReadModelsDepartementModel({
    this.id,
    this.name,
  });

  factory CRMInfrastructureElasticSearchReadModelsDepartementModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsDepartementModelFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsDepartementModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsDepartementModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsDepartementModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsDepartementModel &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsDepartementModelExtension
    on CRMInfrastructureElasticSearchReadModelsDepartementModel {
  CRMInfrastructureElasticSearchReadModelsDepartementModel copyWith(
      {String? id, String? name}) {
    return CRMInfrastructureElasticSearchReadModelsDepartementModel(
        id: id ?? this.id, name: name ?? this.name);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsRegionModel {
  CRMInfrastructureElasticSearchReadModelsRegionModel({
    this.id,
    this.name,
  });

  factory CRMInfrastructureElasticSearchReadModelsRegionModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsRegionModelFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsRegionModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsRegionModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsRegionModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsRegionModel &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsRegionModelExtension
    on CRMInfrastructureElasticSearchReadModelsRegionModel {
  CRMInfrastructureElasticSearchReadModelsRegionModel copyWith(
      {String? id, String? name}) {
    return CRMInfrastructureElasticSearchReadModelsRegionModel(
        id: id ?? this.id, name: name ?? this.name);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsAddressModel {
  CRMInfrastructureElasticSearchReadModelsAddressModel({
    this.value,
    this.supplement,
    this.city,
    this.departement,
    this.region,
  });

  factory CRMInfrastructureElasticSearchReadModelsAddressModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsAddressModelFromJson(json);

  @JsonKey(name: 'value', includeIfNull: false, defaultValue: '')
  final String? value;
  @JsonKey(name: 'supplement', includeIfNull: false, defaultValue: '')
  final String? supplement;
  @JsonKey(name: 'city', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsCityModel? city;
  @JsonKey(name: 'departement', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsDepartementModel? departement;
  @JsonKey(name: 'region', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsRegionModel? region;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsAddressModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsAddressModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsAddressModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsAddressModel &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)) &&
            (identical(other.supplement, supplement) ||
                const DeepCollectionEquality()
                    .equals(other.supplement, supplement)) &&
            (identical(other.city, city) ||
                const DeepCollectionEquality().equals(other.city, city)) &&
            (identical(other.departement, departement) ||
                const DeepCollectionEquality()
                    .equals(other.departement, departement)) &&
            (identical(other.region, region) ||
                const DeepCollectionEquality().equals(other.region, region)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(value) ^
      const DeepCollectionEquality().hash(supplement) ^
      const DeepCollectionEquality().hash(city) ^
      const DeepCollectionEquality().hash(departement) ^
      const DeepCollectionEquality().hash(region) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsAddressModelExtension
    on CRMInfrastructureElasticSearchReadModelsAddressModel {
  CRMInfrastructureElasticSearchReadModelsAddressModel copyWith(
      {String? value,
      String? supplement,
      CRMInfrastructureElasticSearchReadModelsCityModel? city,
      CRMInfrastructureElasticSearchReadModelsDepartementModel? departement,
      CRMInfrastructureElasticSearchReadModelsRegionModel? region}) {
    return CRMInfrastructureElasticSearchReadModelsAddressModel(
        value: value ?? this.value,
        supplement: supplement ?? this.supplement,
        city: city ?? this.city,
        departement: departement ?? this.departement,
        region: region ?? this.region);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureElasticSearchReadModelsContactReadModel {
  CRMInfrastructureElasticSearchReadModelsContactReadModel({
    this.id,
    this.agentId,
    this.creationDate,
    this.updateDate,
    this.identity,
    this.consentStatus,
    this.notes,
    this.status,
    this.source,
    this.address,
    this.profilesKind,
    this.hasForSaleProfile,
    this.hasSearchProfile,
  });

  factory CRMInfrastructureElasticSearchReadModelsContactReadModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureElasticSearchReadModelsContactReadModelFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'agentId', includeIfNull: false, defaultValue: '')
  final String? agentId;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'updateDate', includeIfNull: false)
  final DateTime? updateDate;
  @JsonKey(name: 'identity', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsIdentityModel? identity;
  @JsonKey(name: 'consentStatus', includeIfNull: false, defaultValue: '')
  final String? consentStatus;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'status', includeIfNull: false, defaultValue: '')
  final String? status;
  @JsonKey(name: 'source', includeIfNull: false, defaultValue: '')
  final String? source;
  @JsonKey(name: 'address', includeIfNull: false)
  final CRMInfrastructureElasticSearchReadModelsAddressModel? address;
  @JsonKey(name: 'profilesKind', includeIfNull: false, defaultValue: <String>[])
  final List<String>? profilesKind;
  @JsonKey(name: 'hasForSaleProfile', includeIfNull: false)
  final bool? hasForSaleProfile;
  @JsonKey(name: 'hasSearchProfile', includeIfNull: false)
  final bool? hasSearchProfile;
  static const fromJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsContactReadModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureElasticSearchReadModelsContactReadModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureElasticSearchReadModelsContactReadModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureElasticSearchReadModelsContactReadModel &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.updateDate, updateDate) ||
                const DeepCollectionEquality()
                    .equals(other.updateDate, updateDate)) &&
            (identical(other.identity, identity) ||
                const DeepCollectionEquality()
                    .equals(other.identity, identity)) &&
            (identical(other.consentStatus, consentStatus) ||
                const DeepCollectionEquality()
                    .equals(other.consentStatus, consentStatus)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)) &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.profilesKind, profilesKind) ||
                const DeepCollectionEquality()
                    .equals(other.profilesKind, profilesKind)) &&
            (identical(other.hasForSaleProfile, hasForSaleProfile) ||
                const DeepCollectionEquality()
                    .equals(other.hasForSaleProfile, hasForSaleProfile)) &&
            (identical(other.hasSearchProfile, hasSearchProfile) ||
                const DeepCollectionEquality()
                    .equals(other.hasSearchProfile, hasSearchProfile)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(agentId) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(updateDate) ^
      const DeepCollectionEquality().hash(identity) ^
      const DeepCollectionEquality().hash(consentStatus) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(status) ^
      const DeepCollectionEquality().hash(source) ^
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(profilesKind) ^
      const DeepCollectionEquality().hash(hasForSaleProfile) ^
      const DeepCollectionEquality().hash(hasSearchProfile) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureElasticSearchReadModelsContactReadModelExtension
    on CRMInfrastructureElasticSearchReadModelsContactReadModel {
  CRMInfrastructureElasticSearchReadModelsContactReadModel copyWith(
      {String? id,
      String? agentId,
      DateTime? creationDate,
      DateTime? updateDate,
      CRMInfrastructureElasticSearchReadModelsIdentityModel? identity,
      String? consentStatus,
      String? notes,
      String? status,
      String? source,
      CRMInfrastructureElasticSearchReadModelsAddressModel? address,
      List<String>? profilesKind,
      bool? hasForSaleProfile,
      bool? hasSearchProfile}) {
    return CRMInfrastructureElasticSearchReadModelsContactReadModel(
        id: id ?? this.id,
        agentId: agentId ?? this.agentId,
        creationDate: creationDate ?? this.creationDate,
        updateDate: updateDate ?? this.updateDate,
        identity: identity ?? this.identity,
        consentStatus: consentStatus ?? this.consentStatus,
        notes: notes ?? this.notes,
        status: status ?? this.status,
        source: source ?? this.source,
        address: address ?? this.address,
        profilesKind: profilesKind ?? this.profilesKind,
        hasForSaleProfile: hasForSaleProfile ?? this.hasForSaleProfile,
        hasSearchProfile: hasSearchProfile ?? this.hasSearchProfile);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel {
  CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel({
    this.count,
    this.total,
    this.totalPage,
    this.pageSize,
    this.pageNumber,
    this.hasMore,
    this.documents,
    this.aggregations,
  });

  factory CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModelFromJson(
          json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  @JsonKey(name: 'total', includeIfNull: false)
  final num? total;
  @JsonKey(name: 'totalPage', includeIfNull: false)
  final num? totalPage;
  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'pageNumber', includeIfNull: false)
  final int? pageNumber;
  @JsonKey(name: 'hasMore', includeIfNull: false)
  final bool? hasMore;
  @JsonKey(name: 'documents', includeIfNull: false, defaultValue: <
      CRMInfrastructureElasticSearchReadModelsContactReadModel>[])
  final List<CRMInfrastructureElasticSearchReadModelsContactReadModel>?
      documents;
  @JsonKey(name: 'aggregations', includeIfNull: false)
  final Map<String, dynamic>? aggregations;
  static const fromJsonFactory =
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModelFromJson;
  static const toJsonFactory =
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModelToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.totalPage, totalPage) ||
                const DeepCollectionEquality()
                    .equals(other.totalPage, totalPage)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.pageNumber, pageNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pageNumber, pageNumber)) &&
            (identical(other.hasMore, hasMore) ||
                const DeepCollectionEquality()
                    .equals(other.hasMore, hasMore)) &&
            (identical(other.documents, documents) ||
                const DeepCollectionEquality()
                    .equals(other.documents, documents)) &&
            (identical(other.aggregations, aggregations) ||
                const DeepCollectionEquality()
                    .equals(other.aggregations, aggregations)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(total) ^
      const DeepCollectionEquality().hash(totalPage) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(pageNumber) ^
      const DeepCollectionEquality().hash(hasMore) ^
      const DeepCollectionEquality().hash(documents) ^
      const DeepCollectionEquality().hash(aggregations) ^
      runtimeType.hashCode;
}

extension $CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModelExtension
    on CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel {
  CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel
      copyWith(
          {int? count,
          num? total,
          num? totalPage,
          int? pageSize,
          int? pageNumber,
          bool? hasMore,
          List<CRMInfrastructureElasticSearchReadModelsContactReadModel>?
              documents,
          Map<String, dynamic>? aggregations}) {
    return CRMDomainReadModelsProfilesPagedDataResult1CRMInfrastructureElasticSearchReadModelsContactReadModel(
        count: count ?? this.count,
        total: total ?? this.total,
        totalPage: totalPage ?? this.totalPage,
        pageSize: pageSize ?? this.pageSize,
        pageNumber: pageNumber ?? this.pageNumber,
        hasMore: hasMore ?? this.hasMore,
        documents: documents ?? this.documents,
        aggregations: aggregations ?? this.aggregations);
  }
}

@JsonSerializable(explicitToJson: true)
class ProfessionalInfosDto {
  ProfessionalInfosDto({
    this.professionalCategory,
    this.profession,
    this.company,
    this.companyRole,
  });

  factory ProfessionalInfosDto.fromJson(Map<String, dynamic> json) =>
      _$ProfessionalInfosDtoFromJson(json);

  @JsonKey(name: 'professionalCategory', includeIfNull: false, defaultValue: '')
  final String? professionalCategory;
  @JsonKey(name: 'profession', includeIfNull: false, defaultValue: '')
  final String? profession;
  @JsonKey(name: 'company', includeIfNull: false, defaultValue: '')
  final String? company;
  @JsonKey(name: 'companyRole', includeIfNull: false, defaultValue: '')
  final String? companyRole;
  static const fromJsonFactory = _$ProfessionalInfosDtoFromJson;
  static const toJsonFactory = _$ProfessionalInfosDtoToJson;
  Map<String, dynamic> toJson() => _$ProfessionalInfosDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is ProfessionalInfosDto &&
            (identical(other.professionalCategory, professionalCategory) ||
                const DeepCollectionEquality().equals(
                    other.professionalCategory, professionalCategory)) &&
            (identical(other.profession, profession) ||
                const DeepCollectionEquality()
                    .equals(other.profession, profession)) &&
            (identical(other.company, company) ||
                const DeepCollectionEquality()
                    .equals(other.company, company)) &&
            (identical(other.companyRole, companyRole) ||
                const DeepCollectionEquality()
                    .equals(other.companyRole, companyRole)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(professionalCategory) ^
      const DeepCollectionEquality().hash(profession) ^
      const DeepCollectionEquality().hash(company) ^
      const DeepCollectionEquality().hash(companyRole) ^
      runtimeType.hashCode;
}

extension $ProfessionalInfosDtoExtension on ProfessionalInfosDto {
  ProfessionalInfosDto copyWith(
      {String? professionalCategory,
      String? profession,
      String? company,
      String? companyRole}) {
    return ProfessionalInfosDto(
        professionalCategory: professionalCategory ?? this.professionalCategory,
        profession: profession ?? this.profession,
        company: company ?? this.company,
        companyRole: companyRole ?? this.companyRole);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIPortfolioControllersDtoEmailDto {
  CRMAPIPortfolioControllersDtoEmailDto({
    this.address,
    this.kind,
  });

  factory CRMAPIPortfolioControllersDtoEmailDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIPortfolioControllersDtoEmailDtoFromJson(json);

  @JsonKey(name: 'address', includeIfNull: false, defaultValue: '')
  final String? address;
  @JsonKey(
      name: 'kind',
      includeIfNull: false,
      toJson: cRMAPIPortfolioControllersDtoEmailKindToJson,
      fromJson: cRMAPIPortfolioControllersDtoEmailKindFromJson)
  final enums.CRMAPIPortfolioControllersDtoEmailKind? kind;
  static const fromJsonFactory =
      _$CRMAPIPortfolioControllersDtoEmailDtoFromJson;
  static const toJsonFactory = _$CRMAPIPortfolioControllersDtoEmailDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIPortfolioControllersDtoEmailDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIPortfolioControllersDtoEmailDto &&
            (identical(other.address, address) ||
                const DeepCollectionEquality()
                    .equals(other.address, address)) &&
            (identical(other.kind, kind) ||
                const DeepCollectionEquality().equals(other.kind, kind)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(address) ^
      const DeepCollectionEquality().hash(kind) ^
      runtimeType.hashCode;
}

extension $CRMAPIPortfolioControllersDtoEmailDtoExtension
    on CRMAPIPortfolioControllersDtoEmailDto {
  CRMAPIPortfolioControllersDtoEmailDto copyWith(
      {String? address, enums.CRMAPIPortfolioControllersDtoEmailKind? kind}) {
    return CRMAPIPortfolioControllersDtoEmailDto(
        address: address ?? this.address, kind: kind ?? this.kind);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIPortfolioControllersDtoPhoneDto {
  CRMAPIPortfolioControllersDtoPhoneDto({
    this.$number,
    this.kind,
  });

  factory CRMAPIPortfolioControllersDtoPhoneDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIPortfolioControllersDtoPhoneDtoFromJson(json);

  @JsonKey(name: 'number', includeIfNull: false, defaultValue: '')
  final String? $number;
  @JsonKey(
      name: 'kind',
      includeIfNull: false,
      toJson: cRMAPIPortfolioControllersDtoPhoneKindToJson,
      fromJson: cRMAPIPortfolioControllersDtoPhoneKindFromJson)
  final enums.CRMAPIPortfolioControllersDtoPhoneKind? kind;
  static const fromJsonFactory =
      _$CRMAPIPortfolioControllersDtoPhoneDtoFromJson;
  static const toJsonFactory = _$CRMAPIPortfolioControllersDtoPhoneDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIPortfolioControllersDtoPhoneDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIPortfolioControllersDtoPhoneDto &&
            (identical(other.$number, $number) ||
                const DeepCollectionEquality()
                    .equals(other.$number, $number)) &&
            (identical(other.kind, kind) ||
                const DeepCollectionEquality().equals(other.kind, kind)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash($number) ^
      const DeepCollectionEquality().hash(kind) ^
      runtimeType.hashCode;
}

extension $CRMAPIPortfolioControllersDtoPhoneDtoExtension
    on CRMAPIPortfolioControllersDtoPhoneDto {
  CRMAPIPortfolioControllersDtoPhoneDto copyWith(
      {String? $number, enums.CRMAPIPortfolioControllersDtoPhoneKind? kind}) {
    return CRMAPIPortfolioControllersDtoPhoneDto(
        $number: $number ?? this.$number, kind: kind ?? this.kind);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIPortfolioControllersDtoCityDto {
  CRMAPIPortfolioControllersDtoCityDto({
    this.id,
    this.name,
    this.postalCodes,
    this.inseeCode,
  });

  factory CRMAPIPortfolioControllersDtoCityDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIPortfolioControllersDtoCityDtoFromJson(json);

  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'name', includeIfNull: false, defaultValue: '')
  final String? name;
  @JsonKey(name: 'postalCodes', includeIfNull: false, defaultValue: <String>[])
  final List<String>? postalCodes;
  @JsonKey(name: 'inseeCode', includeIfNull: false, defaultValue: '')
  final String? inseeCode;
  static const fromJsonFactory = _$CRMAPIPortfolioControllersDtoCityDtoFromJson;
  static const toJsonFactory = _$CRMAPIPortfolioControllersDtoCityDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIPortfolioControllersDtoCityDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIPortfolioControllersDtoCityDto &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.name, name) ||
                const DeepCollectionEquality().equals(other.name, name)) &&
            (identical(other.postalCodes, postalCodes) ||
                const DeepCollectionEquality()
                    .equals(other.postalCodes, postalCodes)) &&
            (identical(other.inseeCode, inseeCode) ||
                const DeepCollectionEquality()
                    .equals(other.inseeCode, inseeCode)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(name) ^
      const DeepCollectionEquality().hash(postalCodes) ^
      const DeepCollectionEquality().hash(inseeCode) ^
      runtimeType.hashCode;
}

extension $CRMAPIPortfolioControllersDtoCityDtoExtension
    on CRMAPIPortfolioControllersDtoCityDto {
  CRMAPIPortfolioControllersDtoCityDto copyWith(
      {String? id,
      String? name,
      List<String>? postalCodes,
      String? inseeCode}) {
    return CRMAPIPortfolioControllersDtoCityDto(
        id: id ?? this.id,
        name: name ?? this.name,
        postalCodes: postalCodes ?? this.postalCodes,
        inseeCode: inseeCode ?? this.inseeCode);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIPortfolioControllersDtoIdentityDto {
  CRMAPIPortfolioControllersDtoIdentityDto({
    this.gender,
    this.firstName,
    this.lastName,
    this.professionalInfos,
    this.emails,
    this.phones,
    this.birthDate,
    this.birthPlace,
  });

  factory CRMAPIPortfolioControllersDtoIdentityDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIPortfolioControllersDtoIdentityDtoFromJson(json);

  @JsonKey(
      name: 'gender',
      includeIfNull: false,
      toJson: cRMAPIPortfolioControllersDtoGenderDtoToJson,
      fromJson: cRMAPIPortfolioControllersDtoGenderDtoFromJson)
  final enums.CRMAPIPortfolioControllersDtoGenderDto? gender;
  @JsonKey(name: 'firstName', includeIfNull: false, defaultValue: '')
  final String? firstName;
  @JsonKey(name: 'lastName', includeIfNull: false, defaultValue: '')
  final String? lastName;
  @JsonKey(name: 'professionalInfos', includeIfNull: false)
  final ProfessionalInfosDto? professionalInfos;
  @JsonKey(
      name: 'emails',
      includeIfNull: false,
      defaultValue: <CRMAPIPortfolioControllersDtoEmailDto>[])
  final List<CRMAPIPortfolioControllersDtoEmailDto>? emails;
  @JsonKey(
      name: 'phones',
      includeIfNull: false,
      defaultValue: <CRMAPIPortfolioControllersDtoPhoneDto>[])
  final List<CRMAPIPortfolioControllersDtoPhoneDto>? phones;
  @JsonKey(name: 'birthDate', includeIfNull: false)
  final DateTime? birthDate;
  @JsonKey(name: 'birthPlace', includeIfNull: false)
  final CRMAPIPortfolioControllersDtoCityDto? birthPlace;
  static const fromJsonFactory =
      _$CRMAPIPortfolioControllersDtoIdentityDtoFromJson;
  static const toJsonFactory = _$CRMAPIPortfolioControllersDtoIdentityDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIPortfolioControllersDtoIdentityDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIPortfolioControllersDtoIdentityDto &&
            (identical(other.gender, gender) ||
                const DeepCollectionEquality().equals(other.gender, gender)) &&
            (identical(other.firstName, firstName) ||
                const DeepCollectionEquality()
                    .equals(other.firstName, firstName)) &&
            (identical(other.lastName, lastName) ||
                const DeepCollectionEquality()
                    .equals(other.lastName, lastName)) &&
            (identical(other.professionalInfos, professionalInfos) ||
                const DeepCollectionEquality()
                    .equals(other.professionalInfos, professionalInfos)) &&
            (identical(other.emails, emails) ||
                const DeepCollectionEquality().equals(other.emails, emails)) &&
            (identical(other.phones, phones) ||
                const DeepCollectionEquality().equals(other.phones, phones)) &&
            (identical(other.birthDate, birthDate) ||
                const DeepCollectionEquality()
                    .equals(other.birthDate, birthDate)) &&
            (identical(other.birthPlace, birthPlace) ||
                const DeepCollectionEquality()
                    .equals(other.birthPlace, birthPlace)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(gender) ^
      const DeepCollectionEquality().hash(firstName) ^
      const DeepCollectionEquality().hash(lastName) ^
      const DeepCollectionEquality().hash(professionalInfos) ^
      const DeepCollectionEquality().hash(emails) ^
      const DeepCollectionEquality().hash(phones) ^
      const DeepCollectionEquality().hash(birthDate) ^
      const DeepCollectionEquality().hash(birthPlace) ^
      runtimeType.hashCode;
}

extension $CRMAPIPortfolioControllersDtoIdentityDtoExtension
    on CRMAPIPortfolioControllersDtoIdentityDto {
  CRMAPIPortfolioControllersDtoIdentityDto copyWith(
      {enums.CRMAPIPortfolioControllersDtoGenderDto? gender,
      String? firstName,
      String? lastName,
      ProfessionalInfosDto? professionalInfos,
      List<CRMAPIPortfolioControllersDtoEmailDto>? emails,
      List<CRMAPIPortfolioControllersDtoPhoneDto>? phones,
      DateTime? birthDate,
      CRMAPIPortfolioControllersDtoCityDto? birthPlace}) {
    return CRMAPIPortfolioControllersDtoIdentityDto(
        gender: gender ?? this.gender,
        firstName: firstName ?? this.firstName,
        lastName: lastName ?? this.lastName,
        professionalInfos: professionalInfos ?? this.professionalInfos,
        emails: emails ?? this.emails,
        phones: phones ?? this.phones,
        birthDate: birthDate ?? this.birthDate,
        birthPlace: birthPlace ?? this.birthPlace);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIPortfolioControllersDtoWriteContactDto {
  CRMAPIPortfolioControllersDtoWriteContactDto({
    this.consentStatus,
    required this.identity,
    this.notes,
    this.addressValue,
    this.addressSupplement,
    this.addressCity,
    this.addressDepartementId,
    this.addressDepartementName,
    this.addressRegionId,
    this.addressRegionName,
    this.source,
    this.birthPlace,
    this.status,
  });

  factory CRMAPIPortfolioControllersDtoWriteContactDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIPortfolioControllersDtoWriteContactDtoFromJson(json);

  @JsonKey(
      name: 'consentStatus',
      includeIfNull: false,
      toJson: cRMAPIPortfolioControllersDtoConsentStatusEnumToJson,
      fromJson: cRMAPIPortfolioControllersDtoConsentStatusEnumFromJson)
  final enums.CRMAPIPortfolioControllersDtoConsentStatusEnum? consentStatus;
  @JsonKey(name: 'identity', includeIfNull: false)
  final CRMAPIPortfolioControllersDtoIdentityDto identity;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'addressValue', includeIfNull: false, defaultValue: '')
  final String? addressValue;
  @JsonKey(name: 'addressSupplement', includeIfNull: false, defaultValue: '')
  final String? addressSupplement;
  @JsonKey(name: 'addressCity', includeIfNull: false, defaultValue: '')
  final String? addressCity;
  @JsonKey(name: 'addressDepartementId', includeIfNull: false, defaultValue: '')
  final String? addressDepartementId;
  @JsonKey(
      name: 'addressDepartementName', includeIfNull: false, defaultValue: '')
  final String? addressDepartementName;
  @JsonKey(name: 'addressRegionId', includeIfNull: false, defaultValue: '')
  final String? addressRegionId;
  @JsonKey(name: 'addressRegionName', includeIfNull: false, defaultValue: '')
  final String? addressRegionName;
  @JsonKey(
      name: 'source',
      includeIfNull: false,
      toJson: sourceEnumToJson,
      fromJson: sourceEnumFromJson)
  final enums.SourceEnum? source;
  @JsonKey(name: 'birthPlace', includeIfNull: false, defaultValue: '')
  final String? birthPlace;
  @JsonKey(
      name: 'status',
      includeIfNull: false,
      toJson: cRMAPIPortfolioControllersDtoStatusEnumToJson,
      fromJson: cRMAPIPortfolioControllersDtoStatusEnumFromJson)
  final enums.CRMAPIPortfolioControllersDtoStatusEnum? status;
  static const fromJsonFactory =
      _$CRMAPIPortfolioControllersDtoWriteContactDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIPortfolioControllersDtoWriteContactDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIPortfolioControllersDtoWriteContactDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIPortfolioControllersDtoWriteContactDto &&
            (identical(other.consentStatus, consentStatus) ||
                const DeepCollectionEquality()
                    .equals(other.consentStatus, consentStatus)) &&
            (identical(other.identity, identity) ||
                const DeepCollectionEquality()
                    .equals(other.identity, identity)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.addressValue, addressValue) ||
                const DeepCollectionEquality()
                    .equals(other.addressValue, addressValue)) &&
            (identical(other.addressSupplement, addressSupplement) ||
                const DeepCollectionEquality()
                    .equals(other.addressSupplement, addressSupplement)) &&
            (identical(other.addressCity, addressCity) ||
                const DeepCollectionEquality()
                    .equals(other.addressCity, addressCity)) &&
            (identical(other.addressDepartementId, addressDepartementId) ||
                const DeepCollectionEquality().equals(
                    other.addressDepartementId, addressDepartementId)) &&
            (identical(other.addressDepartementName, addressDepartementName) ||
                const DeepCollectionEquality().equals(
                    other.addressDepartementName, addressDepartementName)) &&
            (identical(other.addressRegionId, addressRegionId) ||
                const DeepCollectionEquality()
                    .equals(other.addressRegionId, addressRegionId)) &&
            (identical(other.addressRegionName, addressRegionName) ||
                const DeepCollectionEquality()
                    .equals(other.addressRegionName, addressRegionName)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)) &&
            (identical(other.birthPlace, birthPlace) ||
                const DeepCollectionEquality()
                    .equals(other.birthPlace, birthPlace)) &&
            (identical(other.status, status) ||
                const DeepCollectionEquality().equals(other.status, status)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(consentStatus) ^
      const DeepCollectionEquality().hash(identity) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(addressValue) ^
      const DeepCollectionEquality().hash(addressSupplement) ^
      const DeepCollectionEquality().hash(addressCity) ^
      const DeepCollectionEquality().hash(addressDepartementId) ^
      const DeepCollectionEquality().hash(addressDepartementName) ^
      const DeepCollectionEquality().hash(addressRegionId) ^
      const DeepCollectionEquality().hash(addressRegionName) ^
      const DeepCollectionEquality().hash(source) ^
      const DeepCollectionEquality().hash(birthPlace) ^
      const DeepCollectionEquality().hash(status) ^
      runtimeType.hashCode;
}

extension $CRMAPIPortfolioControllersDtoWriteContactDtoExtension
    on CRMAPIPortfolioControllersDtoWriteContactDto {
  CRMAPIPortfolioControllersDtoWriteContactDto copyWith(
      {enums.CRMAPIPortfolioControllersDtoConsentStatusEnum? consentStatus,
      CRMAPIPortfolioControllersDtoIdentityDto? identity,
      String? notes,
      String? addressValue,
      String? addressSupplement,
      String? addressCity,
      String? addressDepartementId,
      String? addressDepartementName,
      String? addressRegionId,
      String? addressRegionName,
      enums.SourceEnum? source,
      String? birthPlace,
      enums.CRMAPIPortfolioControllersDtoStatusEnum? status}) {
    return CRMAPIPortfolioControllersDtoWriteContactDto(
        consentStatus: consentStatus ?? this.consentStatus,
        identity: identity ?? this.identity,
        notes: notes ?? this.notes,
        addressValue: addressValue ?? this.addressValue,
        addressSupplement: addressSupplement ?? this.addressSupplement,
        addressCity: addressCity ?? this.addressCity,
        addressDepartementId: addressDepartementId ?? this.addressDepartementId,
        addressDepartementName:
            addressDepartementName ?? this.addressDepartementName,
        addressRegionId: addressRegionId ?? this.addressRegionId,
        addressRegionName: addressRegionName ?? this.addressRegionName,
        source: source ?? this.source,
        birthPlace: birthPlace ?? this.birthPlace,
        status: status ?? this.status);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIPortfolioControllersDtoConsentStatusDto {
  CRMAPIPortfolioControllersDtoConsentStatusDto({
    this.consentStatus,
  });

  factory CRMAPIPortfolioControllersDtoConsentStatusDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIPortfolioControllersDtoConsentStatusDtoFromJson(json);

  @JsonKey(
      name: 'consentStatus',
      includeIfNull: false,
      toJson: cRMAPIPortfolioControllersDtoConsentStatusEnumToJson,
      fromJson: cRMAPIPortfolioControllersDtoConsentStatusEnumFromJson)
  final enums.CRMAPIPortfolioControllersDtoConsentStatusEnum? consentStatus;
  static const fromJsonFactory =
      _$CRMAPIPortfolioControllersDtoConsentStatusDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIPortfolioControllersDtoConsentStatusDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIPortfolioControllersDtoConsentStatusDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIPortfolioControllersDtoConsentStatusDto &&
            (identical(other.consentStatus, consentStatus) ||
                const DeepCollectionEquality()
                    .equals(other.consentStatus, consentStatus)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(consentStatus) ^ runtimeType.hashCode;
}

extension $CRMAPIPortfolioControllersDtoConsentStatusDtoExtension
    on CRMAPIPortfolioControllersDtoConsentStatusDto {
  CRMAPIPortfolioControllersDtoConsentStatusDto copyWith(
      {enums.CRMAPIPortfolioControllersDtoConsentStatusEnum? consentStatus}) {
    return CRMAPIPortfolioControllersDtoConsentStatusDto(
        consentStatus: consentStatus ?? this.consentStatus);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMInfrastructureProfilesModelProfileModel {
  CRMInfrastructureProfilesModelProfileModel({
    this.contactId,
    this.agentId,
    this.reference,
    this.lastModificationDate,
    this.creationDate,
    this.archivingDate,
    this.source,
    this.id,
    this.timestamp,
  });

  factory CRMInfrastructureProfilesModelProfileModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMInfrastructureProfilesModelProfileModelFromJson(json);

  @JsonKey(name: 'contactId', includeIfNull: false, defaultValue: '')
  final String? contactId;
  @JsonKey(name: 'agentId', includeIfNull: false, defaultValue: '')
  final String? agentId;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'lastModificationDate', includeIfNull: false)
  final DateTime? lastModificationDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'source', includeIfNull: false, defaultValue: '')
  final String? source;
  @JsonKey(name: 'id', includeIfNull: false, defaultValue: '')
  final String? id;
  @JsonKey(name: 'timestamp', includeIfNull: false)
  final DateTime? timestamp;
  static const fromJsonFactory =
      _$CRMInfrastructureProfilesModelProfileModelFromJson;
  static const toJsonFactory =
      _$CRMInfrastructureProfilesModelProfileModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMInfrastructureProfilesModelProfileModelToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMInfrastructureProfilesModelProfileModel &&
            (identical(other.contactId, contactId) ||
                const DeepCollectionEquality()
                    .equals(other.contactId, contactId)) &&
            (identical(other.agentId, agentId) ||
                const DeepCollectionEquality()
                    .equals(other.agentId, agentId)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.lastModificationDate, lastModificationDate) ||
                const DeepCollectionEquality().equals(
                    other.lastModificationDate, lastModificationDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.source, source) ||
                const DeepCollectionEquality().equals(other.source, source)) &&
            (identical(other.id, id) ||
                const DeepCollectionEquality().equals(other.id, id)) &&
            (identical(other.timestamp, timestamp) ||
                const DeepCollectionEquality()
                    .equals(other.timestamp, timestamp)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(contactId) ^
      const DeepCollectionEquality().hash(agentId) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(lastModificationDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(source) ^
      const DeepCollectionEquality().hash(id) ^
      const DeepCollectionEquality().hash(timestamp) ^
      runtimeType.hashCode;
}

extension $CRMInfrastructureProfilesModelProfileModelExtension
    on CRMInfrastructureProfilesModelProfileModel {
  CRMInfrastructureProfilesModelProfileModel copyWith(
      {String? contactId,
      String? agentId,
      String? reference,
      DateTime? lastModificationDate,
      DateTime? creationDate,
      DateTime? archivingDate,
      String? source,
      String? id,
      DateTime? timestamp}) {
    return CRMInfrastructureProfilesModelProfileModel(
        contactId: contactId ?? this.contactId,
        agentId: agentId ?? this.agentId,
        reference: reference ?? this.reference,
        lastModificationDate: lastModificationDate ?? this.lastModificationDate,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        source: source ?? this.source,
        id: id ?? this.id,
        timestamp: timestamp ?? this.timestamp);
  }
}

@JsonSerializable(explicitToJson: true)
class SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64 {
  SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64({
    this.key,
    this.value,
  });

  factory SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64.fromJson(
          Map<String, dynamic> json) =>
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64FromJson(
          json);

  @JsonKey(name: 'key', includeIfNull: false, defaultValue: '')
  final String? key;
  @JsonKey(name: 'value', includeIfNull: false)
  final num? value;
  static const fromJsonFactory =
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64FromJson;
  static const toJsonFactory =
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64ToJson;
  Map<String, dynamic> toJson() =>
      _$SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64ToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64 &&
            (identical(other.key, key) ||
                const DeepCollectionEquality().equals(other.key, key)) &&
            (identical(other.value, value) ||
                const DeepCollectionEquality().equals(other.value, value)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(key) ^
      const DeepCollectionEquality().hash(value) ^
      runtimeType.hashCode;
}

extension $SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64Extension
    on SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64 {
  SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64
      copyWith({String? key, num? value}) {
    return SystemCollectionsGenericKeyValuePair2SystemStringSystemNullable1SystemInt64(
        key: key ?? this.key, value: value ?? this.value);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel {
  CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel({
    this.count,
    this.total,
    this.totalPage,
    this.pageSize,
    this.pageNumber,
    this.hasMore,
    this.documents,
    this.aggregations,
  });

  factory CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModelFromJson(
          json);

  @JsonKey(name: 'count', includeIfNull: false)
  final int? count;
  @JsonKey(name: 'total', includeIfNull: false)
  final num? total;
  @JsonKey(name: 'totalPage', includeIfNull: false)
  final num? totalPage;
  @JsonKey(name: 'pageSize', includeIfNull: false)
  final int? pageSize;
  @JsonKey(name: 'pageNumber', includeIfNull: false)
  final int? pageNumber;
  @JsonKey(name: 'hasMore', includeIfNull: false)
  final bool? hasMore;
  @JsonKey(
      name: 'documents',
      includeIfNull: false,
      defaultValue: <CRMInfrastructureProfilesModelProfileModel>[])
  final List<CRMInfrastructureProfilesModelProfileModel>? documents;
  @JsonKey(name: 'aggregations', includeIfNull: false)
  final Map<String, dynamic>? aggregations;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModelFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModelToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModelToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel &&
            (identical(other.count, count) ||
                const DeepCollectionEquality().equals(other.count, count)) &&
            (identical(other.total, total) ||
                const DeepCollectionEquality().equals(other.total, total)) &&
            (identical(other.totalPage, totalPage) ||
                const DeepCollectionEquality()
                    .equals(other.totalPage, totalPage)) &&
            (identical(other.pageSize, pageSize) ||
                const DeepCollectionEquality()
                    .equals(other.pageSize, pageSize)) &&
            (identical(other.pageNumber, pageNumber) ||
                const DeepCollectionEquality()
                    .equals(other.pageNumber, pageNumber)) &&
            (identical(other.hasMore, hasMore) ||
                const DeepCollectionEquality()
                    .equals(other.hasMore, hasMore)) &&
            (identical(other.documents, documents) ||
                const DeepCollectionEquality()
                    .equals(other.documents, documents)) &&
            (identical(other.aggregations, aggregations) ||
                const DeepCollectionEquality()
                    .equals(other.aggregations, aggregations)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(count) ^
      const DeepCollectionEquality().hash(total) ^
      const DeepCollectionEquality().hash(totalPage) ^
      const DeepCollectionEquality().hash(pageSize) ^
      const DeepCollectionEquality().hash(pageNumber) ^
      const DeepCollectionEquality().hash(hasMore) ^
      const DeepCollectionEquality().hash(documents) ^
      const DeepCollectionEquality().hash(aggregations) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModelExtension
    on CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel {
  CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel
      copyWith(
          {int? count,
          num? total,
          num? totalPage,
          int? pageSize,
          int? pageNumber,
          bool? hasMore,
          List<CRMInfrastructureProfilesModelProfileModel>? documents,
          Map<String, dynamic>? aggregations}) {
    return CRMAPIProfilesDtoPagedDataResultDto1CRMInfrastructureProfilesModelProfileModel(
        count: count ?? this.count,
        total: total ?? this.total,
        totalPage: totalPage ?? this.totalPage,
        pageSize: pageSize ?? this.pageSize,
        pageNumber: pageNumber ?? this.pageNumber,
        hasMore: hasMore ?? this.hasMore,
        documents: documents ?? this.documents,
        aggregations: aggregations ?? this.aggregations);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto {
  CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto({
    this.maxMatching,
    this.max,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDtoFromJson(
          json);

  @JsonKey(name: 'maxMatching', includeIfNull: false)
  final double? maxMatching;
  @JsonKey(name: 'max', includeIfNull: false)
  final double? max;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto &&
            (identical(other.maxMatching, maxMatching) ||
                const DeepCollectionEquality()
                    .equals(other.maxMatching, maxMatching)) &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maxMatching) ^
      const DeepCollectionEquality().hash(max) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto {
  CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto copyWith(
      {double? maxMatching, double? max}) {
    return CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto(
        maxMatching: maxMatching ?? this.maxMatching, max: max ?? this.max);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto {
  CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto({
    this.min,
    this.maxMatching,
    this.max,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDtoFromJson(
          json);

  @JsonKey(name: 'min', includeIfNull: false)
  final double? min;
  @JsonKey(name: 'maxMatching', includeIfNull: false)
  final double? maxMatching;
  @JsonKey(name: 'max', includeIfNull: false)
  final double? max;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto &&
            (identical(other.min, min) ||
                const DeepCollectionEquality().equals(other.min, min)) &&
            (identical(other.maxMatching, maxMatching) ||
                const DeepCollectionEquality()
                    .equals(other.maxMatching, maxMatching)) &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(min) ^
      const DeepCollectionEquality().hash(maxMatching) ^
      const DeepCollectionEquality().hash(max) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto {
  CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto copyWith(
      {double? min, double? maxMatching, double? max}) {
    return CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto(
        min: min ?? this.min,
        maxMatching: maxMatching ?? this.maxMatching,
        max: max ?? this.max);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto {
  CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto({
    this.income,
    this.bouquet,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoFromJson(json);

  @JsonKey(name: 'income', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto? income;
  @JsonKey(name: 'bouquet', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto?
      bouquet;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto &&
            (identical(other.income, income) ||
                const DeepCollectionEquality().equals(other.income, income)) &&
            (identical(other.bouquet, bouquet) ||
                const DeepCollectionEquality().equals(other.bouquet, bouquet)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(income) ^
      const DeepCollectionEquality().hash(bouquet) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto {
  CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto copyWith(
      {CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoIncomeDto? income,
      CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDtoBouquetDto?
          bouquet}) {
    return CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto(
        income: income ?? this.income, bouquet: bouquet ?? this.bouquet);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoLotSizeDto {
  CRMAPIProfilesDtoLotSizeDto({
    this.max,
    this.min,
  });

  factory CRMAPIProfilesDtoLotSizeDto.fromJson(Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoLotSizeDtoFromJson(json);

  @JsonKey(name: 'max', includeIfNull: false)
  final double? max;
  @JsonKey(name: 'min', includeIfNull: false)
  final double? min;
  static const fromJsonFactory = _$CRMAPIProfilesDtoLotSizeDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoLotSizeDtoToJson;
  Map<String, dynamic> toJson() => _$CRMAPIProfilesDtoLotSizeDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoLotSizeDto &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)) &&
            (identical(other.min, min) ||
                const DeepCollectionEquality().equals(other.min, min)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(max) ^
      const DeepCollectionEquality().hash(min) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoLotSizeDtoExtension on CRMAPIProfilesDtoLotSizeDto {
  CRMAPIProfilesDtoLotSizeDto copyWith({double? max, double? min}) {
    return CRMAPIProfilesDtoLotSizeDto(
        max: max ?? this.max, min: min ?? this.min);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoHomeSizeDto {
  CRMAPIProfilesDtoHomeSizeDto({
    this.max,
    this.min,
  });

  factory CRMAPIProfilesDtoHomeSizeDto.fromJson(Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoHomeSizeDtoFromJson(json);

  @JsonKey(name: 'max', includeIfNull: false)
  final double? max;
  @JsonKey(name: 'min', includeIfNull: false)
  final double? min;
  static const fromJsonFactory = _$CRMAPIProfilesDtoHomeSizeDtoFromJson;
  static const toJsonFactory = _$CRMAPIProfilesDtoHomeSizeDtoToJson;
  Map<String, dynamic> toJson() => _$CRMAPIProfilesDtoHomeSizeDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoHomeSizeDto &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)) &&
            (identical(other.min, min) ||
                const DeepCollectionEquality().equals(other.min, min)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(max) ^
      const DeepCollectionEquality().hash(min) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoHomeSizeDtoExtension
    on CRMAPIProfilesDtoHomeSizeDto {
  CRMAPIProfilesDtoHomeSizeDto copyWith({double? max, double? min}) {
    return CRMAPIProfilesDtoHomeSizeDto(
        max: max ?? this.max, min: min ?? this.min);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto({
    this.vacancy,
    this.withParking,
    this.withElevator,
    this.minBedrooms,
    this.minRooms,
    this.places,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
    this.constructionYears,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'vacancy',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType? vacancy;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  @JsonKey(name: 'minBedrooms', includeIfNull: false)
  final int? minBedrooms;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto &&
            (identical(other.vacancy, vacancy) ||
                const DeepCollectionEquality()
                    .equals(other.vacancy, vacancy)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)) &&
            (identical(other.minBedrooms, minBedrooms) ||
                const DeepCollectionEquality()
                    .equals(other.minBedrooms, minBedrooms)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(vacancy) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      const DeepCollectionEquality().hash(minBedrooms) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto
      copyWith(
          {enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType?
              vacancy,
          bool? withParking,
          bool? withElevator,
          int? minBedrooms,
          int? minRooms,
          List<CRMAPIProfilesDtoPlaceDto>? places,
          enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
          CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget,
          CRMAPIProfilesDtoLotSizeDto? lotSize,
          CRMAPIProfilesDtoHomeSizeDto? homeSize,
          List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
              constructionYears}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto(
        vacancy: vacancy ?? this.vacancy,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator,
        minBedrooms: minBedrooms ?? this.minBedrooms,
        minRooms: minRooms ?? this.minRooms,
        places: places ?? this.places,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        constructionYears: constructionYears ?? this.constructionYears);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto({
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto?
      criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto
      copyWith(
          {String? reference,
          String? notes,
          CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentCriteriaDto?
              criteria,
          DateTime? creationDate,
          DateTime? archivingDate,
          enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityApartmentProfileWriteDto(
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto({
    this.vacancy,
    this.homeSize,
    this.lotSize,
    this.maturity,
    this.budget,
    this.places,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'vacancy',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType? vacancy;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto &&
            (identical(other.vacancy, vacancy) ||
                const DeepCollectionEquality()
                    .equals(other.vacancy, vacancy)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(vacancy) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto
      copyWith(
          {enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType?
              vacancy,
          CRMAPIProfilesDtoHomeSizeDto? homeSize,
          CRMAPIProfilesDtoLotSizeDto? lotSize,
          enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
          CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget,
          List<CRMAPIProfilesDtoPlaceDto>? places}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto(
        vacancy: vacancy ?? this.vacancy,
        homeSize: homeSize ?? this.homeSize,
        lotSize: lotSize ?? this.lotSize,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.archivingDate,
    this.creationDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto?
      criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto
      copyWith(
          {String? reference,
          enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
          String? notes,
          CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingCriteriaDto?
              criteria,
          DateTime? archivingDate,
          DateTime? creationDate,
          enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityBuildingProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        creationDate: creationDate ?? this.creationDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto({
    this.vacancy,
    this.withParking,
    this.withElevator,
    this.minBedrooms,
    this.minRooms,
    this.places,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
    this.constructionYears,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'vacancy',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType? vacancy;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  @JsonKey(name: 'minBedrooms', includeIfNull: false)
  final int? minBedrooms;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto &&
            (identical(other.vacancy, vacancy) ||
                const DeepCollectionEquality()
                    .equals(other.vacancy, vacancy)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)) &&
            (identical(other.minBedrooms, minBedrooms) ||
                const DeepCollectionEquality()
                    .equals(other.minBedrooms, minBedrooms)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(vacancy) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      const DeepCollectionEquality().hash(minBedrooms) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType? vacancy,
      bool? withParking,
      bool? withElevator,
      int? minBedrooms,
      int? minRooms,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto(
        vacancy: vacancy ?? this.vacancy,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator,
        minBedrooms: minBedrooms ?? this.minBedrooms,
        minRooms: minRooms ?? this.minRooms,
        places: places ?? this.places,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        constructionYears: constructionYears ?? this.constructionYears);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.archivingDate,
    this.creationDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto?
      criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto
      copyWith(
          {String? reference,
          enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
          String? notes,
          CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseCriteriaDto?
              criteria,
          DateTime? archivingDate,
          DateTime? creationDate,
          enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityHouseProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        creationDate: creationDate ?? this.creationDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto({
    this.maturity,
    this.budget,
    this.places,
    this.lotSize,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality().equals(other.lotSize, lotSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(lotSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      CRMAPIProfilesDtoLotSizeDto? lotSize}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto(
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places,
        lotSize: lotSize ?? this.lotSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.archivingDate,
    this.creationDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto?
      criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto
      copyWith(
          {String? reference,
          enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
          String? notes,
          CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandCriteriaDto?
              criteria,
          DateTime? archivingDate,
          DateTime? creationDate,
          enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityLandProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        creationDate: creationDate ?? this.creationDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto({
    this.vacancy,
    this.minRooms,
    this.lotSize,
    this.homeSize,
    this.maturity,
    this.budget,
    this.places,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'vacancy',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType? vacancy;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto &&
            (identical(other.vacancy, vacancy) ||
                const DeepCollectionEquality()
                    .equals(other.vacancy, vacancy)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(vacancy) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto
      copyWith(
          {enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType?
              vacancy,
          int? minRooms,
          CRMAPIProfilesDtoLotSizeDto? lotSize,
          CRMAPIProfilesDtoHomeSizeDto? homeSize,
          enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
          CRMAPIProfilesDtoSearchLifeAnnuityBudgetLifeAnnuityDto? budget,
          List<CRMAPIProfilesDtoPlaceDto>? places}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto(
        vacancy: vacancy ?? this.vacancy,
        minRooms: minRooms ?? this.minRooms,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.archivingDate,
    this.creationDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto?
      criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto {
  CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto
      copyWith(
          {String? reference,
          enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
          String? notes,
          CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesCriteriaDto?
              criteria,
          DateTime? archivingDate,
          DateTime? creationDate,
          enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchLifeAnnuitySearchLifeAnnuityPremisesProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        creationDate: creationDate ?? this.creationDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto {
  CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto({
    this.min,
    this.maxMatching,
    this.max,
  });

  factory CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDtoFromJson(json);

  @JsonKey(name: 'min', includeIfNull: false)
  final double? min;
  @JsonKey(name: 'maxMatching', includeIfNull: false)
  final double? maxMatching;
  @JsonKey(name: 'max', includeIfNull: false)
  final double? max;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto &&
            (identical(other.min, min) ||
                const DeepCollectionEquality().equals(other.min, min)) &&
            (identical(other.maxMatching, maxMatching) ||
                const DeepCollectionEquality()
                    .equals(other.maxMatching, maxMatching)) &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(min) ^
      const DeepCollectionEquality().hash(maxMatching) ^
      const DeepCollectionEquality().hash(max) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto {
  CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto copyWith(
      {double? min, double? maxMatching, double? max}) {
    return CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto(
        min: min ?? this.min,
        maxMatching: maxMatching ?? this.maxMatching,
        max: max ?? this.max);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto({
    this.propertyAge,
    this.constructionYears,
    this.withParking,
    this.withElevator,
    this.minBedrooms,
    this.minRooms,
    this.places,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'propertyAge',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeToJson,
      fromJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
      propertyAge;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  @JsonKey(name: 'minBedrooms', includeIfNull: false)
  final int? minBedrooms;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto &&
            (identical(other.propertyAge, propertyAge) ||
                const DeepCollectionEquality()
                    .equals(other.propertyAge, propertyAge)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)) &&
            (identical(other.minBedrooms, minBedrooms) ||
                const DeepCollectionEquality()
                    .equals(other.minBedrooms, minBedrooms)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(propertyAge) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      const DeepCollectionEquality().hash(minBedrooms) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
          propertyAge,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears,
      bool? withParking,
      bool? withElevator,
      int? minBedrooms,
      int? minRooms,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto(
        propertyAge: propertyAge ?? this.propertyAge,
        constructionYears: constructionYears ?? this.constructionYears,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator,
        minBedrooms: minBedrooms ?? this.minBedrooms,
        minRooms: minRooms ?? this.minRooms,
        places: places ?? this.places,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.archivingDate,
    this.creationDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto?
      criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto
      copyWith(
          {String? reference,
          enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
          String? notes,
          CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentCriteriaDto?
              criteria,
          DateTime? archivingDate,
          DateTime? creationDate,
          enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseApartmentProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        creationDate: creationDate ?? this.creationDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto({
    this.propertyAge,
    this.constructionYears,
    this.homeSize,
    this.lotSize,
    this.maturity,
    this.budget,
    this.places,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'propertyAge',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeToJson,
      fromJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
      propertyAge;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto &&
            (identical(other.propertyAge, propertyAge) ||
                const DeepCollectionEquality()
                    .equals(other.propertyAge, propertyAge)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(propertyAge) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
          propertyAge,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto(
        propertyAge: propertyAge ?? this.propertyAge,
        constructionYears: constructionYears ?? this.constructionYears,
        homeSize: homeSize ?? this.homeSize,
        lotSize: lotSize ?? this.lotSize,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto?
      criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto copyWith(
      {String? reference,
      enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? notes,
      CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingCriteriaDto?
          criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseBuildingProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto({
    this.propertyAge,
    this.constructionYears,
    this.withParking,
    this.withElevator,
    this.minBedrooms,
    this.minRooms,
    this.places,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'propertyAge',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeToJson,
      fromJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
      propertyAge;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  @JsonKey(name: 'minBedrooms', includeIfNull: false)
  final int? minBedrooms;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto &&
            (identical(other.propertyAge, propertyAge) ||
                const DeepCollectionEquality()
                    .equals(other.propertyAge, propertyAge)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)) &&
            (identical(other.minBedrooms, minBedrooms) ||
                const DeepCollectionEquality()
                    .equals(other.minBedrooms, minBedrooms)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(propertyAge) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      const DeepCollectionEquality().hash(minBedrooms) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
          propertyAge,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears,
      bool? withParking,
      bool? withElevator,
      int? minBedrooms,
      int? minRooms,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto(
        propertyAge: propertyAge ?? this.propertyAge,
        constructionYears: constructionYears ?? this.constructionYears,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator,
        minBedrooms: minBedrooms ?? this.minBedrooms,
        minRooms: minRooms ?? this.minRooms,
        places: places ?? this.places,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto? criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto copyWith(
      {String? reference,
      enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? notes,
      CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseCriteriaDto? criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseHouseProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto({
    this.maturity,
    this.budget,
    this.places,
    this.lotSize,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality().equals(other.lotSize, lotSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(lotSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      CRMAPIProfilesDtoLotSizeDto? lotSize}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto(
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places,
        lotSize: lotSize ?? this.lotSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto({
    this.account,
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto? criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandCriteriaDto? criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseLandProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto({
    this.propertyAge,
    this.constructionYears,
    this.minRooms,
    this.lotSize,
    this.homeSize,
    this.maturity,
    this.budget,
    this.places,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'propertyAge',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeToJson,
      fromJson:
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
      propertyAge;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto &&
            (identical(other.propertyAge, propertyAge) ||
                const DeepCollectionEquality()
                    .equals(other.propertyAge, propertyAge)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(propertyAge) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
          propertyAge,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears,
      int? minRooms,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto(
        propertyAge: propertyAge ?? this.propertyAge,
        constructionYears: constructionYears ?? this.constructionYears,
        minRooms: minRooms ?? this.minRooms,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto({
    this.account,
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto?
      criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesCriteriaDto?
          criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchasePremisesProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto({
    this.maturity,
    this.budget,
    this.places,
    this.homeSize,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(homeSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      CRMAPIProfilesDtoHomeSizeDto? homeSize}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto(
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places,
        homeSize: homeSize ?? this.homeSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto({
    this.account,
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto?
      criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingCriteriaDto? criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseParkingProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto({
    this.withPremises,
    this.minRooms,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
    this.places,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDtoFromJson(
          json);

  @JsonKey(name: 'withPremises', includeIfNull: false)
  final bool? withPremises;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto &&
            (identical(other.withPremises, withPremises) ||
                const DeepCollectionEquality()
                    .equals(other.withPremises, withPremises)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(withPremises) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(places) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto copyWith(
      {bool? withPremises,
      int? minRooms,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchPurchaseBudgetPurchaseDto? budget,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      List<CRMAPIProfilesDtoPlaceDto>? places}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto(
        withPremises: withPremises ?? this.withPremises,
        minRooms: minRooms ?? this.minRooms,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        places: places ?? this.places);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto({
    this.reference,
    this.account,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDtoFromJson(
          json);

  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto?
      criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto {
  CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto copyWith(
      {String? reference,
      enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? notes,
      CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillCriteriaDto?
          criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchPurchaseSearchPurchaseGoodwillProfileWriteDto(
        reference: reference ?? this.reference,
        account: account ?? this.account,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalBudgetRentalDto {
  CRMAPIProfilesDtoSearchRentalBudgetRentalDto({
    this.min,
    this.maxMatching,
    this.max,
  });

  factory CRMAPIProfilesDtoSearchRentalBudgetRentalDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalBudgetRentalDtoFromJson(json);

  @JsonKey(name: 'min', includeIfNull: false)
  final double? min;
  @JsonKey(name: 'maxMatching', includeIfNull: false)
  final double? maxMatching;
  @JsonKey(name: 'max', includeIfNull: false)
  final double? max;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalBudgetRentalDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalBudgetRentalDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalBudgetRentalDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalBudgetRentalDto &&
            (identical(other.min, min) ||
                const DeepCollectionEquality().equals(other.min, min)) &&
            (identical(other.maxMatching, maxMatching) ||
                const DeepCollectionEquality()
                    .equals(other.maxMatching, maxMatching)) &&
            (identical(other.max, max) ||
                const DeepCollectionEquality().equals(other.max, max)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(min) ^
      const DeepCollectionEquality().hash(maxMatching) ^
      const DeepCollectionEquality().hash(max) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalBudgetRentalDtoExtension
    on CRMAPIProfilesDtoSearchRentalBudgetRentalDto {
  CRMAPIProfilesDtoSearchRentalBudgetRentalDto copyWith(
      {double? min, double? maxMatching, double? max}) {
    return CRMAPIProfilesDtoSearchRentalBudgetRentalDto(
        min: min ?? this.min,
        maxMatching: maxMatching ?? this.maxMatching,
        max: max ?? this.max);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto({
    this.furniture,
    this.withParking,
    this.withElevator,
    this.minBedrooms,
    this.minRooms,
    this.places,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
    this.constructionYears,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'furniture',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? furniture;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  @JsonKey(name: 'minBedrooms', includeIfNull: false)
  final int? minBedrooms;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto &&
            (identical(other.furniture, furniture) ||
                const DeepCollectionEquality()
                    .equals(other.furniture, furniture)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)) &&
            (identical(other.minBedrooms, minBedrooms) ||
                const DeepCollectionEquality()
                    .equals(other.minBedrooms, minBedrooms)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(furniture) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      const DeepCollectionEquality().hash(minBedrooms) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? furniture,
      bool? withParking,
      bool? withElevator,
      int? minBedrooms,
      int? minRooms,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto(
        furniture: furniture ?? this.furniture,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator,
        minBedrooms: minBedrooms ?? this.minBedrooms,
        minRooms: minRooms ?? this.minRooms,
        places: places ?? this.places,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        constructionYears: constructionYears ?? this.constructionYears);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto({
    this.account,
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto? criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchRentalSearchRentalApartmentCriteriaDto? criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalApartmentProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto({
    this.furniture,
    this.withParking,
    this.withElevator,
    this.minBedrooms,
    this.minRooms,
    this.places,
    this.maturity,
    this.budget,
    this.lotSize,
    this.homeSize,
    this.constructionYears,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDtoFromJson(json);

  @JsonKey(
      name: 'furniture',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? furniture;
  @JsonKey(name: 'withParking', includeIfNull: false)
  final bool? withParking;
  @JsonKey(name: 'withElevator', includeIfNull: false)
  final bool? withElevator;
  @JsonKey(name: 'minBedrooms', includeIfNull: false)
  final int? minBedrooms;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'constructionYears',
      includeIfNull: false,
      toJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson,
      fromJson:
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson)
  final List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      constructionYears;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto &&
            (identical(other.furniture, furniture) ||
                const DeepCollectionEquality()
                    .equals(other.furniture, furniture)) &&
            (identical(other.withParking, withParking) ||
                const DeepCollectionEquality()
                    .equals(other.withParking, withParking)) &&
            (identical(other.withElevator, withElevator) ||
                const DeepCollectionEquality()
                    .equals(other.withElevator, withElevator)) &&
            (identical(other.minBedrooms, minBedrooms) ||
                const DeepCollectionEquality()
                    .equals(other.minBedrooms, minBedrooms)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.constructionYears, constructionYears) ||
                const DeepCollectionEquality()
                    .equals(other.constructionYears, constructionYears)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(furniture) ^
      const DeepCollectionEquality().hash(withParking) ^
      const DeepCollectionEquality().hash(withElevator) ^
      const DeepCollectionEquality().hash(minBedrooms) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(constructionYears) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? furniture,
      bool? withParking,
      bool? withElevator,
      int? minBedrooms,
      int? minRooms,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
          constructionYears}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto(
        furniture: furniture ?? this.furniture,
        withParking: withParking ?? this.withParking,
        withElevator: withElevator ?? this.withElevator,
        minBedrooms: minBedrooms ?? this.minBedrooms,
        minRooms: minRooms ?? this.minRooms,
        places: places ?? this.places,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        constructionYears: constructionYears ?? this.constructionYears);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto({
    this.account,
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto? criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchRentalSearchRentalHouseCriteriaDto? criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalHouseProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto({
    this.maturity,
    this.budget,
    this.places,
    this.lotSize,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDtoFromJson(json);

  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality().equals(other.lotSize, lotSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(lotSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      CRMAPIProfilesDtoLotSizeDto? lotSize}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto(
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places,
        lotSize: lotSize ?? this.lotSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto({
    this.account,
    this.reference,
    this.notes,
    this.criteria,
    this.creationDate,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto? criteria;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchRentalSearchRentalLandCriteriaDto? criteria,
      DateTime? creationDate,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalLandProfileWriteDto(
        account: account ?? this.account,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        creationDate: creationDate ?? this.creationDate,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto({
    this.maturity,
    this.budget,
    this.places,
    this.homeSize,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDtoToJson(this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      const DeepCollectionEquality().hash(homeSize) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places,
      CRMAPIProfilesDtoHomeSizeDto? homeSize}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto(
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places,
        homeSize: homeSize ?? this.homeSize);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto({
    this.account,
    this.creationDate,
    this.reference,
    this.notes,
    this.criteria,
    this.archivingDate,
    this.origin,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto? criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(creationDate) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      DateTime? creationDate,
      String? reference,
      String? notes,
      CRMAPIProfilesDtoSearchRentalSearchRentalParkingCriteriaDto? criteria,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalParkingProfileWriteDto(
        account: account ?? this.account,
        creationDate: creationDate ?? this.creationDate,
        reference: reference ?? this.reference,
        notes: notes ?? this.notes,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto({
    this.furniture,
    this.minRooms,
    this.lotSize,
    this.homeSize,
    this.maturity,
    this.budget,
    this.places,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDtoFromJson(
          json);

  @JsonKey(
      name: 'furniture',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeToJson,
      fromJson: cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeFromJson)
  final enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? furniture;
  @JsonKey(name: 'minRooms', includeIfNull: false)
  final int? minRooms;
  @JsonKey(name: 'lotSize', includeIfNull: false)
  final CRMAPIProfilesDtoLotSizeDto? lotSize;
  @JsonKey(name: 'homeSize', includeIfNull: false)
  final CRMAPIProfilesDtoHomeSizeDto? homeSize;
  @JsonKey(
      name: 'maturity',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson,
      fromJson: cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson)
  final enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity;
  @JsonKey(name: 'budget', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget;
  @JsonKey(
      name: 'places',
      includeIfNull: false,
      defaultValue: <CRMAPIProfilesDtoPlaceDto>[])
  final List<CRMAPIProfilesDtoPlaceDto>? places;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto &&
            (identical(other.furniture, furniture) ||
                const DeepCollectionEquality()
                    .equals(other.furniture, furniture)) &&
            (identical(other.minRooms, minRooms) ||
                const DeepCollectionEquality()
                    .equals(other.minRooms, minRooms)) &&
            (identical(other.lotSize, lotSize) ||
                const DeepCollectionEquality()
                    .equals(other.lotSize, lotSize)) &&
            (identical(other.homeSize, homeSize) ||
                const DeepCollectionEquality()
                    .equals(other.homeSize, homeSize)) &&
            (identical(other.maturity, maturity) ||
                const DeepCollectionEquality()
                    .equals(other.maturity, maturity)) &&
            (identical(other.budget, budget) ||
                const DeepCollectionEquality().equals(other.budget, budget)) &&
            (identical(other.places, places) ||
                const DeepCollectionEquality().equals(other.places, places)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(furniture) ^
      const DeepCollectionEquality().hash(minRooms) ^
      const DeepCollectionEquality().hash(lotSize) ^
      const DeepCollectionEquality().hash(homeSize) ^
      const DeepCollectionEquality().hash(maturity) ^
      const DeepCollectionEquality().hash(budget) ^
      const DeepCollectionEquality().hash(places) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto copyWith(
      {enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? furniture,
      int? minRooms,
      CRMAPIProfilesDtoLotSizeDto? lotSize,
      CRMAPIProfilesDtoHomeSizeDto? homeSize,
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType? maturity,
      CRMAPIProfilesDtoSearchRentalBudgetRentalDto? budget,
      List<CRMAPIProfilesDtoPlaceDto>? places}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto(
        furniture: furniture ?? this.furniture,
        minRooms: minRooms ?? this.minRooms,
        lotSize: lotSize ?? this.lotSize,
        homeSize: homeSize ?? this.homeSize,
        maturity: maturity ?? this.maturity,
        budget: budget ?? this.budget,
        places: places ?? this.places);
  }
}

@JsonSerializable(explicitToJson: true)
class CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto({
    this.account,
    this.notes,
    this.reference,
    this.criteria,
    this.archivingDate,
    this.origin,
    this.creationDate,
  });

  factory CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto.fromJson(
          Map<String, dynamic> json) =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDtoFromJson(
          json);

  @JsonKey(
      name: 'account',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoAccountDtoAccountTypeToJson,
      fromJson: cRMAPIProfilesDtoAccountDtoAccountTypeFromJson)
  final enums.CRMAPIProfilesDtoAccountDtoAccountType? account;
  @JsonKey(name: 'notes', includeIfNull: false, defaultValue: '')
  final String? notes;
  @JsonKey(name: 'reference', includeIfNull: false, defaultValue: '')
  final String? reference;
  @JsonKey(name: 'criteria', includeIfNull: false)
  final CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto? criteria;
  @JsonKey(name: 'archivingDate', includeIfNull: false)
  final DateTime? archivingDate;
  @JsonKey(
      name: 'origin',
      includeIfNull: false,
      toJson: cRMAPIProfilesDtoOriginDtoOriginTypeToJson,
      fromJson: cRMAPIProfilesDtoOriginDtoOriginTypeFromJson)
  final enums.CRMAPIProfilesDtoOriginDtoOriginType? origin;
  @JsonKey(name: 'creationDate', includeIfNull: false)
  final DateTime? creationDate;
  static const fromJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDtoFromJson;
  static const toJsonFactory =
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDtoToJson;
  Map<String, dynamic> toJson() =>
      _$CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDtoToJson(
          this);

  @override
  String toString() => jsonEncode(this);

  @override
  bool operator ==(dynamic other) {
    return identical(this, other) ||
        (other is CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto &&
            (identical(other.account, account) ||
                const DeepCollectionEquality()
                    .equals(other.account, account)) &&
            (identical(other.notes, notes) ||
                const DeepCollectionEquality().equals(other.notes, notes)) &&
            (identical(other.reference, reference) ||
                const DeepCollectionEquality()
                    .equals(other.reference, reference)) &&
            (identical(other.criteria, criteria) ||
                const DeepCollectionEquality()
                    .equals(other.criteria, criteria)) &&
            (identical(other.archivingDate, archivingDate) ||
                const DeepCollectionEquality()
                    .equals(other.archivingDate, archivingDate)) &&
            (identical(other.origin, origin) ||
                const DeepCollectionEquality().equals(other.origin, origin)) &&
            (identical(other.creationDate, creationDate) ||
                const DeepCollectionEquality()
                    .equals(other.creationDate, creationDate)));
  }

  @override
  int get hashCode =>
      const DeepCollectionEquality().hash(account) ^
      const DeepCollectionEquality().hash(notes) ^
      const DeepCollectionEquality().hash(reference) ^
      const DeepCollectionEquality().hash(criteria) ^
      const DeepCollectionEquality().hash(archivingDate) ^
      const DeepCollectionEquality().hash(origin) ^
      const DeepCollectionEquality().hash(creationDate) ^
      runtimeType.hashCode;
}

extension $CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDtoExtension
    on CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto {
  CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto copyWith(
      {enums.CRMAPIProfilesDtoAccountDtoAccountType? account,
      String? notes,
      String? reference,
      CRMAPIProfilesDtoSearchRentalSearchRentalPremisesCriteriaDto? criteria,
      DateTime? archivingDate,
      enums.CRMAPIProfilesDtoOriginDtoOriginType? origin,
      DateTime? creationDate}) {
    return CRMAPIProfilesDtoSearchRentalSearchRentalPremisesProfileWriteDto(
        account: account ?? this.account,
        notes: notes ?? this.notes,
        reference: reference ?? this.reference,
        criteria: criteria ?? this.criteria,
        archivingDate: archivingDate ?? this.archivingDate,
        origin: origin ?? this.origin,
        creationDate: creationDate ?? this.creationDate);
  }
}

String? cRMAPIProfilesDtoAccountDtoAccountTypeToJson(
    enums.CRMAPIProfilesDtoAccountDtoAccountType?
        cRMAPIProfilesDtoAccountDtoAccountType) {
  return enums.$CRMAPIProfilesDtoAccountDtoAccountTypeMap[
      cRMAPIProfilesDtoAccountDtoAccountType];
}

enums.CRMAPIProfilesDtoAccountDtoAccountType
    cRMAPIProfilesDtoAccountDtoAccountTypeFromJson(
  Object? cRMAPIProfilesDtoAccountDtoAccountType, [
  enums.CRMAPIProfilesDtoAccountDtoAccountType? defaultValue,
]) {
  if (cRMAPIProfilesDtoAccountDtoAccountType is String) {
    return enums.$CRMAPIProfilesDtoAccountDtoAccountTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoAccountDtoAccountType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoAccountDtoAccountType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoAccountDtoAccountTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoAccountDtoAccountType.swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoAccountDtoAccountTypeListToJson(
    List<enums.CRMAPIProfilesDtoAccountDtoAccountType>?
        cRMAPIProfilesDtoAccountDtoAccountType) {
  if (cRMAPIProfilesDtoAccountDtoAccountType == null) {
    return [];
  }

  return cRMAPIProfilesDtoAccountDtoAccountType
      .map((e) => enums.$CRMAPIProfilesDtoAccountDtoAccountTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoAccountDtoAccountType>
    cRMAPIProfilesDtoAccountDtoAccountTypeListFromJson(
  List? cRMAPIProfilesDtoAccountDtoAccountType, [
  List<enums.CRMAPIProfilesDtoAccountDtoAccountType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoAccountDtoAccountType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoAccountDtoAccountType
      .map((e) => cRMAPIProfilesDtoAccountDtoAccountTypeFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoMaturityDtoMaturityTypeToJson(
    enums.CRMAPIProfilesDtoMaturityDtoMaturityType?
        cRMAPIProfilesDtoMaturityDtoMaturityType) {
  return enums.$CRMAPIProfilesDtoMaturityDtoMaturityTypeMap[
      cRMAPIProfilesDtoMaturityDtoMaturityType];
}

enums.CRMAPIProfilesDtoMaturityDtoMaturityType
    cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson(
  Object? cRMAPIProfilesDtoMaturityDtoMaturityType, [
  enums.CRMAPIProfilesDtoMaturityDtoMaturityType? defaultValue,
]) {
  if (cRMAPIProfilesDtoMaturityDtoMaturityType is String) {
    return enums.$CRMAPIProfilesDtoMaturityDtoMaturityTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoMaturityDtoMaturityType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoMaturityDtoMaturityType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoMaturityDtoMaturityTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoMaturityDtoMaturityType.swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoMaturityDtoMaturityTypeListToJson(
    List<enums.CRMAPIProfilesDtoMaturityDtoMaturityType>?
        cRMAPIProfilesDtoMaturityDtoMaturityType) {
  if (cRMAPIProfilesDtoMaturityDtoMaturityType == null) {
    return [];
  }

  return cRMAPIProfilesDtoMaturityDtoMaturityType
      .map((e) => enums.$CRMAPIProfilesDtoMaturityDtoMaturityTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoMaturityDtoMaturityType>
    cRMAPIProfilesDtoMaturityDtoMaturityTypeListFromJson(
  List? cRMAPIProfilesDtoMaturityDtoMaturityType, [
  List<enums.CRMAPIProfilesDtoMaturityDtoMaturityType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoMaturityDtoMaturityType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoMaturityDtoMaturityType
      .map(
          (e) => cRMAPIProfilesDtoMaturityDtoMaturityTypeFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeToJson(
    enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType?
        cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType) {
  return enums
          .$CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeMap[
      cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType];
}

enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType
    cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType, [
  enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType>?
            cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType) {
  if (cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType>
    cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType, [
  List<enums.CRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateType
      .map((e) =>
          cRMAPIProfilesDtoForSaleCommonGeneralStateDtoGeneralStateTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeToJson(
    enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType?
        cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType) {
  return enums.$CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeMap[
      cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType];
}

enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType
    cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType, [
  enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType is String) {
    return enums.$CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeListToJson(
    List<enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType>?
        cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType) {
  if (cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType
      .map((e) => enums.$CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType>
    cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType, [
  List<enums.CRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltType
      .map((e) =>
          cRMAPIProfilesDtoForSaleCommonBuiltDtoBuiltTypeFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeToJson(
    enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType?
        cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType) {
  return enums.$CRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeMap[
      cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType];
}

enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType
    cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType, [
  enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeListToJson(
    List<enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType>?
        cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType) {
  if (cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType
      .map((e) =>
          enums.$CRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType>
    cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType, [
  List<enums.CRMAPIProfilesDtoForSaleCommonExposureDtoExposureType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonExposureDtoExposureType
      .map((e) => cRMAPIProfilesDtoForSaleCommonExposureDtoExposureTypeFromJson(
          e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeToJson(
    enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType?
        cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType) {
  return enums
          .$CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeMap[
      cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType];
}

enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
    cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType, [
  enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
      is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType>?
            cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType) {
  if (cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType>
    cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType, [
  List<enums.CRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipType
      .map((e) =>
          cRMAPIProfilesDtoForSaleCommonJoinOwnershipDtoJoinOwnershipTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeToJson(
    enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType?
        cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType) {
  return enums.$CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeMap[
      cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType];
}

enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType
    cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType, [
  enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType is String) {
    return enums.$CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListToJson(
    List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>?
        cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType) {
  if (cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType
      .map((e) =>
          enums.$CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>
    cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType, [
  List<enums.CRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityType
      .map((e) => cRMAPIProfilesDtoForSaleCommonAmenityDtoAmenityTypeFromJson(
          e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonAnnexKindToJson(
    enums.CRMAPIProfilesDtoForSaleCommonAnnexKind?
        cRMAPIProfilesDtoForSaleCommonAnnexKind) {
  return enums.$CRMAPIProfilesDtoForSaleCommonAnnexKindMap[
      cRMAPIProfilesDtoForSaleCommonAnnexKind];
}

enums.CRMAPIProfilesDtoForSaleCommonAnnexKind
    cRMAPIProfilesDtoForSaleCommonAnnexKindFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonAnnexKind, [
  enums.CRMAPIProfilesDtoForSaleCommonAnnexKind? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonAnnexKind is String) {
    return enums.$CRMAPIProfilesDtoForSaleCommonAnnexKindMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonAnnexKind.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleCommonAnnexKind
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleCommonAnnexKindMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonAnnexKind.swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleCommonAnnexKindListToJson(
    List<enums.CRMAPIProfilesDtoForSaleCommonAnnexKind>?
        cRMAPIProfilesDtoForSaleCommonAnnexKind) {
  if (cRMAPIProfilesDtoForSaleCommonAnnexKind == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonAnnexKind
      .map((e) => enums.$CRMAPIProfilesDtoForSaleCommonAnnexKindMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonAnnexKind>
    cRMAPIProfilesDtoForSaleCommonAnnexKindListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonAnnexKind, [
  List<enums.CRMAPIProfilesDtoForSaleCommonAnnexKind>? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonAnnexKind == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonAnnexKind
      .map((e) => cRMAPIProfilesDtoForSaleCommonAnnexKindFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeToJson(
    enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType?
        cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType) {
  return enums.$CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeMap[
      cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType];
}

enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType
    cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType, [
  enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType>?
            cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType) {
  if (cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType>
    cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType, [
  List<enums.CRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoType
      .map((e) =>
          cRMAPIProfilesDtoForSaleCommonKitchenInfoDtoKitchenInfoTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoOriginDtoOriginTypeToJson(
    enums.CRMAPIProfilesDtoOriginDtoOriginType?
        cRMAPIProfilesDtoOriginDtoOriginType) {
  return enums.$CRMAPIProfilesDtoOriginDtoOriginTypeMap[
      cRMAPIProfilesDtoOriginDtoOriginType];
}

enums.CRMAPIProfilesDtoOriginDtoOriginType
    cRMAPIProfilesDtoOriginDtoOriginTypeFromJson(
  Object? cRMAPIProfilesDtoOriginDtoOriginType, [
  enums.CRMAPIProfilesDtoOriginDtoOriginType? defaultValue,
]) {
  if (cRMAPIProfilesDtoOriginDtoOriginType is String) {
    return enums.$CRMAPIProfilesDtoOriginDtoOriginTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoOriginDtoOriginType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoOriginDtoOriginType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoOriginDtoOriginTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoOriginDtoOriginType.swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoOriginDtoOriginTypeListToJson(
    List<enums.CRMAPIProfilesDtoOriginDtoOriginType>?
        cRMAPIProfilesDtoOriginDtoOriginType) {
  if (cRMAPIProfilesDtoOriginDtoOriginType == null) {
    return [];
  }

  return cRMAPIProfilesDtoOriginDtoOriginType
      .map((e) => enums.$CRMAPIProfilesDtoOriginDtoOriginTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoOriginDtoOriginType>
    cRMAPIProfilesDtoOriginDtoOriginTypeListFromJson(
  List? cRMAPIProfilesDtoOriginDtoOriginType, [
  List<enums.CRMAPIProfilesDtoOriginDtoOriginType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoOriginDtoOriginType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoOriginDtoOriginType
      .map((e) => cRMAPIProfilesDtoOriginDtoOriginTypeFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeToJson(
    enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType?
        cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType) {
  return enums
          .$CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeMap[
      cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType];
}

enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
    cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType, [
  enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
      is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType>?
            cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType) {
  if (cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType ==
      null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType>
    cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType, [
  List<enums.CRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType ==
      null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityType
      .map((e) =>
          cRMAPIProfilesDtoForSaleParkingParkingAmenityDtoParkingAmenityTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeToJson(
    enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType?
        cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType) {
  return enums.$CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeMap[
      cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType];
}

enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType
    cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType, [
  enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType>?
            cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType) {
  if (cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType>
    cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType, [
  List<enums.CRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindType
      .map((e) =>
          cRMAPIProfilesDtoForSaleParkingParkingKindDtoParkingKindTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeToJson(
    enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType?
        cRMAPIProfilesDtoForSaleBuildingLotDtoLotType) {
  return enums.$CRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeMap[
      cRMAPIProfilesDtoForSaleBuildingLotDtoLotType];
}

enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType
    cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleBuildingLotDtoLotType, [
  enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleBuildingLotDtoLotType is String) {
    return enums.$CRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleBuildingLotDtoLotType.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeListToJson(
    List<enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType>?
        cRMAPIProfilesDtoForSaleBuildingLotDtoLotType) {
  if (cRMAPIProfilesDtoForSaleBuildingLotDtoLotType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleBuildingLotDtoLotType
      .map((e) => enums.$CRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType>
    cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleBuildingLotDtoLotType, [
  List<enums.CRMAPIProfilesDtoForSaleBuildingLotDtoLotType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleBuildingLotDtoLotType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleBuildingLotDtoLotType
      .map((e) =>
          cRMAPIProfilesDtoForSaleBuildingLotDtoLotTypeFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeToJson(
    enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType?
        cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType) {
  return enums
          .$CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeMap[
      cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType];
}

enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
    cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType, [
  enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
      is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType>?
            cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType) {
  if (cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType>
    cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType, [
  List<enums.CRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindType
      .map((e) =>
          cRMAPIProfilesDtoForSaleBuildingBuildingKindDtoBuildingKindTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeToJson(
    enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType?
        cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType) {
  return enums.$CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeMap[
      cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType];
}

enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType
    cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType, [
  enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType>?
            cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType) {
  if (cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType>
    cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType, [
  List<enums.CRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityType
      .map((e) =>
          cRMAPIProfilesDtoForSaleLandLandAmenityDtoLandAmenityTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeToJson(
    enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType?
        cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType) {
  return enums.$CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeMap[
      cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType];
}

enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType
    cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType, [
  enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType is String) {
    return enums.$CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeListToJson(
    List<enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType>?
        cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType) {
  if (cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType
      .map((e) =>
          enums.$CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType>
    cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType, [
  List<enums.CRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType>? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindType
      .map((e) => cRMAPIProfilesDtoForSaleLandLandKindDtoLandKindTypeFromJson(
          e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeToJson(
    enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType?
        cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType) {
  return enums.$CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeMap[
      cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType];
}

enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType
    cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType, [
  enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType? defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeListToJson(
    List<enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType>?
        cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType) {
  if (cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType
      .map((e) =>
          enums.$CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType>
    cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType, [
  List<enums.CRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefType
      .map((e) =>
          cRMAPIProfilesDtoForSaleLandLandReliefDtoLandReliefTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeToJson(
    enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType?
        cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType) {
  return enums
          .$CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeMap[
      cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType];
}

enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
    cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeFromJson(
  Object? cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType, [
  enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
      is String) {
    return enums
        .$CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeListToJson(
        List<enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType>?
            cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType) {
  if (cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType == null) {
    return [];
  }

  return cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
      .map((e) => enums
          .$CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType>
    cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeListFromJson(
  List? cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType, [
  List<enums.CRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionType
      .map((e) =>
          cRMAPIProfilesDtoForSaleLandLandConnectionDtoLandConnectionTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIHuntersControllersDtoBusinessUnitToJson(
    enums.CRMAPIHuntersControllersDtoBusinessUnit?
        cRMAPIHuntersControllersDtoBusinessUnit) {
  return enums.$CRMAPIHuntersControllersDtoBusinessUnitMap[
      cRMAPIHuntersControllersDtoBusinessUnit];
}

enums.CRMAPIHuntersControllersDtoBusinessUnit
    cRMAPIHuntersControllersDtoBusinessUnitFromJson(
  Object? cRMAPIHuntersControllersDtoBusinessUnit, [
  enums.CRMAPIHuntersControllersDtoBusinessUnit? defaultValue,
]) {
  if (cRMAPIHuntersControllersDtoBusinessUnit is String) {
    return enums.$CRMAPIHuntersControllersDtoBusinessUnitMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIHuntersControllersDtoBusinessUnit.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIHuntersControllersDtoBusinessUnit
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIHuntersControllersDtoBusinessUnitMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIHuntersControllersDtoBusinessUnit.swaggerGeneratedUnknown;
}

List<String> cRMAPIHuntersControllersDtoBusinessUnitListToJson(
    List<enums.CRMAPIHuntersControllersDtoBusinessUnit>?
        cRMAPIHuntersControllersDtoBusinessUnit) {
  if (cRMAPIHuntersControllersDtoBusinessUnit == null) {
    return [];
  }

  return cRMAPIHuntersControllersDtoBusinessUnit
      .map((e) => enums.$CRMAPIHuntersControllersDtoBusinessUnitMap[e]!)
      .toList();
}

List<enums.CRMAPIHuntersControllersDtoBusinessUnit>
    cRMAPIHuntersControllersDtoBusinessUnitListFromJson(
  List? cRMAPIHuntersControllersDtoBusinessUnit, [
  List<enums.CRMAPIHuntersControllersDtoBusinessUnit>? defaultValue,
]) {
  if (cRMAPIHuntersControllersDtoBusinessUnit == null) {
    return defaultValue ?? [];
  }

  return cRMAPIHuntersControllersDtoBusinessUnit
      .map((e) => cRMAPIHuntersControllersDtoBusinessUnitFromJson(e.toString()))
      .toList();
}

String? cRMInfrastructureElasticSearchContactSortColumnToJson(
    enums.CRMInfrastructureElasticSearchContactSortColumn?
        cRMInfrastructureElasticSearchContactSortColumn) {
  return enums.$CRMInfrastructureElasticSearchContactSortColumnMap[
      cRMInfrastructureElasticSearchContactSortColumn];
}

enums.CRMInfrastructureElasticSearchContactSortColumn
    cRMInfrastructureElasticSearchContactSortColumnFromJson(
  Object? cRMInfrastructureElasticSearchContactSortColumn, [
  enums.CRMInfrastructureElasticSearchContactSortColumn? defaultValue,
]) {
  if (cRMInfrastructureElasticSearchContactSortColumn is String) {
    return enums.$CRMInfrastructureElasticSearchContactSortColumnMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMInfrastructureElasticSearchContactSortColumn.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMInfrastructureElasticSearchContactSortColumn
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMInfrastructureElasticSearchContactSortColumnMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMInfrastructureElasticSearchContactSortColumn
          .swaggerGeneratedUnknown;
}

List<String> cRMInfrastructureElasticSearchContactSortColumnListToJson(
    List<enums.CRMInfrastructureElasticSearchContactSortColumn>?
        cRMInfrastructureElasticSearchContactSortColumn) {
  if (cRMInfrastructureElasticSearchContactSortColumn == null) {
    return [];
  }

  return cRMInfrastructureElasticSearchContactSortColumn
      .map((e) => enums.$CRMInfrastructureElasticSearchContactSortColumnMap[e]!)
      .toList();
}

List<enums.CRMInfrastructureElasticSearchContactSortColumn>
    cRMInfrastructureElasticSearchContactSortColumnListFromJson(
  List? cRMInfrastructureElasticSearchContactSortColumn, [
  List<enums.CRMInfrastructureElasticSearchContactSortColumn>? defaultValue,
]) {
  if (cRMInfrastructureElasticSearchContactSortColumn == null) {
    return defaultValue ?? [];
  }

  return cRMInfrastructureElasticSearchContactSortColumn
      .map((e) =>
          cRMInfrastructureElasticSearchContactSortColumnFromJson(e.toString()))
      .toList();
}

String? profileKindEnumToJson(enums.ProfileKindEnum? profileKindEnum) {
  return enums.$ProfileKindEnumMap[profileKindEnum];
}

enums.ProfileKindEnum profileKindEnumFromJson(
  Object? profileKindEnum, [
  enums.ProfileKindEnum? defaultValue,
]) {
  if (profileKindEnum is String) {
    return enums.$ProfileKindEnumMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == profileKindEnum.toLowerCase(),
            orElse: () => const MapEntry(
                enums.ProfileKindEnum.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$ProfileKindEnumMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.ProfileKindEnum.swaggerGeneratedUnknown;
}

List<String> profileKindEnumListToJson(
    List<enums.ProfileKindEnum>? profileKindEnum) {
  if (profileKindEnum == null) {
    return [];
  }

  return profileKindEnum.map((e) => enums.$ProfileKindEnumMap[e]!).toList();
}

List<enums.ProfileKindEnum> profileKindEnumListFromJson(
  List? profileKindEnum, [
  List<enums.ProfileKindEnum>? defaultValue,
]) {
  if (profileKindEnum == null) {
    return defaultValue ?? [];
  }

  return profileKindEnum
      .map((e) => profileKindEnumFromJson(e.toString()))
      .toList();
}

String? sourceEnumToJson(enums.SourceEnum? sourceEnum) {
  return enums.$SourceEnumMap[sourceEnum];
}

enums.SourceEnum sourceEnumFromJson(
  Object? sourceEnum, [
  enums.SourceEnum? defaultValue,
]) {
  if (sourceEnum is String) {
    return enums.$SourceEnumMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() == sourceEnum.toLowerCase(),
            orElse: () =>
                const MapEntry(enums.SourceEnum.swaggerGeneratedUnknown, ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$SourceEnumMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.SourceEnum.swaggerGeneratedUnknown;
}

List<String> sourceEnumListToJson(List<enums.SourceEnum>? sourceEnum) {
  if (sourceEnum == null) {
    return [];
  }

  return sourceEnum.map((e) => enums.$SourceEnumMap[e]!).toList();
}

List<enums.SourceEnum> sourceEnumListFromJson(
  List? sourceEnum, [
  List<enums.SourceEnum>? defaultValue,
]) {
  if (sourceEnum == null) {
    return defaultValue ?? [];
  }

  return sourceEnum.map((e) => sourceEnumFromJson(e.toString())).toList();
}

String? cRMAPIPortfolioControllersDtoConsentStatusEnumToJson(
    enums.CRMAPIPortfolioControllersDtoConsentStatusEnum?
        cRMAPIPortfolioControllersDtoConsentStatusEnum) {
  return enums.$CRMAPIPortfolioControllersDtoConsentStatusEnumMap[
      cRMAPIPortfolioControllersDtoConsentStatusEnum];
}

enums.CRMAPIPortfolioControllersDtoConsentStatusEnum
    cRMAPIPortfolioControllersDtoConsentStatusEnumFromJson(
  Object? cRMAPIPortfolioControllersDtoConsentStatusEnum, [
  enums.CRMAPIPortfolioControllersDtoConsentStatusEnum? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoConsentStatusEnum is String) {
    return enums.$CRMAPIPortfolioControllersDtoConsentStatusEnumMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIPortfolioControllersDtoConsentStatusEnum.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIPortfolioControllersDtoConsentStatusEnum
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIPortfolioControllersDtoConsentStatusEnumMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIPortfolioControllersDtoConsentStatusEnum
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIPortfolioControllersDtoConsentStatusEnumListToJson(
    List<enums.CRMAPIPortfolioControllersDtoConsentStatusEnum>?
        cRMAPIPortfolioControllersDtoConsentStatusEnum) {
  if (cRMAPIPortfolioControllersDtoConsentStatusEnum == null) {
    return [];
  }

  return cRMAPIPortfolioControllersDtoConsentStatusEnum
      .map((e) => enums.$CRMAPIPortfolioControllersDtoConsentStatusEnumMap[e]!)
      .toList();
}

List<enums.CRMAPIPortfolioControllersDtoConsentStatusEnum>
    cRMAPIPortfolioControllersDtoConsentStatusEnumListFromJson(
  List? cRMAPIPortfolioControllersDtoConsentStatusEnum, [
  List<enums.CRMAPIPortfolioControllersDtoConsentStatusEnum>? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoConsentStatusEnum == null) {
    return defaultValue ?? [];
  }

  return cRMAPIPortfolioControllersDtoConsentStatusEnum
      .map((e) =>
          cRMAPIPortfolioControllersDtoConsentStatusEnumFromJson(e.toString()))
      .toList();
}

String? cRMAPIPortfolioControllersDtoGenderDtoToJson(
    enums.CRMAPIPortfolioControllersDtoGenderDto?
        cRMAPIPortfolioControllersDtoGenderDto) {
  return enums.$CRMAPIPortfolioControllersDtoGenderDtoMap[
      cRMAPIPortfolioControllersDtoGenderDto];
}

enums.CRMAPIPortfolioControllersDtoGenderDto
    cRMAPIPortfolioControllersDtoGenderDtoFromJson(
  Object? cRMAPIPortfolioControllersDtoGenderDto, [
  enums.CRMAPIPortfolioControllersDtoGenderDto? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoGenderDto is String) {
    return enums.$CRMAPIPortfolioControllersDtoGenderDtoMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIPortfolioControllersDtoGenderDto.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIPortfolioControllersDtoGenderDto
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIPortfolioControllersDtoGenderDtoMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIPortfolioControllersDtoGenderDto.swaggerGeneratedUnknown;
}

List<String> cRMAPIPortfolioControllersDtoGenderDtoListToJson(
    List<enums.CRMAPIPortfolioControllersDtoGenderDto>?
        cRMAPIPortfolioControllersDtoGenderDto) {
  if (cRMAPIPortfolioControllersDtoGenderDto == null) {
    return [];
  }

  return cRMAPIPortfolioControllersDtoGenderDto
      .map((e) => enums.$CRMAPIPortfolioControllersDtoGenderDtoMap[e]!)
      .toList();
}

List<enums.CRMAPIPortfolioControllersDtoGenderDto>
    cRMAPIPortfolioControllersDtoGenderDtoListFromJson(
  List? cRMAPIPortfolioControllersDtoGenderDto, [
  List<enums.CRMAPIPortfolioControllersDtoGenderDto>? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoGenderDto == null) {
    return defaultValue ?? [];
  }

  return cRMAPIPortfolioControllersDtoGenderDto
      .map((e) => cRMAPIPortfolioControllersDtoGenderDtoFromJson(e.toString()))
      .toList();
}

String? cRMAPIPortfolioControllersDtoEmailKindToJson(
    enums.CRMAPIPortfolioControllersDtoEmailKind?
        cRMAPIPortfolioControllersDtoEmailKind) {
  return enums.$CRMAPIPortfolioControllersDtoEmailKindMap[
      cRMAPIPortfolioControllersDtoEmailKind];
}

enums.CRMAPIPortfolioControllersDtoEmailKind
    cRMAPIPortfolioControllersDtoEmailKindFromJson(
  Object? cRMAPIPortfolioControllersDtoEmailKind, [
  enums.CRMAPIPortfolioControllersDtoEmailKind? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoEmailKind is String) {
    return enums.$CRMAPIPortfolioControllersDtoEmailKindMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIPortfolioControllersDtoEmailKind.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIPortfolioControllersDtoEmailKind
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIPortfolioControllersDtoEmailKindMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIPortfolioControllersDtoEmailKind.swaggerGeneratedUnknown;
}

List<String> cRMAPIPortfolioControllersDtoEmailKindListToJson(
    List<enums.CRMAPIPortfolioControllersDtoEmailKind>?
        cRMAPIPortfolioControllersDtoEmailKind) {
  if (cRMAPIPortfolioControllersDtoEmailKind == null) {
    return [];
  }

  return cRMAPIPortfolioControllersDtoEmailKind
      .map((e) => enums.$CRMAPIPortfolioControllersDtoEmailKindMap[e]!)
      .toList();
}

List<enums.CRMAPIPortfolioControllersDtoEmailKind>
    cRMAPIPortfolioControllersDtoEmailKindListFromJson(
  List? cRMAPIPortfolioControllersDtoEmailKind, [
  List<enums.CRMAPIPortfolioControllersDtoEmailKind>? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoEmailKind == null) {
    return defaultValue ?? [];
  }

  return cRMAPIPortfolioControllersDtoEmailKind
      .map((e) => cRMAPIPortfolioControllersDtoEmailKindFromJson(e.toString()))
      .toList();
}

String? cRMAPIPortfolioControllersDtoPhoneKindToJson(
    enums.CRMAPIPortfolioControllersDtoPhoneKind?
        cRMAPIPortfolioControllersDtoPhoneKind) {
  return enums.$CRMAPIPortfolioControllersDtoPhoneKindMap[
      cRMAPIPortfolioControllersDtoPhoneKind];
}

enums.CRMAPIPortfolioControllersDtoPhoneKind
    cRMAPIPortfolioControllersDtoPhoneKindFromJson(
  Object? cRMAPIPortfolioControllersDtoPhoneKind, [
  enums.CRMAPIPortfolioControllersDtoPhoneKind? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoPhoneKind is String) {
    return enums.$CRMAPIPortfolioControllersDtoPhoneKindMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIPortfolioControllersDtoPhoneKind.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIPortfolioControllersDtoPhoneKind
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIPortfolioControllersDtoPhoneKindMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIPortfolioControllersDtoPhoneKind.swaggerGeneratedUnknown;
}

List<String> cRMAPIPortfolioControllersDtoPhoneKindListToJson(
    List<enums.CRMAPIPortfolioControllersDtoPhoneKind>?
        cRMAPIPortfolioControllersDtoPhoneKind) {
  if (cRMAPIPortfolioControllersDtoPhoneKind == null) {
    return [];
  }

  return cRMAPIPortfolioControllersDtoPhoneKind
      .map((e) => enums.$CRMAPIPortfolioControllersDtoPhoneKindMap[e]!)
      .toList();
}

List<enums.CRMAPIPortfolioControllersDtoPhoneKind>
    cRMAPIPortfolioControllersDtoPhoneKindListFromJson(
  List? cRMAPIPortfolioControllersDtoPhoneKind, [
  List<enums.CRMAPIPortfolioControllersDtoPhoneKind>? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoPhoneKind == null) {
    return defaultValue ?? [];
  }

  return cRMAPIPortfolioControllersDtoPhoneKind
      .map((e) => cRMAPIPortfolioControllersDtoPhoneKindFromJson(e.toString()))
      .toList();
}

String? cRMAPIPortfolioControllersDtoStatusEnumToJson(
    enums.CRMAPIPortfolioControllersDtoStatusEnum?
        cRMAPIPortfolioControllersDtoStatusEnum) {
  return enums.$CRMAPIPortfolioControllersDtoStatusEnumMap[
      cRMAPIPortfolioControllersDtoStatusEnum];
}

enums.CRMAPIPortfolioControllersDtoStatusEnum
    cRMAPIPortfolioControllersDtoStatusEnumFromJson(
  Object? cRMAPIPortfolioControllersDtoStatusEnum, [
  enums.CRMAPIPortfolioControllersDtoStatusEnum? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoStatusEnum is String) {
    return enums.$CRMAPIPortfolioControllersDtoStatusEnumMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIPortfolioControllersDtoStatusEnum.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIPortfolioControllersDtoStatusEnum
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIPortfolioControllersDtoStatusEnumMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIPortfolioControllersDtoStatusEnum.swaggerGeneratedUnknown;
}

List<String> cRMAPIPortfolioControllersDtoStatusEnumListToJson(
    List<enums.CRMAPIPortfolioControllersDtoStatusEnum>?
        cRMAPIPortfolioControllersDtoStatusEnum) {
  if (cRMAPIPortfolioControllersDtoStatusEnum == null) {
    return [];
  }

  return cRMAPIPortfolioControllersDtoStatusEnum
      .map((e) => enums.$CRMAPIPortfolioControllersDtoStatusEnumMap[e]!)
      .toList();
}

List<enums.CRMAPIPortfolioControllersDtoStatusEnum>
    cRMAPIPortfolioControllersDtoStatusEnumListFromJson(
  List? cRMAPIPortfolioControllersDtoStatusEnum, [
  List<enums.CRMAPIPortfolioControllersDtoStatusEnum>? defaultValue,
]) {
  if (cRMAPIPortfolioControllersDtoStatusEnum == null) {
    return defaultValue ?? [];
  }

  return cRMAPIPortfolioControllersDtoStatusEnum
      .map((e) => cRMAPIPortfolioControllersDtoStatusEnumFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoSortableColumnToJson(
    enums.CRMAPIProfilesDtoSortableColumn? cRMAPIProfilesDtoSortableColumn) {
  return enums
      .$CRMAPIProfilesDtoSortableColumnMap[cRMAPIProfilesDtoSortableColumn];
}

enums.CRMAPIProfilesDtoSortableColumn cRMAPIProfilesDtoSortableColumnFromJson(
  Object? cRMAPIProfilesDtoSortableColumn, [
  enums.CRMAPIProfilesDtoSortableColumn? defaultValue,
]) {
  if (cRMAPIProfilesDtoSortableColumn is String) {
    return enums.$CRMAPIProfilesDtoSortableColumnMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoSortableColumn.toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoSortableColumn.swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoSortableColumnMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoSortableColumn.swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoSortableColumnListToJson(
    List<enums.CRMAPIProfilesDtoSortableColumn>?
        cRMAPIProfilesDtoSortableColumn) {
  if (cRMAPIProfilesDtoSortableColumn == null) {
    return [];
  }

  return cRMAPIProfilesDtoSortableColumn
      .map((e) => enums.$CRMAPIProfilesDtoSortableColumnMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoSortableColumn>
    cRMAPIProfilesDtoSortableColumnListFromJson(
  List? cRMAPIProfilesDtoSortableColumn, [
  List<enums.CRMAPIProfilesDtoSortableColumn>? defaultValue,
]) {
  if (cRMAPIProfilesDtoSortableColumn == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoSortableColumn
      .map((e) => cRMAPIProfilesDtoSortableColumnFromJson(e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeToJson(
    enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType?
        cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType) {
  return enums.$CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeMap[
      cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType];
}

enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType
    cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeFromJson(
  Object? cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType, [
  enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType? defaultValue,
]) {
  if (cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType is String) {
    return enums
        .$CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeListToJson(
    List<enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType>?
        cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType) {
  if (cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType == null) {
    return [];
  }

  return cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType
      .map((e) =>
          enums.$CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType>
    cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeListFromJson(
  List? cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType, [
  List<enums.CRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyType
      .map((e) =>
          cRMAPIProfilesDtoSearchLifeAnnuityVacancyDtoVacancyTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeToJson(
    enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType?
        cRMAPIProfilesDtoConstructionYearDtoConstructionYearType) {
  return enums.$CRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeMap[
      cRMAPIProfilesDtoConstructionYearDtoConstructionYearType];
}

enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType
    cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeFromJson(
  Object? cRMAPIProfilesDtoConstructionYearDtoConstructionYearType, [
  enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType? defaultValue,
]) {
  if (cRMAPIProfilesDtoConstructionYearDtoConstructionYearType is String) {
    return enums
        .$CRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoConstructionYearDtoConstructionYearType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums
          .$CRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListToJson(
    List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
        cRMAPIProfilesDtoConstructionYearDtoConstructionYearType) {
  if (cRMAPIProfilesDtoConstructionYearDtoConstructionYearType == null) {
    return [];
  }

  return cRMAPIProfilesDtoConstructionYearDtoConstructionYearType
      .map((e) => enums
          .$CRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>
    cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeListFromJson(
  List? cRMAPIProfilesDtoConstructionYearDtoConstructionYearType, [
  List<enums.CRMAPIProfilesDtoConstructionYearDtoConstructionYearType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoConstructionYearDtoConstructionYearType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoConstructionYearDtoConstructionYearType
      .map((e) =>
          cRMAPIProfilesDtoConstructionYearDtoConstructionYearTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeToJson(
    enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
        cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType) {
  return enums.$CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeMap[
      cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType];
}

enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType
    cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeFromJson(
  Object? cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType, [
  enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType is String) {
    return enums
        .$CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeMap
        .entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums
                    .CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeMap
          .entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType
          .swaggerGeneratedUnknown;
}

List<String>
    cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeListToJson(
        List<enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType>?
            cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType) {
  if (cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType == null) {
    return [];
  }

  return cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType
      .map((e) => enums
          .$CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType>
    cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeListFromJson(
  List? cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType, [
  List<enums.CRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeType
      .map((e) =>
          cRMAPIProfilesDtoSearchPurchasePropertyAgeDtoPropertyAgeTypeFromJson(
              e.toString()))
      .toList();
}

String? cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeToJson(
    enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType?
        cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType) {
  return enums.$CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeMap[
      cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType];
}

enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType
    cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeFromJson(
  Object? cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType, [
  enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType? defaultValue,
]) {
  if (cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType is String) {
    return enums
        .$CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeMap.entries
        .firstWhere(
            (element) =>
                element.value.toLowerCase() ==
                cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType
                    .toLowerCase(),
            orElse: () => const MapEntry(
                enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType
                    .swaggerGeneratedUnknown,
                ''))
        .key;
  }

  final parsedResult = defaultValue == null
      ? null
      : enums.$CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeMap.entries
          .firstWhereOrNull((element) => element.value == defaultValue)
          ?.key;

  return parsedResult ??
      defaultValue ??
      enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType
          .swaggerGeneratedUnknown;
}

List<String> cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeListToJson(
    List<enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType>?
        cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType) {
  if (cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType == null) {
    return [];
  }

  return cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType
      .map((e) =>
          enums.$CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeMap[e]!)
      .toList();
}

List<enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType>
    cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeListFromJson(
  List? cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType, [
  List<enums.CRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType>?
      defaultValue,
]) {
  if (cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType == null) {
    return defaultValue ?? [];
  }

  return cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureType
      .map((e) =>
          cRMAPIProfilesDtoSearchRentalFurnitureDtoFurnitureTypeFromJson(
              e.toString()))
      .toList();
}

typedef $JsonFactory<T> = T Function(Map<String, dynamic> json);

class $CustomJsonDecoder {
  $CustomJsonDecoder(this.factories);

  final Map<Type, $JsonFactory> factories;

  dynamic decode<T>(dynamic entity) {
    if (entity is Iterable) {
      return _decodeList<T>(entity);
    }

    if (entity is T) {
      return entity;
    }

    if (isTypeOf<T, Map>()) {
      return entity;
    }

    if (isTypeOf<T, Iterable>()) {
      return entity;
    }

    if (entity is Map<String, dynamic>) {
      return _decodeMap<T>(entity);
    }

    return entity;
  }

  T _decodeMap<T>(Map<String, dynamic> values) {
    final jsonFactory = factories[T];
    if (jsonFactory == null || jsonFactory is! $JsonFactory<T>) {
      return throw "Could not find factory for type $T. Is '$T: $T.fromJsonFactory' included in the CustomJsonDecoder instance creation in bootstrapper.dart?";
    }

    return jsonFactory(values);
  }

  List<T> _decodeList<T>(Iterable values) =>
      values.where((v) => v != null).map<T>((v) => decode<T>(v) as T).toList();
}

class $JsonSerializableConverter extends chopper.JsonConverter {
  @override
  chopper.Response<ResultType> convertResponse<ResultType, Item>(
      chopper.Response response) {
    if (response.bodyString.isEmpty) {
      // In rare cases, when let's say 204 (no content) is returned -
      // we cannot decode the missing json with the result type specified
      return chopper.Response(response.base, null, error: response.error);
    }

    final jsonRes = super.convertResponse(response);
    return jsonRes.copyWith<ResultType>(
        body: $jsonDecoder.decode<Item>(jsonRes.body) as ResultType);
  }
}

final $jsonDecoder = $CustomJsonDecoder(generatedMapping);

// ignore: unused_element
String? _dateToJson(DateTime? date) {
  if (date == null) {
    return null;
  }

  final year = date.year.toString();
  final month = date.month < 10 ? '0${date.month}' : date.month.toString();
  final day = date.day < 10 ? '0${date.day}' : date.day.toString();

  return '$year-$month-$day';
}
